// AutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "AutDlg.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;
extern CAutDlg *AutDlg;

/////////////////////////////////////////////////////////////////////////////
// CAutDlg dialog


CAutDlg::CAutDlg(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CAutDlg)
	m_mins = 0;
	m_remove = FALSE;
	m_rescan = FALSE;
	m_sort = FALSE;
	m_every = FALSE;
	m_onstart = FALSE;
	m_removedup = FALSE;
	m_saveset = FALSE;
	//}}AFX_DATA_INIT
}


void CAutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAutDlg)
	DDX_Control(pDX, IDC_SPIN, m_spin);
	DDX_Control(pDX, IDC_FOLDERS, m_folders);
	DDX_Text(pDX, IDC_MIN, m_mins);
	DDX_Check(pDX, IDC_REMOVE, m_remove);
	DDX_Check(pDX, IDC_RESCAN, m_rescan);
	DDX_Check(pDX, IDC_SORT, m_sort);
	DDX_Check(pDX, IDC_EVERY, m_every);
	DDX_Check(pDX, IDC_ONSTART, m_onstart);
	DDX_Check(pDX, IDC_REMOVEDUP, m_removedup);
	DDX_Check(pDX, IDC_SAVESET, m_saveset);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAutDlg, CDialog)
	//{{AFX_MSG_MAP(CAutDlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutDlg message handlers

void CAutDlg::OnAdd() 
{
	LPMALLOC pMalloc;
	if (SHGetMalloc (&pMalloc)!= NOERROR)
	{
		return;
	}

	BROWSEINFO bi;
	char buf[MAX_PATH];

	CString title;
	title=MyLoadString(IDS_OPENFOLDER);

	bi.hwndOwner=m_hWnd;
	bi.pszDisplayName=buf;
	bi.pidlRoot=NULL;
	bi.lpszTitle=LPCTSTR(title);
	bi.ulFlags=BIF_RETURNONLYFSDIRS;
	bi.lpfn=NULL;

	LPITEMIDLIST pidl;
	if((pidl=SHBrowseForFolder(&bi))==NULL)
	{
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	if(SHGetPathFromIDList(pidl,buf)==false)
	{	
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	pMalloc->Free(pidl);
	pMalloc->Release();

	CString theDir=buf;
	if(theDir[theDir.GetLength()-1]!='\\')
		theDir+="\\";
	m_folders.AddString(theDir);
}

void CAutDlg::OnDel() 
{
	if(m_folders.GetCurSel()!=LB_ERR)
		m_folders.DeleteString(m_folders.GetCurSel());
}

BOOL CAutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_spin.SetRange(1,60);

	m_folders.SetHorizontalExtent(500);

	m_mins=pMainFrame->AutPeriod;
	m_remove=pMainFrame->AutRemove;
	m_removedup=pMainFrame->AutRemovedup;
	m_rescan=pMainFrame->AutRescan;
	m_sort=pMainFrame->AutSort;
	m_onstart=pMainFrame->AutOnStart;
	m_every=pMainFrame->AutEvery;
	m_saveset=pMainFrame->AutSaveset;

	m_mins=pMainFrame->AutPeriod;

	for(int i=0;i<pMainFrame->AutDirs.GetSize();i++)
		m_folders.AddString(pMainFrame->AutDirs[i]);

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAutDlg::OnOK() 
{
	UpdateData(TRUE);

	bool UpdTimerFlag=(pMainFrame->AutPeriod!=m_mins);

	pMainFrame->AutPeriod=m_mins?1:0;
	pMainFrame->AutRemove=m_remove?1:0;
	pMainFrame->AutRemovedup=m_removedup?1:0;
	pMainFrame->AutRescan=m_rescan?1:0;
	pMainFrame->AutSort=m_sort?1:0;
	pMainFrame->AutPeriod=m_mins;
	pMainFrame->AutOnStart=m_onstart?1:0;
	pMainFrame->AutEvery=m_every?1:0;
	pMainFrame->AutSaveset=m_saveset?1:0;

	CString buf;
	pMainFrame->AutDirs.RemoveAll();

	for(int i=0;i<m_folders.GetCount();i++)
	{
		m_folders.GetText(i,buf);
		pMainFrame->AutDirs.Add(buf);
	}
	
	if(UpdTimerFlag)
	{
		pMainFrame->KillTimer(30);
		pMainFrame->SetTimer(30,pMainFrame->AutPeriod*60000,NULL);
	}

	DestroyWindow();
	AutDlg=NULL;	
}

void CAutDlg::OnCancel() 
{
	DestroyWindow();
	AutDlg=NULL;	
}

void CAutDlg::OnClose() 
{
	DestroyWindow();
	AutDlg=NULL;		
}
