#ifndef ARGS_H
#define ARGS_H

#include "common.h"
#include "main.h"
#include <windows.h>

struct al_table 
{
 short bits;
 short d;
};

class MPArgs {
public:
    unsigned long CurrentPos;   // Current player position in frames
//    unsigned long StartFrame, StartPos,
//                            EndFrame, EndPos;
    unsigned long SampleRate;   // Samplerate
    unsigned long BufferSize;   // The size of the output buffer
    unsigned long Buffers;      // The number of buffers 
	int InpBufFrames;			// Number of frames for input buffering
    long Channels;              // Channels(1=mono;2=stereo)
    long AudioBits;             // Bits per sample(ex. 16 bit)
    long AudioDevice;           // The audio device number which should be opened
    long AudioMode;             // Audio type(ex. 16bit signed),currently not used  
    long ScaleFactor;           // Output scale factor(ex. 32768 which is normal)
    bool Seekable;              // Is the stream seekable?
    char *InName;               // Input stream filename 
    char *OutName;              // Output filename for wave output
    long OutDeviceNum;          // Device number for MMSystem output
    long ForceMono;             // Force mono output?
    long DownSample;            // Downsample Modes
    long UseEqualizer;          // Activate equalizer? 
    long PlayPriority;          // Play thread priority
    void *Player;
    void *Decoder;
    esInputMode  InputMode;    
    esOutputMode OutputMode;

    HWND wnd;

    MPArgs() {
        InName = NULL;
        OutName= NULL;
        OutDeviceNum = 0;
        CurrentPos = 0;
//        StartPos = 0;
//        EndPos = 0;
        // No downsampling
        DownSample = 0;
        // Force Stereo output
        AudioBits = 16;
        SampleRate = 44100;
        Channels = 2;
        AudioMode = 1;
        AudioDevice = WAVE_MAPPER;
        BufferSize = 16384;
        Buffers = 8;
		InpBufFrames = 100;
        Seekable    = true;
        ForceMono   = 0;
        ScaleFactor = 32768;
        UseEqualizer= false;
        PlayPriority= THREAD_PRIORITY_NORMAL;
        wnd         = NULL;
    }

    ~MPArgs() {
        if (InName) free(InName);
        if (OutName) free(OutName);
    }
};

typedef int (*synthProc)(real *, int, unsigned char *, int *);
typedef int (*synth_monoProc)(real *, unsigned char *, int *);

struct frame {
    synthProc synth;
    synth_monoProc synth_mono;

	int framesize;

    long stereo;
    long jsbound;
    long single;
    long II_sblimit;
    long lsf;
    long mpeg25;
    unsigned long block_size;
    long lay;
    long error_protection;
    long bitrate_index;
    long sampling_frequency;
    long padding;
    long extension;
    long mode;
    long mode_ext;
    long copyright;
    long original;
    long emphasis;    
};

extern MPArgs *Args;
extern struct frame fr;

#endif
