#ifndef PLAYER_H
#define PLAYER_H

#include "common.h"
#include "main.h"
#include "args.h"
#include "decoder.h"

// Maximum frame size
#define MAXFRAMESIZE 1792

#define MPG_MD_STEREO           0
#define MPG_MD_JOINT_STEREO     1
#define MPG_MD_DUAL_CHANNEL     2
#define MPG_MD_MONO             3

extern LPCTSTR NameString;
extern LPCTSTR ExtsString;

class MPPlayer;

class MPPlayer {
public:
    esPlayerMode FPlayerMode;   

    HANDLE StopEvent;
    bool PauseFlag;

    bool ThreadSync, UserBreak;

    MPPlayer();
    ~MPPlayer();

    void SetInName (const char *FileName);
    void SetOutName(const char *FileName);
    void SetOutMode(esOutputMode OutMode);
    bool InitStream();
    void Play();
    void Pause();
    void Resume();
    void Close();
    unsigned long GetPos();
    unsigned long GetSize();
    bool CanSetPos();
    void SetPos(int Percent);
    esPlayerMode PlayerMode();
    void SetPriority(long Priority);
    void SetWindow(HWND Wnd);
};

#endif