#include "common.h"
#include <io.h>
#include <fcntl.h>
#include <windows.h>
#include <wininet.h>
#include <tchar.h>
#include "stream.h"
#include "args.h"
#include "player.h"

extern HINTERNET m_hInternetSession;
extern void InitInetSession();

extern bool FirstBuf;

/*--------------------XING STUFF-----------------------------*/
unsigned char TOC[100];
int xingframes,xingbytes;
int xingheader;

#define FRAMES_FLAG     0x0001
#define BYTES_FLAG      0x0002
#define TOC_FLAG        0x0004
#define VBR_SCALE_FLAG  0x0008

static int ExtractI4(unsigned char *buf)
{
int x;
// big endian extract

x = buf[0];
x <<= 8;
x |= buf[1];
x <<= 8;
x |= buf[2];
x <<= 8;
x |= buf[3];

return x;
}
/*-------------------------------------------------------------*/
bool GetXingHeader(unsigned char *buf)
{

if( buf[0] != 'X' ) return false;    // fail
if( buf[1] != 'i' ) return false;    // header not found
if( buf[2] != 'n' ) return false;
if( buf[3] != 'g' ) return false;
buf+=4;

int i, head_flags;
// get Xing header data

head_flags = ExtractI4(buf); buf+=4;      // get flags

if( head_flags & FRAMES_FLAG ) {xingframes=ExtractI4(buf); buf+=4;}
if( head_flags & BYTES_FLAG )  {xingbytes=ExtractI4(buf); buf+=4;}

if( head_flags & TOC_FLAG ) {
    for(i=0;i<100;i++) TOC[i] = buf[i];
    buf+=100;
}

return true;       // success
}
/*-------------------------------------------------------------*/
int SeekPoint(unsigned char TOC[100], int file_bytes, float percent)
{
// interpolate in TOC to get file seek point in bytes
int a, seekpoint;
float fa, fb, fx;


if( percent < 0.0f )   percent = 0.0f;
if( percent > 100.0f ) percent = 100.0f;

a = (int)percent;
if( a > 99 ) a = 99;
fa = TOC[a];
if( a < 99 ) {
    fb = TOC[a+1];
}
else {
    fb = 256.0f;
}


fx = fa + (fb-fa)*(percent-a);

seekpoint = (int)((1.0f/256.0f)*fx*file_bytes); 


return seekpoint;
}
/*-------------------------------------------------------------*/


// Bitrate index,in order: MPEG version,layer,bitrate index 
const int BitRateIndex[2][3][16]=
{{{0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,},
{0,32,48,56,64,80,96,112,128,160,192,224,256,320,384,},
{0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,}},
{{0,32,48,56,64,80,96,112,128,144,160,176,192,224,256,},
{0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,},
{0,8,16,24,32,40,48,56,64,80,96,112,128,144,160}}};

const long freqs[9] = { 44100, 48000, 32000, 22050, 24000, 16000 , 11025 , 12000 , 8000 };

struct ibuf 
{
    struct ibuf *next;
    struct ibuf *prev;
    unsigned char *buf;
    unsigned char *pnt;
    int len;
};

struct ibuf ibufs[2];
struct ibuf *cibuf;
unsigned char bsspace[2][MAXFRAMESIZE+512], *bsbuf=bsspace[1], *bsbufold;
static HGLOBAL MBHnd;

//#define IBFRAMES 100
struct frame *frames;
unsigned char *bodies;
BOOL *results;

int bitindex;
unsigned char *wordpointer;
HANDLE StreamHandle;
unsigned long StreamSize;
int ibufnum, fsize, fsizeold, ssize, bsnum;
unsigned long oldhead, firsthead;
esInputMode InputMode;

bool StreamInit = false;

bool Init_Stream(){
	xingheader=0;
    StreamSize = 0; 
    SECURITY_ATTRIBUTES Sec;
    // Set the security attributes 
    Sec.nLength = sizeof(SECURITY_ATTRIBUTES);
    Sec.lpSecurityDescriptor = false;
    Sec.bInheritHandle = false;
    InputMode = Args->InputMode;
    // Open the stream using CreateFile
	if(InputMode==imFile)
		StreamHandle = CreateFile(Args->InName, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE,&Sec, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS, NULL);
	else
	{
		if(m_hInternetSession==NULL)
			InitInetSession();
		StreamHandle=::InternetOpenUrl(m_hInternetSession,Args->InName,NULL,0,0,0);
	}
    if(StreamHandle == INVALID_HANDLE_VALUE || StreamHandle == NULL) 
    { 
        throw 1;        
    };

	Args->Seekable=false;
	StreamSize=0;
	if(InputMode==imFile)
	{
		StreamSize = GetFileSize(StreamHandle, NULL);
		Args->Seekable=true;
	}
	else
	{
	if((Args->InName[0]=='h'||Args->InName[0]=='H')&&
	   (Args->InName[1]=='t'||Args->InName[1]=='T')&&
	   (Args->InName[2]=='t'||Args->InName[2]=='T')&&
	   (Args->InName[3]=='p'||Args->InName[3]=='P')&&
	   Args->InName[4]==':'&&
	   Args->InName[5]=='/'&&
	   Args->InName[6]=='/')
		{
			TCHAR szContentLength[32];
			DWORD dwInfoSize = 32;
			if (::HttpQueryInfo(StreamHandle, HTTP_QUERY_CONTENT_LENGTH, szContentLength, &dwInfoSize, NULL))
				StreamSize = (unsigned long) _ttol(szContentLength);
			Args->Seekable=true;
		}
	}

    // Set "stream is open" flag
	if(InputMode==imFile)
	{
		if (SetFilePointer(StreamHandle, 0, 0, FILE_BEGIN) == 0xFFFFFFFF) {
			throw 1;
		}
	} else
	{
		if(InternetSetFilePointer(StreamHandle, 0, NULL, 0, FILE_BEGIN) == 0xFFFFFFFF)
			Args->Seekable=false;
	}
    // Global initializations
    ibufnum=0;fsize=0;fsizeold=0;bsnum=0;oldhead=0;firsthead=0;

    StreamInit = true;    
    return true;
}

static void GetLayer2(struct frame *pfr){ 
    static int Translate[3][2][16]= 
    {{{0,2,2,2,2,2,2,0,0,0,1,1,1,1,1,0},
    {0,2,2,0,0,0,1,1,1,1,1,1,1,1,1,0}},
    {{0,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0},
    {0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0}},
    {{0,3,3,3,3,3,3,0,0,0,1,1,1,1,1,0},
    {0,3,3,0,0,0,1,1,1,1,1,1,1,1,1,0}}};
    
    int table,sblim;
    //static const struct al_table *tables[5]={alloc_0,alloc_1,alloc_2,alloc_3,alloc_4};
    static int sblims[5] = { 27 , 30 , 8, 12 , 30 };
    if(pfr->lsf) table=4;
    else table=Translate[pfr->sampling_frequency][2-pfr->stereo][pfr->bitrate_index];
    sblim=sblims[table];
    //fr.alloc=tables[table];
    pfr->II_sblimit=sblim;
}

int head_read(unsigned char *hbuf,unsigned long *newhead)
{
    long numread;
    BOOL res;
	if(InputMode==imFile)
	    res=ReadFile(StreamHandle, hbuf, 4, (DWORD *)&numread, NULL);
	else
		res=InternetReadFile(StreamHandle, hbuf, 4, (DWORD *)&numread);
      
    if(!res||numread!=4) return FALSE;
    *newhead=((unsigned long) hbuf[0] << 24) |
        ((unsigned long) hbuf[1] << 16) |
        ((unsigned long) hbuf[2] << 8)  |
        (unsigned long) hbuf[3];
    return TRUE;
}

static int decode_header(unsigned long newhead,struct frame *pfr)
{
    if( (newhead & 0xffe00000) != 0xffe00000)
	return FALSE;
    if(!((newhead>>17)&3))
	return FALSE;
    if( ((newhead>>12)&0xf) == 0xf)
	return FALSE;
    if( ((newhead>>10)&0x3) == 0x3 )
	return FALSE;
    if ((newhead & 0xffff0000) == 0xfffe0000)
      return FALSE;

    if( newhead & (1<<20) ) {
      pfr->lsf = (newhead & (1<<19)) ? 0x0 : 0x1;
      pfr->mpeg25 = 0;
    }
    else {
      pfr->lsf = 1;
      pfr->mpeg25 = 1;
    }
      
	pfr->lay = 4-((newhead>>17)&3);

	if (pfr->mpeg25) 
		pfr->sampling_frequency = 6 + ((newhead>>10)&0x3);
	else
		pfr->sampling_frequency = ((newhead>>10)&0x3) + (pfr->lsf*3);

    pfr->error_protection = ((newhead>>16)&0x1)^0x1;
	pfr->bitrate_index = ((newhead>>12)&0xf);
    pfr->padding   = ((newhead>>9)&0x1);
    pfr->extension = ((newhead>>8)&0x1);
    pfr->mode      = ((newhead>>6)&0x3);
    pfr->mode_ext  = ((newhead>>4)&0x3);
    pfr->copyright = ((newhead>>3)&0x1);
    pfr->original  = ((newhead>>2)&0x1);
    pfr->emphasis  = newhead & 0x3;

    pfr->stereo    = (pfr->mode == MPG_MD_MONO) ? 1 : 2;

	if(!pfr->bitrate_index)
	{
		oldhead = 0;
		return 0;
	}

    switch(pfr->lay)
    {
      case 1:
        pfr->jsbound = (pfr->mode == MPG_MD_JOINT_STEREO) ? 
                         (pfr->mode_ext<<2)+4 : 32;
        pfr->framesize = (long) BitRateIndex[pfr->lsf][0][pfr->bitrate_index] * 12000;
        pfr->framesize /= freqs[pfr->sampling_frequency];
        pfr->framesize = ((pfr->framesize+pfr->padding)<<2)-4;
        break;
      case 2:
        GetLayer2(pfr);
        pfr->jsbound = (pfr->mode == MPG_MD_JOINT_STEREO) ?
                         (pfr->mode_ext<<2)+4 : pfr->II_sblimit;
        pfr->framesize = (long) BitRateIndex[pfr->lsf][1][pfr->bitrate_index] * 144000;
        pfr->framesize /= freqs[pfr->sampling_frequency];
        pfr->framesize += pfr->padding - 4;
        break;
      case 3:
        if(pfr->lsf)
          ssize = (pfr->stereo == 1) ? 9 : 17;
        else
          ssize = (pfr->stereo == 1) ? 17 : 32;
        if (pfr->error_protection)
        {
          ssize += 2;
        }
        pfr->framesize =  (long) BitRateIndex[pfr->lsf][2][pfr->bitrate_index] * 144000;
        pfr->framesize /= freqs[pfr->sampling_frequency]<<(pfr->lsf);
        pfr->framesize = pfr->framesize + pfr->padding - 4;
        break; 
      default:
		oldhead = 0;
        return (0);
    }

	oldhead = newhead;
    return 1;
}

#define swap_int32(int_32) (((int_32) << 24) | (((int_32) << 8) & 0x00ff0000) | \
                                               (((int_32) >> 8) & 0x0000ff00) | ((int_32) >> 24))

int ReadFrame(struct frame *pfr)
{
    long numread=0;
    unsigned char hbuf[4];
    static unsigned long newhead;
    BOOL Res;

read_again:
    if(!head_read(hbuf, &newhead)) {
       return FALSE;
    }
    if(oldhead != newhead || !oldhead)
    {
        if(!decode_header(newhead, pfr)) 
		{
			if(!firsthead)
			{
				if(newhead == ('R'<<24)+('I'<<16)+('F'<<8)+'F')
				{
					if(InputMode==imFile)
					{
						if (SetFilePointer(StreamHandle, 66, 0, FILE_CURRENT) == 0xFFFFFFFF) 
						{
							return FALSE;
						}
					} else
					{
						if (InternetSetFilePointer(StreamHandle, 66, NULL, 0, FILE_CURRENT) == 0xFFFFFFFF) 
						{
							return FALSE;
						}
					}
					goto read_again;
				}
				if ((newhead & (('I'<<24)+('D'<<16)+('3'<<8))) == (('I'<<24)+('D'<<16)+('3'<<8))) 
				{
					if(InputMode==imFile)
					{
						if (SetFilePointer(StreamHandle, 2, 0, FILE_CURRENT) == 0xFFFFFFFF) 
						{
							return FALSE;
						}
					} else
					{
						if (InternetSetFilePointer(StreamHandle, 2, NULL, 0, FILE_CURRENT) == 0xFFFFFFFF) 
						{
							return FALSE;
						}
					}
					if(InputMode==imFile)
						Res=ReadFile(StreamHandle, hbuf, 4, (DWORD *)&numread, NULL);
					else
						Res=InternetReadFile(StreamHandle, hbuf, 4, (DWORD *)&numread);
      
					if(!Res||numread!=4) return FALSE;

					int
					id3v2size=(int)(hbuf[0]&0x7f)*0x200000+
							  (int)(hbuf[1]&0x7f)*0x4000+
							  (int)(hbuf[2]&0x7f)*0x80+
							  (int)(hbuf[3]&0x7f);
					if(InputMode==imFile)
					{
						if (SetFilePointer(StreamHandle, id3v2size, 0, FILE_CURRENT) == 0xFFFFFFFF) 
						{
							return FALSE;
						}
					} else
					{
						if (InternetSetFilePointer(StreamHandle, id3v2size, NULL, 0, FILE_CURRENT) == 0xFFFFFFFF) 
						{
							return FALSE;
						}
					}
					goto read_again;
				}
				for(int i=0;i<65536;i++) 
				{
					memmove(&hbuf[0],&hbuf[1],3);
					if(InputMode==imFile)
						Res = ReadFile(StreamHandle, hbuf+3, 1, (DWORD*) &numread, NULL);
					else
						Res = InternetReadFile(StreamHandle, hbuf+3, 1, (DWORD*) &numread);              
					if(Res&&numread==0) 
						return FALSE;
					if(!Res||numread!=1) 
						throw 1;
					newhead <<= 8;
					newhead |= hbuf[3];
					newhead &= 0xffffffff;
					if(decode_header(newhead, pfr)) break;
				}
				if(i==65536) 
					return FALSE;
				else
				{
					if(InputMode==imFile)
					{
						if (SetFilePointer(StreamHandle, pfr->framesize, 0, FILE_CURRENT) == 0xFFFFFFFF) 
							return FALSE;
					} else
					{
						if (InternetSetFilePointer(StreamHandle, pfr->framesize, NULL, 0, FILE_CURRENT) == 0xFFFFFFFF) 
							return FALSE;
					}
					goto read_again;
				}
			} else
			{
				for(int i=0;i<65536;i++) 
				{
					memmove(&hbuf[0],&hbuf[1],3);
					if(InputMode==imFile)
						Res = ReadFile(StreamHandle, hbuf+3, 1, (DWORD*) &numread, NULL);
					else
						Res = InternetReadFile(StreamHandle, hbuf+3, 1, (DWORD*) &numread);              
					if(Res&&numread==0) 
						return FALSE;
					if(!Res||numread!=1) 
						throw 1;
					newhead <<= 8;
					newhead |= hbuf[3];
					newhead &= 0xffffffff;
					if(decode_header(newhead, pfr)) break;
				}
				if(i==65536) 
					return FALSE;
				else
				{
					if(InputMode==imFile)
					{
						if (SetFilePointer(StreamHandle, pfr->framesize, 0, FILE_CURRENT) == 0xFFFFFFFF) 
							return FALSE;
					} else
					{
						if (InternetSetFilePointer(StreamHandle, pfr->framesize, NULL, 0, FILE_CURRENT) == 0xFFFFFFFF) 
							return FALSE;
					}
					goto read_again;
				}
			}
		}
		if(!firsthead)
			firsthead=newhead;
    }
    return TRUE;
}

int ReadFrameBody(struct frame *pfr, unsigned char *buf)
{
    long numread=0;
    BOOL Res;
 
	if(InputMode==imFile)
		Res = ReadFile(StreamHandle, buf, pfr->framesize, (DWORD*) &numread, NULL);
	else
		Res = InternetReadFile(StreamHandle, buf,pfr->framesize, (DWORD*) &numread);
    
    if(Res&&numread==0) 
        return 0;
    if(!Res||numread != pfr->framesize) {
        memset(buf+numread,0,pfr->framesize-numread);
    } 

	if(xingheader==0)
	{
		if(pfr->lay==3&&GetXingHeader(buf+ssize)) xingheader=1;
		else xingheader=2;
	}

	return 1;
}

real Frame2ms()
{
	return (real)8*(real)(fr.framesize+5-fr.padding)/(real)BitRateIndex[fr.lsf][fr.lay-1][fr.bitrate_index];
}

real Totalms()
{
    return((StreamSize/(fr.framesize+5-fr.padding))*Frame2ms());
}

unsigned long Currentms()
{
    return(Args->CurrentPos*Frame2ms());
}

bool Seek_Stream(int Percent)
{
    if(Percent>99) return false;
	
	unsigned long Posi;
    unsigned long XPosi;

	if(xingheader!=1)
	{
		Posi=(StreamSize/(fr.framesize+5-fr.padding))*Percent/100;
		XPosi =  fr.framesize*Posi;
	} else
	{
		Posi=xingframes*Percent/100;
		XPosi=SeekPoint(TOC,xingbytes,Percent);
	}
	
	if(InputMode==imFile)
	{
		if (SetFilePointer(StreamHandle, XPosi, 0, FILE_BEGIN) == 0xFFFFFFFF) 
			return false;
	} else
	{
		if (InternetSetFilePointer(StreamHandle, XPosi, NULL, 0, FILE_BEGIN) == 0xFFFFFFFF) 
			return false;
	}
	if(XPosi==0) firsthead=0;
	
	Args->CurrentPos=Posi;

	if(Args->CurrentPos%Args->InpBufFrames!=0)
		FillInputBuffer(Args->CurrentPos%Args->InpBufFrames);
	FirstBuf=true;
    return true;
}

void Reset_Stream()
{
	if(InputMode==imFile)
	{
		if (SetFilePointer(StreamHandle, 0, 0, FILE_BEGIN) == 0xFFFFFFFF) 
			return;
	} else
	{
		if (InternetSetFilePointer(StreamHandle, 0, NULL, 0, FILE_BEGIN) == 0xFFFFFFFF) 
			return;
	}
    ibufnum=0; fsize=0; fsizeold=0; oldhead=0;firsthead=0; bitindex = 0; ssize = 0;

	bsbuf=bsspace[1];
    bsnum = 0;
    
    Args->CurrentPos=0;
}

unsigned long GetBits(int number_of_bits)
{
    unsigned long rval;
    if(!number_of_bits) return 0;
    {
        rval = wordpointer[0];
        rval <<= 8;
        rval |= wordpointer[1];
        rval <<= 8;
        rval |= wordpointer[2];
        rval <<= bitindex;
        rval &= 0xffffff;
        bitindex += number_of_bits;
        rval >>= (24-number_of_bits);
        wordpointer += (bitindex>>3);
        bitindex &= 7;
    }
    return rval;
}

unsigned long GetBitsFast(int number_of_bits)
{
    unsigned long rval;
    {
        rval = wordpointer[0];
        rval <<= 8;     
        rval |= wordpointer[1];
        rval <<= bitindex;
        rval &= 0xffff;
        bitindex += number_of_bits;
        rval >>= (16-number_of_bits);
        wordpointer += (bitindex>>3);
        bitindex &= 7;
    }
    return rval;
}

unsigned long Get1Bit(void)
{
    unsigned char rval;
    rval = *wordpointer << bitindex;
    bitindex++;
    wordpointer += (bitindex>>3);
    bitindex &= 7;
    return rval>>7;
}

void SetPointer(long backstep)
{
    wordpointer=bsbuf+ssize-backstep;
    if(backstep) 
        memmove(wordpointer,bsbufold+fsizeold-backstep,backstep);
    bitindex=0; 
}

bool Done_Stream()
{
	if(InputMode==imFile)
	{
		if (StreamInit) CloseHandle(StreamHandle);
	}
	else
	{
		if (StreamInit) InternetCloseHandle(StreamHandle);
	}
    StreamInit = false;
    return true;
}

bool InitInputBuffer()
{
	frames=(struct frame*)malloc(Args->InpBufFrames*sizeof(struct frame));
	if(!frames) return false;
	bodies=(unsigned char*)malloc(Args->InpBufFrames*sizeof(unsigned char)*MAXFRAMESIZE);
	if(!bodies) return false;
	results=(BOOL*)malloc(Args->InpBufFrames*sizeof(BOOL));
	if(!results) return false;

	return true;
}

void FreeInputBuffer()
{
	if(frames) free(frames);
	if(bodies) free(bodies);
	if(results) free(results);
}

void FillInputBuffer(int from)
{
	int rm=Args->CurrentPos%Args->InpBufFrames;
	if(rm==from)
	{
		for(int i=from;i<Args->InpBufFrames;i++)
		{
			if(!(results[i]=ReadFrame(&fr))) break;
			frames[i]=fr;
			if(!(results[i]=ReadFrameBody(&fr,bodies+i*MAXFRAMESIZE))) break;
		}
	}
}

BOOL GetNextFrame()
{
	int rm=Args->CurrentPos%Args->InpBufFrames;

    if (results[rm]) 
	{    
		fr=frames[rm];

		fsizeold = fsize;
		fsize = fr.framesize;

		bsbufold = bsbuf;        
		if (bsnum == 1)
		{
			bsbuf = bsspace[1] + 512;
			bsnum = 0;
		}
		else
		{
			bsbuf = bsspace[0] + 512;
			bsnum = 1;
		}

		memcpy(bsbuf,bodies+rm*MAXFRAMESIZE,fr.framesize);

		bitindex=0;
		wordpointer =(unsigned char *)bsbuf;
	}
	return results[rm];
}

int GetBitrate(int lsf,int lay,int bi)
{
	return BitRateIndex[lsf][lay-1][bi];
}