// EqualizerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "MainWnd.h"
#include "EqualizerDlg.h"
#include "SeekDialog.h"
#include "PRName.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;
extern CEqualizerDlg *EqualizerDlg;
extern CSeekDialog *SeekDialog;

extern CSysTrayPlayApp theApp;

BEGIN_MESSAGE_MAP(CMyEQBar,CProgressCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND( )
END_MESSAGE_MAP()

CMyEQBar::CMyEQBar():
	CProgressCtrl()
{
	MemDCCreated=false;
}


/////////////////////////////////////////////////////////////////////////////
// CEqualizerDlg dialog


CEqualizerDlg::CEqualizerDlg(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CEqualizerDlg)
	//}}AFX_DATA_INIT
}


void CEqualizerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEqualizerDlg)
	DDX_Control(pDX, IDC_SAVE, m_savebutton);
	DDX_Control(pDX, IDC_COMBO_PRESET, m_presetcombo);
	DDX_Control(pDX, IDC_ENABLE_EQ_CHECKBOX, m_EnableEQCheckBox);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_PREAMP, m_Preamp);
	DDX_Control(pDX, IDC_SLIDER10, m_Slider10);
	DDX_Control(pDX, IDC_SLIDER9, m_Slider9);
	DDX_Control(pDX, IDC_SLIDER8, m_Slider8);
	DDX_Control(pDX, IDC_SLIDER7, m_Slider7);
	DDX_Control(pDX, IDC_SLIDER6, m_Slider6);
	DDX_Control(pDX, IDC_SLIDER5, m_Slider5);
	DDX_Control(pDX, IDC_SLIDER4, m_Slider4);
	DDX_Control(pDX, IDC_SLIDER3, m_Slider3);
	DDX_Control(pDX, IDC_SLIDER2, m_Slider2);
	DDX_Control(pDX, IDC_SLIDER1, m_Slider1);
}


BEGIN_MESSAGE_MAP(CEqualizerDlg, CDialog)
	//{{AFX_MSG_MAP(CEqualizerDlg)
	ON_BN_CLICKED(IDC_ENABLE_EQ_CHECKBOX, OnEnableEqCheckbox)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_COMBO_PRESET, OnSelchangeComboPreset)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	//}}AFX_MSG_MAP
	ON_WM_SYSCOMMAND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEqualizerDlg message handlers

BOOL CEqualizerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	SetIcon(pMainFrame->StpIcon, TRUE);
	SetIcon(pMainFrame->StpIconSm, FALSE);

	CRect rect1,rect2;
	::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	GetWindowRect(&rect2);
	if(pMainFrame->EqualizerX==-1000)
		pMainFrame->EqualizerX=(rect1.right-(rect2.right-rect2.left))/2;
	if(pMainFrame->EqualizerY==-1000)
		pMainFrame->EqualizerY=(rect1.bottom-(rect2.bottom-rect2.top))/2;
	if(pMainFrame->EqualizerX<0)
		pMainFrame->EqualizerX=0;
	if(pMainFrame->EqualizerY<0)
		pMainFrame->EqualizerY=0;
	if(pMainFrame->EqualizerX+(rect2.right-rect2.left)>rect1.right)
		pMainFrame->EqualizerX=rect1.right-(rect2.right-rect2.left);
	if(pMainFrame->EqualizerY+(rect2.bottom-rect2.top)>rect1.bottom)
		pMainFrame->EqualizerY=rect1.bottom-(rect2.bottom-rect2.top);
	SetWindowPos(NULL,pMainFrame->EqualizerX,pMainFrame->EqualizerY,0,0,SWP_NOSIZE | SWP_NOZORDER|SWP_NOACTIVATE);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, 9999, MyLoadString(IDS_ALWAYSONTOP));
	}
	if(pMainFrame->EQOnTop==1)
	{
		pSysMenu->CheckMenuItem(9999,MF_BYCOMMAND | MF_CHECKED);
		SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
	} else
	{
		ModifyStyleEx(0,WS_EX_APPWINDOW);
	}

    // set the range for the sliders
    m_Preamp.SetRange(0,20);
	m_Slider1.SetRange(0,20);
    m_Slider2.SetRange(0,20);
    m_Slider3.SetRange(0,20);
    m_Slider4.SetRange(0,20);
    m_Slider5.SetRange(0,20);
    m_Slider6.SetRange(0,20);
    m_Slider7.SetRange(0,20);
    m_Slider8.SetRange(0,20);
    m_Slider9.SetRange(0,20);
    m_Slider10.SetRange(0,20);

	m_EnableEQCheckBox.SetCheck(pMainFrame->m_EEQ);
    // set the initial position for the sliders
	m_Preamp.SetPos(pMainFrame->m_preamp+10);
    m_Slider1.SetPos(pMainFrame->m_s1+10);
    m_Slider2.SetPos(pMainFrame->m_s2+10);
    m_Slider3.SetPos(pMainFrame->m_s3+10);
    m_Slider4.SetPos(pMainFrame->m_s4+10);
    m_Slider5.SetPos(pMainFrame->m_s5+10);
    m_Slider6.SetPos(pMainFrame->m_s6+10);
    m_Slider7.SetPos(pMainFrame->m_s7+10);
    m_Slider8.SetPos(pMainFrame->m_s8+10);
    m_Slider9.SetPos(pMainFrame->m_s9+10);
    m_Slider10.SetPos(pMainFrame->m_s10+10);

	for(int i=0;i<pMainFrame->presets.GetSize();i++)
	{
		m_presetcombo.AddString(pMainFrame->presets[i].Left(pMainFrame->presets[i].Find('\t')));
	}
	
	m_presetcombo.SetCurSel(pMainFrame->EQPreset);

	OnSelchangeComboPreset();

    return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEqualizerDlg::UpdateValues()
{
	double eq[32];

	pMainFrame->m_EEQ=m_EnableEQCheckBox.GetCheck();

	pMainFrame->m_preamp=m_Preamp.GetPos()-10;
	pMainFrame->m_s1=m_Slider1.GetPos()-10;
	pMainFrame->m_s2=m_Slider2.GetPos()-10;
	pMainFrame->m_s3=m_Slider3.GetPos()-10;
	pMainFrame->m_s4=m_Slider4.GetPos()-10;
	pMainFrame->m_s5=m_Slider5.GetPos()-10;
	pMainFrame->m_s6=m_Slider6.GetPos()-10;
	pMainFrame->m_s7=m_Slider7.GetPos()-10;
	pMainFrame->m_s8=m_Slider8.GetPos()-10;
	pMainFrame->m_s9=m_Slider9.GetPos()-10;
	pMainFrame->m_s10=m_Slider10.GetPos()-10;

    if (m_EnableEQCheckBox.GetCheck() == FALSE) {
        // unset the equalizer
		Args->UseEqualizer = FALSE;
        return;
    }
	Args->UseEqualizer = TRUE;

    // compute channel bands;

    eq[ 0] = pMainFrame->m_s1;
    eq[ 1] = pMainFrame->m_s2;
    eq[ 2] = pMainFrame->m_s3;
    eq[ 3] = pMainFrame->m_s4;
    eq[ 4] = pMainFrame->m_s5;
    eq[ 5] = pMainFrame->m_s6;
    eq[ 6] = pMainFrame->m_s7;
    eq[ 7] = pMainFrame->m_s7;
    eq[ 8] = pMainFrame->m_s8;
    eq[ 9] = pMainFrame->m_s8;
    eq[10] = pMainFrame->m_s8;
    eq[11] = pMainFrame->m_s8;
    eq[12] = pMainFrame->m_s9;
    eq[13] = pMainFrame->m_s9;
    eq[14] = pMainFrame->m_s9;
    eq[15] = pMainFrame->m_s9;
    eq[16] = pMainFrame->m_s9;
    eq[17] = pMainFrame->m_s9;
    eq[18] = pMainFrame->m_s9;
    eq[19] = pMainFrame->m_s9;
    eq[20] = pMainFrame->m_s10;
    eq[21] = pMainFrame->m_s10;
    eq[22] = pMainFrame->m_s10;
    eq[23] = pMainFrame->m_s10;
    eq[24] = pMainFrame->m_s10;
    eq[25] = pMainFrame->m_s10;
    eq[26] = pMainFrame->m_s10;
    eq[27] = pMainFrame->m_s10;
    eq[28] = pMainFrame->m_s10;
    eq[29] = pMainFrame->m_s10;
    eq[30] = pMainFrame->m_s10;
    eq[31] = pMainFrame->m_s10;

	for(int i = 0; i < 32; i++)
	{
		equalizer[i] =
			(1+eq[i]*.05)*(1+eq[i]*.05)*(1+pMainFrame->m_preamp*.05)*(1+pMainFrame->m_preamp*.05);
	}
}

void CEqualizerDlg::OnEnableEqCheckbox() 
{
    UpdateValues();	
}

void CEqualizerDlg::OnButtonReset() 
{
	m_Preamp.SetPos(10);
	m_Slider1.SetPos(10);	
	m_Slider2.SetPos(10);	
	m_Slider3.SetPos(10);	
	m_Slider4.SetPos(10);	
	m_Slider5.SetPos(10);	
	m_Slider6.SetPos(10);	
	m_Slider7.SetPos(10);	
	m_Slider8.SetPos(10);	
	m_Slider9.SetPos(10);	
	m_Slider10.SetPos(10);	
	UpdateValues();
	m_presetcombo.SetCurSel(pMainFrame->EQPreset=-1);
}

void CEqualizerDlg::OnClose() 
{
	SaveWindowPosAndDestroy();
}

void CEqualizerDlg::OnCancel() 
{
	SaveWindowPosAndDestroy();
}

void CEqualizerDlg::OnSelchangeComboPreset() 
{
	if(m_presetcombo.GetCurSel()==CB_ERR) return;
	pMainFrame->EQPreset=m_presetcombo.GetCurSel();
	CString buf;
	m_presetcombo.GetLBText(pMainFrame->EQPreset,buf);
	for(int i=0;i<pMainFrame->presets.GetSize();i++)
	{
		if(buf==pMainFrame->presets[i].Left(pMainFrame->presets[i].Find('\t')))
		{
			buf=pMainFrame->presets[i].Mid(pMainFrame->presets[i].Find('\t')+1);
			break;
		}
	}

	m_Preamp.SetPos((int)buf[0]-'a');
	m_Slider1.SetPos((int)buf[1]-'a');	
	m_Slider2.SetPos((int)buf[2]-'a');	
	m_Slider3.SetPos((int)buf[3]-'a');	
	m_Slider4.SetPos((int)buf[4]-'a');	
	m_Slider5.SetPos((int)buf[5]-'a');	
	m_Slider6.SetPos((int)buf[6]-'a');	
	m_Slider7.SetPos((int)buf[7]-'a');	
	m_Slider8.SetPos((int)buf[8]-'a');	
	m_Slider9.SetPos((int)buf[9]-'a');	
	m_Slider10.SetPos((int)buf[10]-'a');	

	UpdateValues();
}

void CEqualizerDlg::OnSave() 
{
	CPrName dlg(IDD_PRNAMER);
	if(dlg.DoModal()==IDOK)
	{
		for(int i=0;i<pMainFrame->presets.GetSize();i++)
		{
			if(dlg.m_prname==pMainFrame->presets[i].Left(pMainFrame->presets[i].Find('\t')))
			{
				pMainFrame->presets[i]=dlg.m_prname+"\t";
				pMainFrame->presets[i]+=(char)(m_Preamp.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider1.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider2.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider3.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider4.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider5.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider6.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider7.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider8.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider9.GetPos())+'a';
				pMainFrame->presets[i]+=(char)(m_Slider10.GetPos())+'a';
				m_presetcombo.SetCurSel(pMainFrame->EQPreset=m_presetcombo.FindStringExact(-1,dlg.m_prname));
				return;
			}
		}
		CString buf=dlg.m_prname+"\t";
		buf+=(char)(m_Preamp.GetPos())+'a';
		buf+=(char)(m_Slider1.GetPos())+'a';
		buf+=(char)(m_Slider2.GetPos())+'a';
		buf+=(char)(m_Slider3.GetPos())+'a';
		buf+=(char)(m_Slider4.GetPos())+'a';
		buf+=(char)(m_Slider5.GetPos())+'a';
		buf+=(char)(m_Slider6.GetPos())+'a';
		buf+=(char)(m_Slider7.GetPos())+'a';
		buf+=(char)(m_Slider8.GetPos())+'a';
		buf+=(char)(m_Slider9.GetPos())+'a';
		buf+=(char)(m_Slider10.GetPos())+'a';
		pMainFrame->presets.Add(buf);
		m_presetcombo.AddString(dlg.m_prname);
		m_presetcombo.SetCurSel(pMainFrame->EQPreset=m_presetcombo.FindStringExact(-1,dlg.m_prname));
		return;
	}


}

void CEqualizerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == 9999)
	{
		if(pMainFrame->EQOnTop==1)
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999,MF_BYCOMMAND | MF_UNCHECKED);
						
			ShowWindow(SW_HIDE);
			ModifyStyleEx(0,WS_EX_APPWINDOW);
			ShowWindow(SW_SHOW);
			
			SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
			pMainFrame->EQOnTop=0;
		}
		else
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999,MF_BYCOMMAND | MF_CHECKED);
			
			ShowWindow(SW_HIDE);
			ModifyStyleEx(WS_EX_APPWINDOW,0);
			ShowWindow(SW_SHOW);

			SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
			pMainFrame->EQOnTop=1;
		}
		if(SeekDialog!=NULL) SeekDialog->SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


BOOL CMyEQBar::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CMyEQBar::OnPaint() 
{
	CPaintDC dc(this);
	
	if(!MemDCCreated)
	{
		
		memDC.CreateCompatibleDC(&dc);
		CRect rect;
		GetClientRect(&rect);
		memBitmap.CreateCompatibleBitmap(&dc, width=rect.Width(), height=rect.Height());
		memDC.SelectObject(&memBitmap);

		MemDCCreated=true;
	}

	memDC.FillSolidRect(0,0,width,height, ::GetSysColor(COLOR_BTNFACE));

	DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);

	CPen *p_pen,
		  pen1(PS_SOLID, 0, ::GetSysColor(COLOR_BTNFACE)),
		  pen2(PS_SOLID, 0, ::GetSysColor(COLOR_HIGHLIGHT));
	p_pen=memDC.SelectObject(&pen1);
	bool flag=true;
	for(int i=1;i<20;i++)
	{
		if(flag&&i>GetPos())
		{
			flag=false;
			memDC.SelectObject(&pen2);
		}
		memDC.MoveTo(i==10?1:width/3,height-height*i/20);
		memDC.LineTo(width-(i==10?1:width/3),height-height*i/20);
	}

	memDC.SelectObject(p_pen);

	dc.BitBlt(0, 0, width, height,
				&memDC, 0, 0, SRCCOPY);

}

void CMyEQBar::OnLButtonDown(UINT nFlags, CPoint point)
{
	CRect rect;
	GetClientRect(&rect);
	SetPos((int)(((float)(rect.Height())-(float)point.y+(float)rect.Height()/(float)40)*(float)20/(float)(rect.Height())));
	EqualizerDlg->UpdateValues();
	EqualizerDlg->m_presetcombo.SetCurSel(pMainFrame->EQPreset=-1);
}

void CMyEQBar::OnMouseMove(UINT nFlags, CPoint point)
{
	if(nFlags&MK_LBUTTON)
	{
		CRect rect;
		GetClientRect(&rect);
		SetPos((int)(((float)(rect.Height())-(float)point.y+(float)rect.Height()/(float)40)*(float)20/(float)(rect.Height())));
		EqualizerDlg->UpdateValues();
		EqualizerDlg->m_presetcombo.SetCurSel(pMainFrame->EQPreset=-1);
	}
}

void CEqualizerDlg::OnDel() 
{
	if(m_presetcombo.GetCurSel()==CB_ERR) return;
	pMainFrame->EQPreset=m_presetcombo.GetCurSel();
	CString buf;
	m_presetcombo.GetLBText(pMainFrame->EQPreset,buf);
	for(int i=0;i<pMainFrame->presets.GetSize();i++)
	{
		if(buf==pMainFrame->presets[i].Left(pMainFrame->presets[i].Find('\t')))
		{
			pMainFrame->presets.RemoveAt(i);
			break;
		}
	}
	m_presetcombo.DeleteString(pMainFrame->EQPreset);
	m_presetcombo.SetCurSel(pMainFrame->EQPreset=-1);
}

void CEqualizerDlg::SaveWindowPosAndDestroy()
{
	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->EqualizerX=rect.left;
	pMainFrame->EqualizerY=rect.top;

	DestroyWindow();
	EqualizerDlg=NULL;
}

