#include "stdafx.h"
#include "GCClock.h"

CGCClock::CGCClock() : CGCColorStatic()
{
	m_b24hr = FALSE;
}


CGCClock::~CGCClock()
{
}


BEGIN_MESSAGE_MAP(CGCClock, CGCColorStatic)
	ON_WM_TIMER()
END_MESSAGE_MAP()


void CGCClock::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent != CLOCK_UPDATE_TIMER_ID) CGCColorStatic::OnTimer(nIDEvent);
	GetLocalTime(&m_CurrentDateTime);
	FormatTime();
	SetWindowText(m_FormattedTime);

//if (m_FormattedTime!="") MessageBox(m_FormattedTime,"STP",MB_OK | MB_ICONWARNING);
}



void CGCClock::FormatTime()
{

		if (m_CurrentDateTime.wHour > 12)
		{
			UINT th;
			th = m_CurrentDateTime.wHour - 12;
			m_FormattedTime.Format("%2d:%02d:%02d p.m.",
				                   th,
								   m_CurrentDateTime.wMinute,
								   m_CurrentDateTime.wSecond);
		}
		else
			m_FormattedTime.Format("%d:%02d:%02d p.m.",
				                   m_CurrentDateTime.wHour,
								   m_CurrentDateTime.wMinute,
								   m_CurrentDateTime.wSecond);

}


BOOL CGCClock::Start()
{
	GetLocalTime(&m_CurrentDateTime);
	FormatTime();
	SetWindowText(m_FormattedTime);
	UINT id = this->SetTimer(CLOCK_UPDATE_TIMER_ID,1000,NULL);
	if (id == 0) return FALSE;

	return TRUE;
}

void CGCClock::Format(const BOOL bTwentyFourHour)
{
	m_b24hr = bTwentyFourHour;
	FormatTime();
	SetWindowText(m_FormattedTime);
}

