// Hotkeys.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "Hotkeys.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;

/////////////////////////////////////////////////////////////////////////////
// CHotkeys dialog


CHotkeys::CHotkeys(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CHotkeys)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CHotkeys::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHotkeys)
	DDX_Control(pDX, IDC_H_AUTOMATION, m_h_automation);
	DDX_Control(pDX, IDC_H_ALBUMMODE, m_h_albummode);
	DDX_Control(pDX, IDC_H_TRACKS, m_h_tracks);
	DDX_Control(pDX, IDC_H_ALBUM, m_h_album);
	DDX_Control(pDX, IDC_H_MENU, m_h_menu);
	DDX_Control(pDX, IDC_H_TRAYICON, m_h_trayicon);
	DDX_Control(pDX, IDC_H_OPEN3, m_h_open3);
	DDX_Control(pDX, IDC_H_BACK, m_h_back);
	DDX_Control(pDX, IDC_H_FORW, m_h_forw);
	DDX_Control(pDX, IDC_H_NP, m_h_np);
	DDX_Control(pDX, IDC_H_MODE, m_h_mode);
	DDX_Control(pDX, IDC_H_EXIT, m_h_exit);
	DDX_Control(pDX, IDC_H_JELTIY, m_h_jeltiy);
	DDX_Control(pDX, IDC_H_MP3INFO, m_h_mp3info);
	DDX_Control(pDX, IDC_H_VUP, m_h_vup);
	DDX_Control(pDX, IDC_H_VDOWN, m_h_vdown);
	DDX_Control(pDX, IDC_H_STOP, m_h_stop);
	DDX_Control(pDX, IDC_H_PREV, m_h_prev);
	DDX_Control(pDX, IDC_H_PLAY, m_h_play);
	DDX_Control(pDX, IDC_H_NEXT, m_h_next);
	DDX_Control(pDX, IDC_H_SHUFFLE, m_h_shuffle);
	DDX_Control(pDX, IDC_H_REPEAT, m_h_repeat);
	DDX_Control(pDX, IDC_H_PLAYLIST, m_h_playlist);
	DDX_Control(pDX, IDC_H_OPEN2, m_h_open2);
	DDX_Control(pDX, IDC_H_OPEN1, m_h_open1);
	DDX_Control(pDX, IDC_H_MINIBAR, m_h_minibar);
	DDX_Control(pDX, IDC_H_EQUALIZER, m_h_equalizer);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHotkeys, CDialog)
	//{{AFX_MSG_MAP(CHotkeys)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHotkeys message handlers

BOOL CHotkeys::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	pMainFrame->UnregHotKeys();

	WORD k,m;

	m_h_forw.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_ForwKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_ForwMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_ForwMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_ForwMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_forw.SetHotKey(k,m);

	m_h_back.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_BackKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_BackMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_BackMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_BackMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_back.SetHotKey(k,m);

	m_h_exit.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_ExitKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_ExitMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_ExitMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_ExitMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_exit.SetHotKey(k,m);


	m_h_np.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_NPKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_NPMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_NPMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_NPMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_np.SetHotKey(k,m);

	m_h_mode.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_ModeKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_ModeMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_ModeMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_ModeMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_mode.SetHotKey(k,m);

	m_h_play.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_PlayKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_PlayMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_PlayMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_PlayMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_play.SetHotKey(k,m);

	m_h_stop.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_StopKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_StopMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_StopMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_StopMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_stop.SetHotKey(k,m);

	m_h_prev.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_PrevKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_PrevMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_PrevMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_PrevMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_prev.SetHotKey(k,m);

	m_h_next.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_NextKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_NextMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_NextMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_NextMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_next.SetHotKey(k,m);

	m_h_vdown.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_VDownKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_VDownMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_VDownMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_VDownMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_vdown.SetHotKey(k,m);

	m_h_vup.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_VUpKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_VUpMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_VUpMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_VUpMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_vup.SetHotKey(k,m);

	m_h_open1.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_OpenKey1;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_OpenMod1&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_OpenMod1&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_OpenMod1&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_open1.SetHotKey(k,m);

	m_h_open2.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_OpenKey2;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_OpenMod2&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_OpenMod2&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_OpenMod2&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_open2.SetHotKey(k,m);

	m_h_open3.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_OpenKey3;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_OpenMod3&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_OpenMod3&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_OpenMod3&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_open3.SetHotKey(k,m);

	m_h_minibar.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_MinibarKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_MinibarMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_MinibarMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_MinibarMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_minibar.SetHotKey(k,m);

	m_h_mp3info.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_MP3InfoKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_MP3InfoMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_MP3InfoMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_MP3InfoMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_mp3info.SetHotKey(k,m);

	m_h_playlist.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_PlaylistKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_PlaylistMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_PlaylistMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_PlaylistMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_playlist.SetHotKey(k,m);

	m_h_equalizer.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_EqualizerKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_EqualizerMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_EqualizerMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_EqualizerMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_equalizer.SetHotKey(k,m);

	m_h_repeat.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_RepeatKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_RepeatMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_RepeatMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_RepeatMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_repeat.SetHotKey(k,m);

	m_h_shuffle.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_ShuffleKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_ShuffleMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_ShuffleMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_ShuffleMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_shuffle.SetHotKey(k,m);

	m_h_albummode.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_AlbummodeKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_AlbummodeMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_AlbummodeMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_AlbummodeMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_albummode.SetHotKey(k,m);

	m_h_trayicon.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_TrayIconKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_TrayIconMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_TrayIconMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_TrayIconMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_trayicon.SetHotKey(k,m);

	m_h_menu.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_MenuKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_MenuMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_MenuMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_MenuMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_menu.SetHotKey(k,m);

	m_h_tracks.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_TracksKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_TracksMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_TracksMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_TracksMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_tracks.SetHotKey(k,m);

	m_h_album.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_AlbumKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_AlbumMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_AlbumMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_AlbumMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_album.SetHotKey(k,m);

	m_h_automation.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_AutomationKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_AutomationMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_AutomationMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_AutomationMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_automation.SetHotKey(k,m);


	
	m_h_jeltiy.SetRules(HKCOMB_NONE,HOTKEYF_CONTROL | HOTKEYF_ALT);
	k=(WORD)pMainFrame->m_JeltiyKey;
	m=(k>=VK_PRIOR&&k<=VK_DOWN||k==VK_INSERT||k==VK_DELETE)?HOTKEYF_EXT:0;
	if(pMainFrame->m_JeltiyMod&MOD_ALT) m|=HOTKEYF_ALT;
	if(pMainFrame->m_JeltiyMod&MOD_CONTROL) m|=HOTKEYF_CONTROL;
	if(pMainFrame->m_JeltiyMod&MOD_SHIFT) m|=HOTKEYF_SHIFT;
	m_h_jeltiy.SetHotKey(k,m);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CHotkeys::OnOK() 
{
	if(CheckDoubles())
	{
		MessageBox(MyLoadString(IDS_HOTKEYS),"STP",MB_OK | MB_ICONERROR);
		return;
	}
	WORD k,m;

	m_h_forw.GetHotKey(k,m);
	pMainFrame->m_ForwKey=(UINT)k;
	pMainFrame->m_ForwMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_ForwMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_ForwMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_ForwMod|=MOD_SHIFT;
	
	m_h_back.GetHotKey(k,m);
	pMainFrame->m_BackKey=(UINT)k;
	pMainFrame->m_BackMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_BackMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_BackMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_BackMod|=MOD_SHIFT;

	m_h_exit.GetHotKey(k,m);
	pMainFrame->m_ExitKey=(UINT)k;
	pMainFrame->m_ExitMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_ExitMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_ExitMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_ExitMod|=MOD_SHIFT;




	m_h_np.GetHotKey(k,m);
	pMainFrame->m_NPKey=(UINT)k;
	pMainFrame->m_NPMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_NPMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_NPMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_NPMod|=MOD_SHIFT;

	m_h_mode.GetHotKey(k,m);
	pMainFrame->m_ModeKey=(UINT)k;
	pMainFrame->m_ModeMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_ModeMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_ModeMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_ModeMod|=MOD_SHIFT;

	m_h_play.GetHotKey(k,m);
	pMainFrame->m_PlayKey=(UINT)k;
	pMainFrame->m_PlayMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_PlayMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_PlayMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_PlayMod|=MOD_SHIFT;

	m_h_stop.GetHotKey(k,m);
	pMainFrame->m_StopKey=(UINT)k;
	pMainFrame->m_StopMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_StopMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_StopMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_StopMod|=MOD_SHIFT;

	m_h_prev.GetHotKey(k,m);
	pMainFrame->m_PrevKey=(UINT)k;
	pMainFrame->m_PrevMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_PrevMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_PrevMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_PrevMod|=MOD_SHIFT;

	m_h_next.GetHotKey(k,m);
	pMainFrame->m_NextKey=(UINT)k;
	pMainFrame->m_NextMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_NextMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_NextMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_NextMod|=MOD_SHIFT;

	m_h_vdown.GetHotKey(k,m);
	pMainFrame->m_VDownKey=(UINT)k;
	pMainFrame->m_VDownMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_VDownMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_VDownMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_VDownMod|=MOD_SHIFT;
	
	m_h_vup.GetHotKey(k,m);
	pMainFrame->m_VUpKey=(UINT)k;
	pMainFrame->m_VUpMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_VUpMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_VUpMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_VUpMod|=MOD_SHIFT;

	m_h_open1.GetHotKey(k,m);
	pMainFrame->m_OpenKey1=(UINT)k;
	pMainFrame->m_OpenMod1=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_OpenMod1|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_OpenMod1|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_OpenMod1|=MOD_SHIFT;

	m_h_open2.GetHotKey(k,m);
	pMainFrame->m_OpenKey2=(UINT)k;
	pMainFrame->m_OpenMod2=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_OpenMod2|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_OpenMod2|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_OpenMod2|=MOD_SHIFT;

	m_h_open3.GetHotKey(k,m);
	pMainFrame->m_OpenKey3=(UINT)k;
	pMainFrame->m_OpenMod3=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_OpenMod3|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_OpenMod3|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_OpenMod3|=MOD_SHIFT;

	m_h_minibar.GetHotKey(k,m);
	pMainFrame->m_MinibarKey=(UINT)k;
	pMainFrame->m_MinibarMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_MinibarMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_MinibarMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_MinibarMod|=MOD_SHIFT;

	m_h_mp3info.GetHotKey(k,m);
	pMainFrame->m_MP3InfoKey=(UINT)k;
	pMainFrame->m_MP3InfoMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_MP3InfoMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_MP3InfoMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_MP3InfoMod|=MOD_SHIFT;

	m_h_playlist.GetHotKey(k,m);
	pMainFrame->m_PlaylistKey=(UINT)k;
	pMainFrame->m_PlaylistMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_PlaylistMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_PlaylistMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_PlaylistMod|=MOD_SHIFT;

	m_h_equalizer.GetHotKey(k,m);
	pMainFrame->m_EqualizerKey=(UINT)k;
	pMainFrame->m_EqualizerMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_EqualizerMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_EqualizerMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_EqualizerMod|=MOD_SHIFT;

	m_h_repeat.GetHotKey(k,m);
	pMainFrame->m_RepeatKey=(UINT)k;
	pMainFrame->m_RepeatMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_RepeatMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_RepeatMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_RepeatMod|=MOD_SHIFT;

	m_h_shuffle.GetHotKey(k,m);
	pMainFrame->m_ShuffleKey=(UINT)k;
	pMainFrame->m_ShuffleMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_ShuffleMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_ShuffleMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_ShuffleMod|=MOD_SHIFT;

	m_h_albummode.GetHotKey(k,m);
	pMainFrame->m_AlbummodeKey=(UINT)k;
	pMainFrame->m_AlbummodeMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_AlbummodeMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_AlbummodeMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_AlbummodeMod|=MOD_SHIFT;

	m_h_trayicon.GetHotKey(k,m);
	pMainFrame->m_TrayIconKey=(UINT)k;
	pMainFrame->m_TrayIconMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_TrayIconMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_TrayIconMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_TrayIconMod|=MOD_SHIFT;

	m_h_menu.GetHotKey(k,m);
	pMainFrame->m_MenuKey=(UINT)k;
	pMainFrame->m_MenuMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_MenuMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_MenuMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_MenuMod|=MOD_SHIFT;

	m_h_tracks.GetHotKey(k,m);
	pMainFrame->m_TracksKey=(UINT)k;
	pMainFrame->m_TracksMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_TracksMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_TracksMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_TracksMod|=MOD_SHIFT;

	m_h_album.GetHotKey(k,m);
	pMainFrame->m_AlbumKey=(UINT)k;
	pMainFrame->m_AlbumMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_AlbumMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_AlbumMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_AlbumMod|=MOD_SHIFT;

	m_h_automation.GetHotKey(k,m);
	pMainFrame->m_AutomationKey=(UINT)k;
	pMainFrame->m_AutomationMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_AutomationMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_AutomationMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_AutomationMod|=MOD_SHIFT;


	
	m_h_jeltiy.GetHotKey(k,m);
	pMainFrame->m_JeltiyKey=(UINT)k;
	pMainFrame->m_JeltiyMod=0;
	if(m&HOTKEYF_ALT)pMainFrame->m_JeltiyMod|=MOD_ALT;
	if(m&HOTKEYF_CONTROL)pMainFrame->m_JeltiyMod|=MOD_CONTROL;
	if(m&HOTKEYF_SHIFT)pMainFrame->m_JeltiyMod|=MOD_SHIFT;



	pMainFrame->RegHotKeys();

	CDialog::OnOK();
}

void CHotkeys::OnClose() 
{
	pMainFrame->RegHotKeys();
	
	CDialog::OnClose();
}

void CHotkeys::OnCancel() 
{
	pMainFrame->RegHotKeys();
	
	CDialog::OnCancel();
}

bool CHotkeys::CheckDoubles()
{
	WORD k[27],m[27];

	m_h_albummode.	GetHotKey(k[0],m[0]);
	m_h_tracks.		GetHotKey(k[1],m[1]);
	m_h_album.		GetHotKey(k[2],m[2]);
	m_h_menu.		GetHotKey(k[3],m[3]);
	m_h_trayicon.	GetHotKey(k[4],m[4]);
	m_h_open3.		GetHotKey(k[5],m[5]);
	m_h_back.		GetHotKey(k[6],m[6]);
	m_h_forw.		GetHotKey(k[7],m[7]);
	m_h_np.			GetHotKey(k[8],m[8]);
	m_h_mode.		GetHotKey(k[9],m[9]);
	m_h_exit.		GetHotKey(k[10],m[10]);
	m_h_mp3info.	GetHotKey(k[11],m[11]);
	m_h_vup.		GetHotKey(k[12],m[12]);
	m_h_vdown.		GetHotKey(k[13],m[13]);
	m_h_stop.		GetHotKey(k[14],m[14]);
	m_h_prev.		GetHotKey(k[15],m[15]);
	m_h_play.		GetHotKey(k[16],m[16]);
	m_h_next.		GetHotKey(k[17],m[17]);
	m_h_shuffle.	GetHotKey(k[18],m[18]);
	m_h_repeat.		GetHotKey(k[19],m[19]);
	m_h_playlist.	GetHotKey(k[20],m[20]);
	m_h_open2.		GetHotKey(k[21],m[21]);
	m_h_open1.		GetHotKey(k[22],m[22]);
	m_h_minibar.	GetHotKey(k[23],m[23]);
	m_h_equalizer.	GetHotKey(k[24],m[24]);
	m_h_automation.	GetHotKey(k[25],m[25]);
	m_h_jeltiy.		GetHotKey(k[26],m[26]);


	int i,j;
	for(i=0;i<27;i++)
		for(j=i+1;j<27;j++)
			if(k[i]==k[j]&&m[i]==m[j]&&!(k[i]==0&&m[i]==0))
				return true;

	return false;
}
