// MP3InfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "MP3InfoDlg.h"
#include "MainWnd.h"
#include "TagEditor.h"
#include "SeekDialog.h"
#include "PlaylistDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;
extern CMP3InfoDlg *MP3InfoDlg;
extern CSeekDialog *SeekDialog;
extern CPlaylistDlg *PlaylistDlg;

extern CStringArray genres;

extern CString ReadTagAT(CString fname);

/////////////////////////////////////////////////////////////////////////////
// CMP3InfoDlg dialog


CMP3InfoDlg::CMP3InfoDlg(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CMP3InfoDlg)
	m_album = _T("");
	m_artist = _T("");
	m_comment = _T("");
	m_filename = _T("");
	m_genre = _T("");
	m_title = _T("");
	m_year = _T("");
	m_bitrate = _T("");
	m_freq = _T("");
	m_mode = _T("");
	//}}AFX_DATA_INIT
}


void CMP3InfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMP3InfoDlg)
	DDX_Text(pDX, IDC_EDIT_ALBUM, m_album);
	DDX_Text(pDX, IDC_EDIT_ARTIST, m_artist);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_comment);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_filename);
	DDX_Text(pDX, IDC_EDIT_GENRE, m_genre);
	DDX_Text(pDX, IDC_EDIT_TITLE, m_title);
	DDX_Text(pDX, IDC_EDIT_YEAR, m_year);
	DDX_Text(pDX, IDC_EDIT_BITRATE, m_bitrate);
	DDX_Text(pDX, IDC_EDIT_FREQ, m_freq);
	DDX_Text(pDX, IDC_EDIT_MODE, m_mode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMP3InfoDlg, CDialog)
	//{{AFX_MSG_MAP(CMP3InfoDlg)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_EDITTAG, OnEdittag)
	//}}AFX_MSG_MAP
	ON_WM_SYSCOMMAND()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP3InfoDlg message handlers

BOOL CMP3InfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	SetIcon(pMainFrame->StpIcon, TRUE);
	SetIcon(pMainFrame->StpIconSm, FALSE);


	CRect rect1,rect2;
	::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	GetWindowRect(&rect2);
	if(pMainFrame->InfoX==-1000)
		pMainFrame->InfoX=(rect1.right-(rect2.right-rect2.left))/2;
	if(pMainFrame->InfoY==-1000)
		pMainFrame->InfoY=(rect1.bottom-(rect2.bottom-rect2.top))/2;
	if(pMainFrame->InfoX<0)
		pMainFrame->InfoX=0;
	if(pMainFrame->InfoY<0)
		pMainFrame->InfoY=0;
	if(pMainFrame->InfoX+(rect2.right-rect2.left)>rect1.right)
		pMainFrame->InfoX=rect1.right-(rect2.right-rect2.left);
	if(pMainFrame->InfoY+(rect2.bottom-rect2.top)>rect1.bottom)
		pMainFrame->InfoY=rect1.bottom-(rect2.bottom-rect2.top);
	SetWindowPos(NULL,pMainFrame->InfoX,pMainFrame->InfoY,0,0,SWP_NOSIZE | SWP_NOZORDER|SWP_NOACTIVATE);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, 9999, MyLoadString(IDS_ALWAYSONTOP));
	}
	if(pMainFrame->InfoOnTop==1)
	{
		pSysMenu->CheckMenuItem(9999,MF_BYCOMMAND | MF_CHECKED);
		SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
	} else
	{
		ModifyStyleEx(0,WS_EX_APPWINDOW);
	}

	PrevFile="*";

	ReadInfo();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMP3InfoDlg::OnCancel() 
{
	SaveWindowPosAndDestroy();
}

void CMP3InfoDlg::OnClose() 
{
	SaveWindowPosAndDestroy();
}

void CMP3InfoDlg::ReadInfo()
{
	m_filename=pMainFrame->PlayList[pMainFrame->Current];

	CString mbuf=pMainFrame->MP3Info;
	m_bitrate=mbuf.Left(mbuf.Find('@'));
	mbuf=mbuf.Mid(mbuf.Find('@')+1);
	m_freq=mbuf.Left(mbuf.Find('@'));
	m_mode=mbuf.Mid(mbuf.Find('@')+1);

	if(PrevFile==m_filename)
	{
		UpdateData(FALSE);
		return;
	}
	PrevFile=m_filename;

	m_album="";
	m_artist="";
	m_comment="";
	m_genre="";
	m_title="";
	m_year="";

	CString theTitle=m_filename;
	int i;
	i=theTitle.ReverseFind('.');
	if(theTitle.Mid(i+1,3).CompareNoCase("MP3")!=0) i=-1;
	if(i==-1)i=theTitle.GetLength();
	theTitle=theTitle.Left(i);

	if(theTitle.Left(7).CompareNoCase("http://")==0||theTitle.Left(6).CompareNoCase("ftp://")==0)
	{
		i=theTitle.ReverseFind('/');
		theTitle=theTitle.Mid(i+1);
		if(theTitle.GetLength()>30) theTitle=theTitle.Left(30);
		m_title=theTitle;
		UpdateData(false);
		return;
	}

	i=theTitle.ReverseFind('\\');
	theTitle=theTitle.Mid(i+1);
	if(theTitle.GetLength()>30) theTitle=theTitle.Left(30);
	theTitle.Replace('_',' ');

	CFile mpfile;
	if(!mpfile.Open(m_filename,CFile::modeRead | CFile::shareDenyNone))
	{
		m_title=theTitle;
		UpdateData(false);
		return;
	}

	if(mpfile.GetLength()<129)
	{
		mpfile.Close();
		m_title=theTitle;
		UpdateData(false);
		return;
	}

	mpfile.Seek(-128,CFile::end);

	char buf[31];
	mpfile.Read(buf,3);buf[3]='\0';
	if(strcmp(buf,"TAG"))
	{
		mpfile.Close();
		m_title=theTitle;
		UpdateData(false);
		return;
	}

	if(mpfile.Read(buf,30))
	{
		buf[30]='\0';
		m_title=buf;
		m_title.TrimRight();
	}
	if(mpfile.Read(buf,30))
	{
		buf[30]='\0';
		m_artist=buf;
		m_artist.TrimRight();
	}
	if(mpfile.Read(buf,30))
	{
		buf[30]='\0';
		m_album=buf;
		m_album.TrimRight();
	}
	if(mpfile.Read(buf,4))
	{
		buf[4]='\0';
		m_year=buf;
		m_year.TrimRight();
	}
	if(mpfile.Read(buf,30))
	{
		buf[30]='\0';
		m_comment=buf;
		m_comment.TrimRight();
	}
	
	if(mpfile.Read(buf,1))
	{
		if((unsigned char)buf[0]<148)
			m_genre=genres[(unsigned char)buf[0]];
	}

	mpfile.Close();

	UpdateData(false);	
}

void CMP3InfoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == 9999)
	{
		if(pMainFrame->InfoOnTop==1)
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999,MF_BYCOMMAND | MF_UNCHECKED);
						
			ShowWindow(SW_HIDE);
			ModifyStyleEx(0,WS_EX_APPWINDOW);
			ShowWindow(SW_SHOW);
			
			SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
			pMainFrame->InfoOnTop=0;
		}
		else
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999,MF_BYCOMMAND | MF_CHECKED);
			
			ShowWindow(SW_HIDE);
			ModifyStyleEx(WS_EX_APPWINDOW,0);
			ShowWindow(SW_SHOW);
			
			SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
			pMainFrame->InfoOnTop=1;
		}
		if(SeekDialog!=NULL) SeekDialog->SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CMP3InfoDlg::OnEdittag() 
{
	CTagEditor TagEditor(IDD_TAGEDITR,this);
	TagEditor.m_filename=pMainFrame->PlayList[pMainFrame->Current];
	if(TagEditor.DoModal()==IDOK)
	{
		if(TagEditor.m_filename==pMainFrame->PlayList[pMainFrame->Current])
			pMainFrame->ReadTag(TagEditor.m_filename);
		PrevFile="*";
		ReadInfo();
		pMainFrame->PlayListAT[pMainFrame->Current]=ReadTagAT(TagEditor.m_filename);
		if(PlaylistDlg!=NULL)
			PlaylistDlg->m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
	}	
}

void CMP3InfoDlg::SaveWindowPosAndDestroy()
{
	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->InfoX=rect.left;
	pMainFrame->InfoY=rect.top;

	DestroyWindow();
	MP3InfoDlg=NULL;
}

