// MainWnd.cpp : implementation file
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "MainWnd.h"
#include "EqualizerDlg.h"
#include "PlaylistDlg.h"
//#include "CDPlaylistDlg.h"
#include "AboutDlg.h"
#include "SeekDialog.h"
#include "MP3InfoDlg.h"
#include "SettingsDialog.h"
#include "WAEmuWnd.h"
//#include "CDBar.h"
#include "UrlDlg.h"
#include "AutDlg.h"
#include "Unexact.h"

#include "stream.h"

#include "Volume.h"
#include "SearcherDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	WM_ICON_NOTIFY WM_USER+10
#define WM_PLAYOVER WM_USER+40

int ADevice, MDevice;

extern int BuffersType;
extern int InputBuffersType;
extern int ForceMono;
extern int Downsampling;

extern CInternetSession* mysession;
extern void InitInetSession();

CStringArray genres;

extern CSysTrayPlayApp theApp;
extern CMainWnd* pMainFrame;
CSeekDialog *SeekDialog=NULL;
CEqualizerDlg *EqualizerDlg=NULL;
CPlaylistDlg *PlaylistDlg=NULL;
//CCDPlaylistDlg *CDPlaylistDlg=NULL;
CAboutDlg *AboutDlg=NULL;
CMP3InfoDlg *MP3InfoDlg=NULL;
CSettingsDialog *SettingsDialog=NULL;
CWAEmuWnd *WAEmuWnd=NULL;
//CCDBar *CDBar=NULL;
CAutDlg *AutDlg=NULL;


CVolume* pVolume=NULL;

CString MyLoadString(UINT id)
{
	CString buf;
	buf.LoadString(id+100);
	return buf;
}

unsigned long rnd;
double frand()
{
	return ((double)(rnd*=0xCAB3)/0xFFFFFFFF);
}

// TAGS STUFF

HANDLE hTagsThread=NULL;

struct simple_frame {
    long lsf;
    long lay;
    long error_protection;
    long bitrate_index;
    long sampling_frequency;
    long mpeg25;
    long stereo;
};

static int ExtractI4(unsigned char *buf)
{
int x;
// big endian extract

x = buf[0];
x <<= 8;
x |= buf[1];
x <<= 8;
x |= buf[2];
x <<= 8;
x |= buf[3];

return x;
}

static int simple_decode_header(unsigned long newhead,struct simple_frame *pfr)
{
    if( (newhead & 0xffe00000) != 0xffe00000)
	return FALSE;
    if(!((newhead>>17)&3))
	return FALSE;
    if( ((newhead>>12)&0xf) == 0xf)
	return FALSE;
    if( ((newhead>>10)&0x3) == 0x3 )
	return FALSE;
    if ((newhead & 0xffff0000) == 0xfffe0000)
      return FALSE;

    if( newhead & (1<<20) ) {
      pfr->lsf = (newhead & (1<<19)) ? 0x0 : 0x1;
      pfr->mpeg25 = 0;
    }
    else {
      pfr->lsf = 1;
      pfr->mpeg25 = 1;
    }
      
	pfr->lay = 4-((newhead>>17)&3);

	if(pfr->lay!=1&&pfr->lay!=2&&pfr->lay!=3)
		return 0;

	if (pfr->mpeg25) 
		pfr->sampling_frequency = 6 + ((newhead>>10)&0x3);
	else
		pfr->sampling_frequency = ((newhead>>10)&0x3) + (pfr->lsf*3);

    pfr->error_protection = ((newhead>>16)&0x1)^0x1;
	pfr->bitrate_index = ((newhead>>12)&0xf);
    pfr->stereo    = (((newhead>>6)&0x3) == MPG_MD_MONO) ? 1 : 2;

	return 1;
}

CString ReadTagAT(CString fname)
{
    CString dur=" (mm:ss)";
    CString ToReturn=fname;
	ToReturn.Replace('_',' ');

	if(ToReturn.Left(7).CompareNoCase("http://")==0||ToReturn.Left(6).CompareNoCase("ftp://")==0)
	{
		ToReturn.Replace("%20"," ");
		int i,j;
		if((i=ToReturn.ReverseFind('.'))>-1)
			if(ToReturn.Mid(i+1,3).CompareNoCase("MP3")==0||ToReturn.Mid(i+1,3).CompareNoCase("WAV")==0)
			{
				j=ToReturn.ReverseFind('/');
				ToReturn=ToReturn.Mid(j+1,i-ToReturn.ReverseFind('/')-1);		
			}
		//if(ToReturn.GetLength()>50) ToReturn=ToReturn.Left(50)+"...";
//		pMainFrame->UpdateTagCache(fname,ToReturn);
		return ToReturn+dur;
	}

    int i;
    i=ToReturn.ReverseFind('.');
    if(i==-1)i=ToReturn.GetLength();
    ToReturn=ToReturn.Left(i);

    i=ToReturn.ReverseFind('\\');
    ToReturn=ToReturn.Mid(i+1);

    CFile f;

    if(!f.Open(fname,CFile::modeRead | CFile::shareDenyNone))
	{
		//pMainFrame->UpdateTagCache(fname,ToReturn);
		return ToReturn+dur;
	}   

    unsigned char hbuf[4];
    unsigned long newhead;
	struct simple_frame frtmp;
	int riffsize=0,id3v2size=0,duration=0;

read_again:
    if(f.Read(hbuf,4)<4)
		goto fault;

    newhead=((unsigned long) hbuf[0] << 24) |
        ((unsigned long) hbuf[1] << 16) |
        ((unsigned long) hbuf[2] << 8)  |
        (unsigned long) hbuf[3];

    if(!simple_decode_header(newhead, &frtmp)) 
	{
		if(newhead == ('R'<<24)+('I'<<16)+('F'<<8)+'F')
		{
			try
			{
				f.Seek(66,CFile::current);
				riffsize=70;
			} catch(...){};
			goto read_again;
		}
		if ((newhead & (('I'<<24)+('D'<<16)+('3'<<8))) == (('I'<<24)+('D'<<16)+('3'<<8))) 
		{
			try
			{
				f.Seek(2,CFile::current);
				f.Read(hbuf,4);

				id3v2size=(int)(hbuf[0]&0x7f)*0x200000+
						  (int)(hbuf[1]&0x7f)*0x4000+
						  (int)(hbuf[2]&0x7f)*0x80+
						  (int)(hbuf[3]&0x7f);
				f.Seek(id3v2size,CFile::current);
			} catch(...){};
			goto read_again;
		}
		for(i=0;i<65536;i++) 
		{
			memmove(&hbuf[0],&hbuf[1],3);
			if(f.Read(hbuf+3, 1)<1) goto fault;
       
			newhead <<= 8;
			newhead |= hbuf[3];
			newhead &= 0xffffffff;
			if(simple_decode_header(newhead, &frtmp)) break;
		}
		if(i==65536) 
			goto fault;
	}
	duration=(f.GetLength()-riffsize-id3v2size)*8 / GetBitrate(frtmp.lsf, frtmp.lay, frtmp.bitrate_index) / 1000;

	try
	{
		int ssize;
		if(frtmp.lsf)
		  ssize = (frtmp.stereo == 1) ? 9 : 17;
		else
		  ssize = (frtmp.stereo == 1) ? 17 : 32;
		if (frtmp.error_protection)
		{
		  ssize += 2;
		}
		f.Seek(ssize, CFile::current);
		if(f.Read(hbuf,4)==4)
		if(hbuf[0]=='X'&&
		   hbuf[1]=='i'&&
		   hbuf[2]=='n'&&
		   hbuf[3]=='g')
		{
			char XingData[116];

			if(f.Read(XingData, 116)==116)
			{
				int flags=ExtractI4((unsigned char*)XingData), frames;
				if((flags&1)>0)
					frames=ExtractI4((unsigned char*)XingData+4);
				else
					frames=0;
				duration=(int)((double)1152/(double)freqs[frtmp.sampling_frequency]*(double)frames);
			}
		}
	} catch(...){};
	dur.Format((" (%02d:%02d)"),(int)(duration/60),duration%60);
fault:
	
	if(f.GetLength()>128)
	{
		try
		{
			f.Seek(f.GetLength()-f.GetPosition()-128,CFile::current);

			char buf[31];
			f.Read(buf,3);buf[3]='\0';
			if(strcmp(buf,"TAG"))
			{
				f.Close();
//				pMainFrame->UpdateTagCache(fname,ToReturn+dur);
				return ToReturn+dur;
			}
    
			f.Read(buf,30);buf[30]='\0';
			ToReturn=buf;
			ToReturn.TrimLeft();ToReturn.TrimRight();
			f.Read(buf,30);buf[30]='\0';
			CString buf2;
			buf2=buf;
			buf2.TrimLeft();buf2.TrimRight();
			if(buf2!="")
				ToReturn=buf2+" - "+ToReturn;
		} catch(...){};
	}
    
    f.Close();

//	pMainFrame->UpdateTagCache(fname,ToReturn+dur);
    return ToReturn+dur;
}




// END OF TAGS STUFF

// CDDB STUFF

struct toc {
	int	min;
	int	sec;
	int	frame;
};

struct toc cdtoc[100];
int tot_trks,offsets[100],totaltime;
CString curcdid;

int
read_cdtoc_from_drive(void)
{
	CString buf;
	char buf2[64];

	mciSendString("status stp number of tracks",buf2,64,NULL);
	int tot_trks=atoi(buf2);

	if(tot_trks>0)
	{
		mciSendString("set stp time format msf",NULL,0,NULL);
		for(int i=0;i<tot_trks;i++)
		{
			buf.Format("status stp position track %d",i+1);
			mciSendString(buf,buf2,64,NULL);
			buf=buf2;
			cdtoc[i].min=atoi(buf.Mid(0,2));
			cdtoc[i].sec=atoi(buf.Mid(3,2));
			cdtoc[i].frame=atoi(buf.Mid(6,2));
			if(i==0)
				totaltime=atoi(buf.Mid(0,2))*60*75+atoi(buf.Mid(3,2))*75+atoi(buf.Mid(6,2));
			buf.Format("status stp length track %d",i+1);
			mciSendString(buf,buf2,64,NULL);
			buf=buf2;
			offsets[i]=totaltime;
			totaltime+=atoi(buf.Mid(0,2))*60*75+atoi(buf.Mid(3,2))*75+atoi(buf.Mid(6,2));
		}
		totaltime=(totaltime-offsets[0])/75;
		buf.Format("status stp length track %d",tot_trks);
		mciSendString(buf,buf2,64,NULL);
		buf=buf2;
		DWORD dwPos=(cdtoc[tot_trks-1].min*60*75)+(cdtoc[tot_trks-1].sec*75)+cdtoc[tot_trks-1].frame+(atoi(buf.Mid(0,2))*60*75)+(atoi(buf.Mid(3,2))*75)+atoi(buf.Mid(6,2))+1;
		cdtoc[tot_trks].frame = dwPos % 75;  dwPos = dwPos / 75;
		cdtoc[tot_trks].sec = dwPos % 60;    dwPos = dwPos / 60;
		cdtoc[tot_trks].min = dwPos;
		mciSendString("set stp time format tmsf",NULL,0,NULL);
	}
	return (tot_trks);
}

int
cddb_sum(int n)
{
	int	ret;

	/* For backward compatibility this algorithm must not change */

	ret = 0;

	while (n > 0) {
		ret = ret + (n % 10);
		n = n / 10;
	}

	return (ret);
}

unsigned long
cddb_discid(int tot_trks)
{
	int	i,
		t = 0,
		n = 0;

	/* For backward compatibility this algorithm must not change */

	i = 0;

	while (i < tot_trks) {
		n = n + cddb_sum((cdtoc[i].min * 60) + cdtoc[i].sec);
		i++;
	}

	t = ((cdtoc[tot_trks].min * 60) + cdtoc[tot_trks].sec) -
	    ((cdtoc[0].min * 60) + cdtoc[0].sec);

	return ((n % 0xff) << 24 | t << 8 | tot_trks);
}

void QueryCDDB(void *dummy)
{
	CString genre,diskid,url,email;

	email=pMainFrame->EMailAddress;
	email.Replace("@","+");

	diskid.Format("%08x", cddb_discid(tot_trks));

	CString buf;

	int i;

	try
	{
		url=pMainFrame->CDDBServer+"?cmd=cddb+query+"+diskid;
		buf.Format("+%d",tot_trks);
		url+=buf;
		for(i=0;i<tot_trks;i++)
		{
			buf.Format("+%d",offsets[i]);
			url+=buf;
		}

		buf.Format("+%d",totaltime);
		url+=buf;

		url+="&hello=";
		url+=email;
		url+="+STP+";
		url+="FINAL";
		url+="&proto=4";

		if(mysession==NULL)
			InitInetSession();

		CStdioFile *remotefile = mysession->OpenURL(url,1,INTERNET_FLAG_TRANSFER_ASCII | INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE);
		if(remotefile==NULL)
		{
			pMainFrame->MessageBox(MyLoadString(IDS_CDDBFAILED),"STP",MB_OK | MB_ICONERROR);
			return;
		}
		if(remotefile->ReadString(buf))
		{
			if(buf.Left(3)=="200"||buf.Left(3)==210||buf.Left(3)=="211")
			{
				if(buf.Left(3)!="200")
				{
					CUnexact dlg(IDD_CDUNEXACTR);
					for(;;)
					{
						remotefile->ReadString(buf);
						if(buf!=".")
							dlg.matches.Add(buf);
						else
							break;
					}
					if(dlg.DoModal()!=IDOK)
					{
						pMainFrame->hCDDBThread=NULL;
						return;
					}
					buf=dlg.matches[dlg.match];
				}
				else
					buf=buf.Mid(buf.Find(' ')+1);
				genre=buf.Left(buf.Find(' '));
				buf=buf.Mid(buf.Find(' ')+1);
				diskid=buf.Left(buf.Find(' '));
				remotefile->Close();
				url=pMainFrame->CDDBServer+"?cmd=cddb+read+"+genre+"+"+diskid+"&hello=";
				url+=email+"+STP+FINAL&proto=4";
				remotefile = mysession->OpenURL(url,1,INTERNET_FLAG_TRANSFER_ASCII | INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE);
				if(remotefile==NULL)
				{
					pMainFrame->MessageBox(MyLoadString(IDS_CDDBFAILED),"STP",MB_OK | MB_ICONERROR);
					pMainFrame->hCDDBThread=NULL;
					return;
				}
				if(remotefile->ReadString(buf))
				{
					if(buf.Left(3)=="210")
					{
						CString artist,title;
						int numtracks=0;
						while(remotefile->ReadString(buf))
						{
							if(buf.Left(6)=="DTITLE")
							{
								buf=buf.Mid(7);
								
								artist=buf.Left(buf.Find('/'));artist.TrimLeft();artist.TrimRight();
								title=buf.Mid(buf.ReverseFind('/')+1);title.TrimLeft();title.TrimRight();
								::WritePrivateProfileString(curcdid,"Artist",artist,"CDPLAYER.INI");
								::WritePrivateProfileString(curcdid,"Title",title,"CDPLAYER.INI");
								continue;
							}
							if(buf.Left(6)=="TTITLE")
							{
								numtracks++;
								title=buf.Mid(buf.Find('=')+1);title.TrimLeft();title.TrimRight();
								::WritePrivateProfileString(curcdid,buf.Mid(6,buf.Find('=')-6),title,"CDPLAYER.INI");
							}
						}
						buf.Format("%d",numtracks);
						::WritePrivateProfileString(curcdid,"NumTracks",buf,"CDPLAYER.INI");
					} else
					{
						pMainFrame->MessageBox(MyLoadString(IDS_CDDBFAILED),"STP",MB_OK | MB_ICONERROR);
						remotefile->Close();
						pMainFrame->hCDDBThread=NULL;
						return;
					}
				} else
				{
					pMainFrame->MessageBox(MyLoadString(IDS_CDDBFAILED),"STP",MB_OK | MB_ICONERROR);
					remotefile->Close();
					pMainFrame->hCDDBThread=NULL;
					return;
				}
				remotefile->Close();
			} else
			{
				pMainFrame->MessageBox(MyLoadString(IDS_CDDBFAILED),"STP",MB_OK | MB_ICONERROR);
				pMainFrame->hCDDBThread=NULL;
				return;
			}
		} else
		{
			pMainFrame->MessageBox(MyLoadString(IDS_CDDBFAILED),"STP",MB_OK | MB_ICONERROR);
			pMainFrame->hCDDBThread=NULL;
			return;
		}
	}
	catch(...)
	{
		pMainFrame->MessageBox(MyLoadString(IDS_CDDBFAILED),"STP",MB_OK | MB_ICONERROR);
		pMainFrame->hCDDBThread=NULL;
		return;
	}
	pMainFrame->hCDDBThread=NULL;
}

// END OF CDDB STUFF

static int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	CString dir;
	dir=pMainFrame->InitDir;
	if(dir.Right(1)=="\\")
		dir=dir.Left(dir.GetLength()-1);

	if (uMsg == BFFM_INITIALIZED)
		::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)LPCTSTR(dir));
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainWnd

IMPLEMENT_DYNCREATE(CMainWnd, CFrameWnd)

CMainWnd::CMainWnd()
{
	StpIcon=(HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STP), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
	StpIconSm=(HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STP), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
//	hMenuBitmap=(HBITMAP)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDB_SYSTRAYPLAY), IMAGE_BITMAP,20,100, LR_DEFAULTCOLOR);
	Created=false;
}

CMainWnd::~CMainWnd()
{
}


BEGIN_MESSAGE_MAP(CMainWnd, CFrameWnd)
	//{{AFX_MSG_MAP(CMainWnd)
	ON_COMMAND(ID_POPUPMENU_EXIT, OnPopupmenuExit)
	ON_COMMAND(ID_POPUPMENU_OPEN_FILE, OnPopupmenuOpenFile)
//	ON_COMMAND(ID_POPUPMENU_PLAY, OnPopupmenuPlay)
	ON_COMMAND(ID_POPUPMENU_PAUSE, OnPopupmenuPause)
	ON_COMMAND(ID_POPUPMENU_STOP, OnPopupmenuStop)
	ON_COMMAND(ID_POPUPMENU_ABOUT, OnPopupmenuAbout)
	ON_COMMAND(ID_POPUPMENU_NEXT, OnPopupmenuNext)
	ON_COMMAND(ID_POPUPMENU_PREVIOUS, OnPopupmenuPrevious)
	ON_COMMAND(ID_POPUPMENU_EQUALIZER, OnPopupmenuEqualizer)
	ON_COMMAND(ID_POPUPMENU_PLAYLISTEDITOR, OnPopupmenuPlaylisteditor)
	ON_COMMAND(ID_POPUPMENU_SEEK, OnPopupmenuSeek)
	ON_COMMAND(ID_POPUPMENU_OPENFOLDER, OnPopupmenuOpenfolder)
	ON_COMMAND(ID_POPUPMENU_FILEINFO, OnPopupmenuFileinfo)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_FILEINFO, OnUpdatePopupmenuFileinfo)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_REPEAT, OnUpdatePopupmenuSettingsRepeat)
	ON_COMMAND(ID_POPUPMENU_SETTINGS_REPEATTRACK, OnPopupmenuSettingsRepeattrack)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_REPEATTRACK, OnUpdatePopupmenuSettingsRepeattrack)
	ON_WM_ENDSESSION()
	ON_COMMAND(ID_POPUPMENU_SETTINGS_REPEAT, OnPopupmenuSettingsRepeat)
	ON_COMMAND(ID_POPUPMENU_SETTINGS_ADVANCED, OnPopupmenuSettingsAdvanced)
	ON_COMMAND(ID_POPUPMENU_SETTINGS_SHUFFLEMODE, OnPopupmenuSettingsShufflemode)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_SHUFFLEMODE, OnUpdatePopupmenuSettingsShufflemode)
	ON_WM_COPYDATA()
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_EQUALIZER, OnUpdatePopupmenuEqualizer)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_PLAYLISTEDITOR, OnUpdatePopupmenuPlaylisteditor)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SEEK, OnUpdatePopupmenuSeek)
	ON_WM_CLOSE()
	ON_COMMAND(ID_POPUPMENU_ELAPSEDTIME, OnPopupmenuElapsedtime)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_ELAPSEDTIME, OnUpdatePopupmenuElapsedtime)
	ON_COMMAND(ID_POPUPMENU_REMAININGTIME, OnPopupmenuRemainingtime)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_REMAININGTIME, OnUpdatePopupmenuRemainingtime)
	ON_COMMAND(ID_POPUPMENU_SETTINGS_RANDOMLYSELECTFIRSTTRACK, OnPopupmenuSettingsRandomlyselectfirsttrack)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_RANDOMLYSELECTFIRSTTRACK, OnUpdatePopupmenuSettingsRandomlyselectfirsttrack)
	ON_COMMAND(ID_POPUPMENU_FILENAME, OnPopupmenuFilename)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_FILENAME, OnUpdatePopupmenuFilename)
	ON_COMMAND(ID_POPUPMENU_TITLE, OnPopupmenuTitle)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_TITLE, OnUpdatePopupmenuTitle)
	ON_COMMAND(ID_POPUPMENU_ARTISTTITLE, OnPopupmenuArtisttitle)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_ARTISTTITLE, OnUpdatePopupmenuArtisttitle)
//	ON_COMMAND(ID_POPUPMENU_CDBAR, OnPopupmenuCdbar)
//	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_CDBAR, OnUpdatePopupmenuCdbar)
	ON_COMMAND(ID_POPUPMENU_EJECTDISK, OnPopupmenuEjectdisk)
	ON_COMMAND(ID_POPUPMENU_CDDB, OnPopupmenuCddb)
//	ON_COMMAND(ID_POPUPMENU_DISK_PLAYLIST, OnPopupmenuDiskPlaylist)
//	ON_COMMAND(ID_POPUPMENU_PLAY_STARTCD, OnPopupmenuPlayStartcd)
//	ON_COMMAND(ID_POPUPMENU_PLAY_ENDCDMODE, OnPopupmenuPlayEndcdmode)
	ON_COMMAND(ID_POPUPMENU_OPEN_URL, OnPopupmenuOpenUrl)
	ON_COMMAND(ID_POPUPMENU_SETTINGS_AFTERENDOFTHEPLAYBACK_EXITSTP, OnPopupmenuSettingsAfterendoftheplaybackExitstp)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_AFTERENDOFTHEPLAYBACK_EXITSTP, OnUpdatePopupmenuSettingsAfterendoftheplaybackExitstp)
	ON_COMMAND(ID_POPUPMENU_SETTINGS_AFTERENDOFTHEPLAYBACK_TURNOFFTHECOMPUTER, OnPopupmenuSettingsAfterendoftheplaybackTurnoffthecomputer)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_AFTERENDOFTHEPLAYBACK_TURNOFFTHECOMPUTER, OnUpdatePopupmenuSettingsAfterendoftheplaybackTurnoff)
	ON_WM_TIMER()
	ON_COMMAND(ID_POPUPMENU_SHOW_TOTALTRACKTIME, OnPopupmenuShowTotaltracktime)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SHOW_TOTALTRACKTIME, OnUpdatePopupmenuShowTotaltracktime)
	ON_COMMAND(ID_POPUPMENU_SETTINGS_STOPAFTEREACHALBUM, OnPopupmenuSettingsStopaftereachalbum)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_SETTINGS_STOPAFTEREACHALBUM, OnUpdatePopupmenuSettingsStopaftereachalbum)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_DISK_PLAYLIST, OnUpdatePopupmenuDiskPlaylist)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_CDDB, OnUpdatePopupmenuCddb)
	ON_COMMAND(ID_POPUPMENU_DISK_LOADDISK, OnPopupmenuDiskLoaddisk)
	ON_COMMAND(ID_AUTOMATION_SETUP, OnAutomationSetup)
	ON_COMMAND(ID_AUTOMATION_PERFORMNOW, OnAutomationPerformnow)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDM_RECENT_FILES,IDM_RECENT_FILES+9,OnPopupmenuOpenRecent)
	ON_COMMAND_RANGE(IDM_TRACKS,IDM_TRACKS+9000,OnTrackMenu)
	ON_COMMAND_RANGE(IDM_DRIVES,IDM_DRIVES+25,OnDrivesMenu)
	ON_WM_MEASUREITEM()
	ON_WM_DRAWITEM()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainWnd message handlers

LRESULT CMainWnd::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
// custom messages
	if(message==WM_PLAYOVER)
	{
		GoNext();
		return TRUE;
	}


//  
	if(message==WM_MOUSEWHEEL)
	{
		MessageBox("^_^","STP",MB_OK | MB_ICONWARNING);
	}



// tray messages
	if(message==WM_ICON_NOTIFY)
	{
		if(lParam==WM_MOUSEMOVE)
		{
			GetCursorPos(&CurMousePos);
			Shell_NotifyIcon(NIM_MODIFY,&(nid));
		}
		if(NoClicks==1)
		{
			if(lParam==WM_MOUSEMOVE||lParam==WM_RBUTTONUP||lParam==WM_LBUTTONUP)
			{
				ShowPopup();
				return TRUE;
			}
		} else
		{
			switch(lParam)
			{
				case WM_LBUTTONDOWN:
					lbd=true;
					if(lbs==0&&rbs==0&&PressAndHold<2)
					{
						SetTimer(6,GetDoubleClickTime(),NULL);
					}
					return TRUE;
					break;
				case WM_RBUTTONDOWN:
					rbd=true;
					if(lbs==0&&rbs==0&&PressAndHold<2)
					{
						SetTimer(7,GetDoubleClickTime(),NULL);
					}
					return TRUE;
					break;
				case WM_RBUTTONUP:
					if(rbd||rbs>0)
					{
						KillTimer(1);KillTimer(2);KillTimer(6);KillTimer(7);
						if(!TraySeeking)
						{
							if(rbs==0&&RClicks2==0&&RClicks3==0&&RClicks4==0)
								ClickAction(RClicks1);
							else
							{
								rbs++;
								SetTimer(2,GetDoubleClickTime(),NULL);
							}
						}
						TraySeeking=false;
						rbd=false;
					}
					return TRUE;
					break;
				case WM_LBUTTONUP:
					if(lbd||lbs>0)
					{
						KillTimer(1);KillTimer(2);KillTimer(6);KillTimer(7);
						if(!TraySeeking)
						{
							if(lbs==0&&Clicks2==0&&Clicks3==0&&Clicks4==0)
								ClickAction(Clicks1);
							else
							{
								lbs++;
								SetTimer(1,GetDoubleClickTime(),NULL);
							}
						}
						TraySeeking=false;
						lbd=false;
					}
					return TRUE;
					break;
			}
		}
	}

// mci notify message (for cd)
	if(message==MM_MCINOTIFY)
	{
		if(wParam==MCI_NOTIFY_SUCCESSFUL)
		{
			CString buf;
			char buf2[64];

			if(m_RepeatTrack)
			{
				int q=CurrentCD;
				mciSendString("status stp number of tracks",buf2,64,NULL);
				if(GapBtwTracks>0)
					Sleep(GapBtwTracks);
				if(q<atoi(buf2))
					buf.Format("play stp from %d to %d notify",q,q+1);
				else
					buf.Format("play stp from %d notify",q);
				mciSendString(buf,NULL,0,m_hWnd);
				Notified=true;
				UpdMBTRCD();
				return TRUE;
			}

			if(ShuffleMode)
			{
				int q=CurrentCD;
				mciSendString("status stp number of tracks",buf2,64,NULL);
				int i=NextRandCD(q,atoi(buf2),true);
				if(GapBtwTracks>0)
					Sleep(GapBtwTracks);
				CurrentCD=i;
				if(i<atoi(buf2))
					buf.Format("play stp from %d to %d notify",i,i+1);
				else
					buf.Format("play stp from %d notify",i);
				mciSendString(buf,NULL,0,m_hWnd);
				Notified=true;
				UpdMBTRCD();
				return TRUE;
			}

			int q=CurrentCD;
			mciSendString("status stp number of tracks",buf2,64,NULL);
			q=NextOrderCD(q,true);
			if(q<=atoi(buf2)&&q>0)
			{
				if(GapBtwTracks>0)
					Sleep(GapBtwTracks);
				CurrentCD=q;
				if(q<atoi(buf2))
					buf.Format("play stp from %d to %d notify",q,q+1);
				else
					buf.Format("play stp from %d notify",q);
				mciSendString(buf,NULL,0,m_hWnd);
				
				Notified=true;
				UpdMBTRCD();
				return TRUE;
			}

			if(m_Repeat)
			{
				if(GapBtwTracks>0)
					Sleep(GapBtwTracks);
				mciSendString("close stp",NULL,0,NULL);
				mciSendString(CDOpenString, NULL, 0, NULL);
				mciSendString("set stp time format tmsf",NULL,0,NULL);
				char buf2[64];
				mciSendString("status stp number of tracks",buf2,64,NULL);
				if(atoi(buf2)>1)
				{
					int q=NextOrderCD(-1,true);
					CurrentCD=q;
					CString buf;
					buf.Format("play stp from %d to %d notify",q,q+1);
					mciSendString(buf, NULL, 0, m_hWnd);
				}
				else
				{
					CurrentCD=1;
					mciSendString("play stp from 1 notify", NULL, 0, m_hWnd);
				}
				Notified=true;
				UpdMBTRCD();
				return TRUE;
			}
			//mciSendString("close stp",NULL,0,NULL);
			CDStatus=CDSTOPPED;
			UpdMBTRCD();
			TryToEnd();
		} else
		if(wParam==MCI_NOTIFY_FAILURE)
		{
				char buf2[64];
				mciSendString("status stp media present",buf2,64,NULL);
				CString buf=buf2;
				if(buf.CompareNoCase("false")==0)
				{
					CDStatus=CDSTOPPED;
					UpdMBTRCD();
				} else
				{
					CString buf,buf3;
					mciSendString("status stp position",buf2,64,NULL);
					buf=buf3=buf2;
					int q=atoi(buf.Left(buf.Find(':')));
					mciSendString("status stp number of tracks",buf2,64,NULL);
					if(q<atoi(buf2))
						buf.Format("play stp from %s to %d notify",buf,q+1);
					else
						buf.Format("play stp from %s notify",buf3);
					mciSendString(buf,NULL,0,m_hWnd);
				}
		}
		return TRUE;
	}

// hotkeys
	if(message==WM_HOTKEY)
	{
		if(!CDMode)
		{
			switch((int)wParam)
			{
				case 101:
					{
						if(PlayListLength>0)
						{
							switch (m_Player.PlayerMode()) {
							  case pmClosed:
								m_Player.InitStream();
								SetOut();
								m_Player.Play();
								break;
							  case pmPaused:
								m_Player.Resume();
								break;
							  case pmPlaying:
								m_Player.Pause();
								break;
							}
							UpdMBTR();
						}
						break;
					}
				case 102:
					OnPopupmenuStop();break;
				case 103:
					OnPopupmenuPrevious();break;
				case 104:
					OnPopupmenuNext();break;
				case 201:
					UnregisterHotKey(m_hWnd, 201);
					CurrentVolume+=5;
					if(CurrentVolume>100)CurrentVolume=100;
					pVolume->SetCurrentVolume(CurrentVolume);
					if(SeekDialog!=NULL) SeekDialog->m_vol.SetPos(CurrentVolume);
					RegisterHotKey(m_hWnd, 201, m_VUpMod, m_VUpKey);
					break;
				case 202:
					UnregisterHotKey(m_hWnd, 202);
					CurrentVolume-=5;
					if(CurrentVolume<0)CurrentVolume=0;
					pVolume->SetCurrentVolume(CurrentVolume);
					if(SeekDialog!=NULL) SeekDialog->m_vol.SetPos(CurrentVolume);
					RegisterHotKey(m_hWnd, 202, m_VDownMod, m_VDownKey);
					break;
				case 301:
					::SetForegroundWindow(m_hWnd);
					OnPopupmenuOpenFile();
					break;
				case 302:
					::SetForegroundWindow(m_hWnd);
					OnPopupmenuOpenfolder();
					break;
				case 303:
					OnPopupmenuOpenUrl();
					break;
				case 401:
					if(ShuffleMode==1) ShuffleMode=0; else ShuffleMode=1;
					break;
				case 1601:
					if(AlbumStop==1) AlbumStop=0; else AlbumStop=1;
					break;
				case 501:
					::SetForegroundWindow(m_hWnd);
					OnPopupmenuSeek();
					break;
				case 601:
					::SetForegroundWindow(m_hWnd);
					OnPopupmenuEqualizer();
					break;
				case 701:
					if(m_Repeat==0&&m_RepeatTrack==0) m_Repeat=1;
					else if(m_Repeat==1&&m_RepeatTrack==0) {m_Repeat=0;m_RepeatTrack=1;}
					else if(m_Repeat==0&&m_RepeatTrack==1) m_RepeatTrack=0;
					break;
				case 801:
					::SetForegroundWindow(m_hWnd);
					OnPopupmenuPlaylisteditor();
					break;
				case 901:
					if(PlayListLength>0)
					{
						::SetForegroundWindow(m_hWnd);
						OnPopupmenuFileinfo();
					}
					break;
				case 1001:
					Finish();
					DestroyWindow();	
					AfxPostQuitMessage(0);
					break;
				case 1201:
					if (OpenClipboard())
					{
						if(EmptyClipboard())
						{
							HANDLE hData;
							hData = GlobalAlloc(GHND, ForNP.GetLength()+5);
							LPTSTR pData;
							pData=(LPTSTR) GlobalLock(hData);
							lstrcpy((LPTSTR)pData, "np: "+ForNP);
							GlobalUnlock(hData);
							if(::SetClipboardData( CF_TEXT, hData )==NULL)
							{
								GlobalFree(hData);
							}
						}
						CloseClipboard();
					}
					break;
				case 1301:
						UnregisterHotKey(m_hWnd, 1301);
						if(PlayListLength>0&&m_Player.CanSetPos()) m_Player.SetPos(m_Player.GetPos()/10/TrackDurI+1);
						UpdMBTR();
						RegisterHotKey(m_hWnd, 1301, m_ForwMod, m_ForwKey);
					break;
				case 1302:
						UnregisterHotKey(m_hWnd, 1302);
						if(PlayListLength>0&&m_Player.CanSetPos()) m_Player.SetPos(m_Player.GetPos()/10/TrackDurI-1);
						UpdMBTR();
						RegisterHotKey(m_hWnd, 1302, m_BackMod, m_BackKey);
					break;
				case 1401:
						if(IconShown)
						{
							Shell_NotifyIcon(NIM_DELETE,&nid);
							IconShown=false;
						} else
						{
							Shell_NotifyIcon(NIM_ADD,&nid);
							IconShown=true;
						}
					break;
				case 1501:
						ShowPopup(1);
					break;
				case 1502:
						ShowTracksMenu(1);
					break;
				case 1503:
						ShowTracksMenu(1,true);
					break;
				case 1701:
					PerformAutomation();
					if(AutSaveset)
						SaveSettings();
					break;
				case 1802:
					if(JeltiySeek!=1)
					{
						JeltiySeek=1;
					}else
					{
							JeltiySeek=0;
						}
					break;



			}
		} else
		{
			switch((int)wParam)
			{
				case 101:
					{
						if(CDStatus==CDPLAYING)
						{
							mciSendString("pause stp", NULL, 0, NULL);	
							CDStatus=CDPAUSED;
							UpdMBTRCD();
						}
						else
						if(CDStatus==CDPAUSED)
						{
							CString buf,buf3;
							char buf2[64];
							mciSendString("status stp position",buf2,64,NULL);
							buf=buf3=buf2;
							int q=atoi(buf.Left(buf.Find(':')));
							mciSendString("status stp number of tracks",buf2,64,NULL);
							if(q<atoi(buf2))
								buf.Format("play stp from %s to %d notify",buf,q+1);
							else
								buf.Format("play stp from %s notify",buf3);
							mciSendString(buf,NULL,0,m_hWnd);
							CDStatus=CDPLAYING;
							UpdMBTRCD();
						}
						else
						if(CDStatus==CDSTOPPED)
						{
							mciSendString("close stp",NULL,0,NULL);
							mciSendString(CDOpenString, NULL, 0, NULL);
							mciSendString("set stp time format tmsf",NULL,0,NULL);
							int i;
							char buf2[64];
							CString buf;
							mciSendString("status stp number of tracks",buf2,64,NULL);
							if(ShuffleMode)
							{
								i=NextRandCD(0,atoi(buf2),true);
							} else
							{
								i=NextOrderCD(-1,true);
							}
							CurrentCD=i;
							if(i<atoi(buf2))
								buf.Format("play stp from %d to %d notify",i,i+1);
							else
								buf.Format("play stp from %d notify",i);

							if(!mciSendString(buf, NULL, 0, m_hWnd))
							{
								CDStatus=CDPLAYING;
								Notified=true;
								UpdMBTRCD();
							}
							UpdMBTRCD();
						}
						break;
					}
				case 102:
					OnPopupmenuStop();break;
				case 103:
					OnPopupmenuPrevious();break;
				case 104:
					OnPopupmenuNext();break;
				case 201:
					UnregisterHotKey(m_hWnd, 201);
					CurrentVolume+=5;
					if(CurrentVolume>100)CurrentVolume=100;
					pVolume->SetCurrentVolume(CurrentVolume);
//					if(CDBar!=NULL) CDBar->m_vol.SetPos(CurrentVolume);
					RegisterHotKey(m_hWnd, 201, m_VUpMod, m_VUpKey);
					break;
				case 202:
					UnregisterHotKey(m_hWnd, 202);
					CurrentVolume-=5;
					if(CurrentVolume<0)CurrentVolume=0;
					pVolume->SetCurrentVolume(CurrentVolume);
//					if(CDBar!=NULL) CDBar->m_vol.SetPos(CurrentVolume);
					RegisterHotKey(m_hWnd, 202, m_VDownMod, m_VDownKey);
					break;
				case 301:
					::SetForegroundWindow(m_hWnd);
					OnPopupmenuOpenFile();
					break;
				case 302:
					::SetForegroundWindow(m_hWnd);
					OnPopupmenuOpenfolder();
					break;
				case 303:
					::SetForegroundWindow(m_hWnd);
					OnPopupmenuOpenUrl();
					break;
				case 401:
					if(ShuffleMode==1) ShuffleMode=0; else ShuffleMode=1;
					break;
				case 701:
					if(m_Repeat==0&&m_RepeatTrack==0) m_Repeat=1;
					else if(m_Repeat==1&&m_RepeatTrack==0) {m_Repeat=0;m_RepeatTrack=1;}
					else if(m_Repeat==0&&m_RepeatTrack==1) m_RepeatTrack=0;
					break;
				case 1001:
					Finish();
					DestroyWindow();	
					AfxPostQuitMessage(0);
					break;
				case 1201:
					if (OpenClipboard())
					{
						if(EmptyClipboard())
						{
							HANDLE hData;
							hData = GlobalAlloc(GHND, ForNP.GetLength()+5);
							LPTSTR pData;
							pData=(LPTSTR) GlobalLock(hData);
							lstrcpy((LPTSTR)pData, "np: "+ForNP);
							GlobalUnlock(hData);
							if(::SetClipboardData( CF_TEXT, hData )==NULL)
							{
								GlobalFree(hData);
							}
						}
						CloseClipboard();
					}
					break;
				case 1301:
					{
						UnregisterHotKey(m_hWnd, 1301);
						CString buf,buf1,buf2;
						char buf3[64];
						mciSendString("status stp position",buf3,64,NULL);
						buf=buf3;
						int q=atoi(buf.Left(2));
						buf2.Format("status stp length track %d",q);
						mciSendString(buf2,buf3,64,NULL);
						buf2=buf3;
						int l=atoi(buf2.Left(2))*60+atoi(buf2.Mid(3,2));
						buf=buf.Mid(3,5);
						int p=atoi(buf.Left(2))*60+atoi(buf.Right(2));
						p+=5;if(p>l)p=l;

						mciSendString("status stp number of tracks",buf3,64,NULL);
						if(CurrentCD<atoi(buf3))
							buf.Format("play stp from %d:%d:%d to %d notify",CurrentCD,p/60,p%60,CurrentCD+1);
						else
							buf.Format("play stp from %d:%d:%d notify",CurrentCD,p/60,p%60);
						mciSendString(buf,NULL,0,m_hWnd);
						CDStatus=CDPLAYING;
						Notified=true;
						UpdMBTRCD();
						RegisterHotKey(m_hWnd, 1301, m_ForwMod, m_ForwKey);
					}
					break;
				case 1302:
					{
						UnregisterHotKey(m_hWnd, 1302);
						CString buf,buf1,buf2;
						char buf3[64];
						mciSendString("status stp position",buf3,64,NULL);
						buf=buf3;
						int q=atoi(buf.Left(2));
						buf2.Format("status stp length track %d",q);
						mciSendString(buf2,buf3,64,NULL);
						buf2=buf3;
						int l=atoi(buf2.Left(2))*60+atoi(buf2.Mid(3,2));
						buf=buf.Mid(3,5);
						int p=atoi(buf.Left(2))*60+atoi(buf.Right(2));
						p-=5;if(p<0)p=0;

						mciSendString("status stp number of tracks",buf3,64,NULL);
						if(CurrentCD<atoi(buf3))
							buf.Format("play stp from %d:%d:%d to %d notify",CurrentCD,p/60,p%60,CurrentCD+1);
						else
							buf.Format("play stp from %d:%d:%d notify",CurrentCD,p/60,p%60);
						mciSendString(buf,NULL,0,m_hWnd);
						CDStatus=CDPLAYING;
						Notified=true;
						UpdMBTRCD();
						RegisterHotKey(m_hWnd, 1302, m_BackMod, m_BackKey);
					}
					break;
				case 1401:
						if(IconShown)
						{
							Shell_NotifyIcon(NIM_DELETE,&nid);
							IconShown=false;
						} else
						{
							Shell_NotifyIcon(NIM_ADD,&nid);
							IconShown=true;
						}
					break;
				case 1501:
						ShowCDPopup(1);
					break;
				case 1502:
						ShowCDTracksMenu(1);
					break;
				case 1503:
						ShowCDTracksMenu(1);
					break;
				case 1701:
					PerformAutomation();
					if(AutSaveset)
						SaveSettings();
					break;
			}
		}
	return TRUE;
	}
	return CFrameWnd::WindowProc(message, wParam, lParam);
}

void CMainWnd::OnPopupmenuExit() 
{
Finish();
DestroyWindow();	
AfxPostQuitMessage(0);
}

void CMainWnd::OnPopupmenuOpenFile() 
{
	if(opening) return;
	opening=true;
	// open a file
	CFileDialog dialog(TRUE, 
						"mp3",
						"",
						OFN_ALLOWMULTISELECT |
						OFN_FILEMUSTEXIST |
						OFN_HIDEREADONLY,
						MyLoadString(IDS_OPENFILE));
	char buffer[_MAX_PATH*500+1];
	buffer[0]='\0';
	dialog.m_ofn.lpstrFile=buffer;
	dialog.m_ofn.nMaxFile=_MAX_PATH*500;
	dialog.m_ofn.lpstrInitialDir=LPCTSTR(InitDir);
	int ret;
	ret = dialog.DoModal();
	if (ret == IDOK) {
		POSITION p=dialog.GetStartPosition();
		CString buf;
		bool q=false;
		while(p!=NULL)
		{
			buf=dialog.GetNextPathName(p);
			InitDir=buf.Left(buf.ReverseFind('\\')+1);
			if((buf.Right(4)).CompareNoCase(".M3U")==0||(buf.Right(4)).CompareNoCase(".PLS")==0)
			{
			   // a playlist was selected
				OpenPlaylist(buf,RandomFirst==1,q);
			}
			else
			{
				// a file was selected
				OpenFile(buf,q);
			}
			AddRecent(buf);
			q=true;
		}
	}
	opening=false;
}

void CMainWnd::OnPopupmenuPlay() 
{
		if(PlayListLength==0) return;
		switch (m_Player.PlayerMode()) {
		  case pmPlaying:
			m_Player.Close();
		  case pmClosed:
			m_Player.InitStream();
			SetOut();
			m_Player.Play();
			break;
		  case pmPaused:
			m_Player.Resume();
			break;
		}
		UpdMBTR();
}

void CMainWnd::OnPopupmenuPause() 
{
	if(PlayListLength==0) return;
	switch (m_Player.PlayerMode()) {
	  case pmPaused:
		m_Player.Resume();
		break;
	  case pmPlaying:
		m_Player.Pause();
		break;
	}
	UpdMBTR();
}

void CMainWnd::OnPopupmenuStop() 
{

		if(PlayListLength==0) return;
		switch(m_Player.PlayerMode())
		{
		case pmPaused:
		case pmPlaying:
			m_Player.Close();
			break;
		}
		UpdMBTR();

}

void CMainWnd::OnPopupmenuAbout() 
{
	if(AboutDlg==NULL)
	{
		AboutDlg=new CAboutDlg(IDD_ABOUTR);
		AboutDlg->Create(IDD_ABOUTR,pMainFrame);
	} else AboutDlg->SetFocus();
}

void CMainWnd::OnPopupmenuNext() 
{

		if(PlayListLength<2) return;
		
		int pm=m_Player.PlayerMode();
		m_Player.Close();
		
		UINT q=0;
		do
		{
			q++;
			if(ShuffleMode)
			{
				Current=MyRandom(true);
			}
			else
			{
				int b,e; GetAlbumRange(&b,&e);
				if(Current==e)
					Current=b;
				else
					Current++;
			}
			m_Player.SetInName(PlayList[Current]);
			if(pm==pmPaused||
				pm==pmPlaying)
			{	
				if(!m_Player.InitStream()) continue;
				SetOut();
				m_Player.Play();
			}
			break;
		}
		while(q<PlayListLength*2);
		ReadTag(PlayList[Current]);
		
		UpdMBTR();
		if(PlaylistDlg!=NULL)			
			PlaylistDlg->m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
	
}

void CMainWnd::OnPopupmenuPrevious() 
{
		if(PlayListLength<2) return;
		int pm=m_Player.PlayerMode();
		m_Player.Close();
		UINT q=0;
		do
		{
		q++;
			if(ShuffleMode)
			{
				Current=MyRandom(false);
			}
			else
			{
				int b,e; GetAlbumRange(&b,&e);
				if(Current==b)
					Current=e;
				else
					Current--;
			}
			m_Player.SetInName(PlayList[Current]);
			if(pm==pmPaused||
				pm==pmPlaying)
			{	
				if(!m_Player.InitStream()) continue;
				SetOut();
				m_Player.Play();
			}
			break;
		}
		while(q<PlayListLength*2);
		
		ReadTag(PlayList[Current]);

		UpdMBTR();
		if(PlaylistDlg!=NULL)			
			PlaylistDlg->m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
	
}

void CMainWnd::ReadTag(CString fname)
{
	CString ToReturn=fname;
	
	ToReturn.Replace('_',' ');

	if(ToReturn.Left(7).CompareNoCase("http://")==0||ToReturn.Left(6).CompareNoCase("ftp://")==0)
	{
		ToReturn.Replace("%20"," ");
		int i,j;
		if((i=ToReturn.ReverseFind('.'))>-1)
			if(ToReturn.Mid(i+1,3).CompareNoCase("MP3")==0)
			{
				j=ToReturn.ReverseFind('/');
				ToReturn=ToReturn.Mid(j+1,i-ToReturn.ReverseFind('/')-1);		
			}
		//if(ToReturn.GetLength()>30) ToReturn=ToReturn.Left(30)+"...";
		CurrentFile=CurrentFileLong=CurrentFileName=ToReturn;
		return;
	}
	
	int i;
	i=ToReturn.ReverseFind('.');
	if(i==-1)i=ToReturn.GetLength();
	ToReturn=ToReturn.Left(i);

	i=ToReturn.ReverseFind('\\');
	ToReturn=ToReturn.Mid(i+1);

	//if(ToReturn.GetLength()>30) ToReturn=ToReturn.Left(30)+"...";

	CurrentFileName=ToReturn;

	CFile mpfile;
	if(!mpfile.Open(fname,CFile::modeRead | CFile::shareDenyNone))
	{
		CurrentFile=CurrentFileLong=ToReturn;
		return;
	}

	if(mpfile.GetLength()<129)
	{
		mpfile.Close();
		CurrentFile=CurrentFileLong=ToReturn;
		return;
	}
	mpfile.Seek(-128,CFile::end);

	char buf[31];
	mpfile.Read(buf,3);buf[3]='\0';
	if(strcmp(buf,"TAG"))
	{
		mpfile.Close();
		CurrentFile=CurrentFileLong=ToReturn;
		return;
	}
	mpfile.Read(buf,30);buf[30]='\0';

	ToReturn=buf;
	ToReturn.TrimLeft();ToReturn.TrimRight();
	CurrentFile=ToReturn;

	mpfile.Read(buf,30);buf[30]='\0';
	ToReturn=buf;
	ToReturn.TrimLeft();ToReturn.TrimRight();
	CurrentFileLong=CurrentFile;
	if(ToReturn!="")
		CurrentFileLong=ToReturn+" - "+CurrentFileLong;

	mpfile.Close();
	
	return;
}

void CMainWnd::OnPopupmenuEqualizer() 
{
	if(EqualizerDlg==NULL)
	{
		EqualizerDlg=new CEqualizerDlg(IDD_EQUALIZER_DIALOGR);
		EqualizerDlg->Create(IDD_EQUALIZER_DIALOGR,pMainFrame);
	} else
	{
		EqualizerDlg->SaveWindowPosAndDestroy();
	}
}

void CMainWnd::OnPopupmenuPlaylisteditor() 
{
	if(PlaylistDlg==NULL)
	{
		PlaylistDlg=new CPlaylistDlg(IDD_PLAYLISTR);
		PlaylistDlg->Create(IDD_PLAYLISTR,pMainFrame);
	} else
	{
		PlaylistDlg->SaveWindowPosAndDestroy();
	}
}

void CMainWnd::OnPopupmenuSeek() 
{
	if(SeekDialog==NULL)
	{
		SeekDialog=new CSeekDialog(IDD_SEEK);
		SeekDialog->Create(IDD_SEEK,pMainFrame);
	}
	else
	{
		SeekDialog->SaveWindowPosAndDestroy();
	}
}

void CMainWnd::OpenFile(CString fname, bool Add, bool ForceStart)
{
	int PLLPrev=PlayListLength;
	if(!Add)
	{
		PlayList.RemoveAll();
		PlayListAT.RemoveAll();
		Current=0;
		m_Player.Close();
	}
	PlayList.Add(fname);
	PlayListAT.Add("");
	PlayListLength=PlayList.GetSize();
	if(!Add||PLLPrev==0)
	{
		ReadTag(fname);
		m_Player.SetInName(fname);
		m_Player.InitStream();
		if(AutoPlay||ForceStart)
		{
			SetOut();
			m_Player.Play();
		} else m_Player.Close();
	}
	UpdMBTR();
	if(PlaylistDlg!=NULL)
	{
		PlaylistDlg->FillPlaylist();
		PlaylistDlg->ShowFileName();
	}
}

void CMainWnd::OpenPlaylist(CString fname, bool RandomFirst, bool Add, bool ForceStart)
{
	int PLLPrev=PlayListLength;
	CStdioFile plfile;
	if(!plfile.Open(fname,CFile::modeRead | CFile::shareDenyNone)) return;
	if(!Add)
	{
		PlayList.RemoveAll();
		PlayListAT.RemoveAll();
		Current=0;
		m_Player.Close();
	}

	bool ifpls=((fname.Right(4)).CompareNoCase(".PLS")==0);

	CString buf;
	CString CurPath=fname.Left(fname.ReverseFind('\\')+1);
	CString CurDisk=fname.Left(fname.Find(':')+1);
	while(plfile.ReadString(buf))
	{
		buf.TrimLeft();buf.TrimRight();
		if(buf.Left(4)=="#EXT"||buf=="") continue;
		if(buf.Left(5)=="#TAG="&&PlayListAT.GetSize()>0&&!ifpls)
		{
			PlayListAT[PlayListAT.GetSize()-1]=buf.Mid(5);
//			UpdateTagCache(PlayList[PlayList.GetSize()-1],PlayListAT[PlayListAT.GetSize()-1]);
			continue;
		}
		if(ifpls)
		{
			if(buf.Left(4).CompareNoCase("file")==0)
				buf=buf.Mid(buf.Find('=')+1);
			else
				continue;
		}
		if(buf.Left(7).CompareNoCase("http://")==0||buf.Left(6).CompareNoCase("ftp://")==0)
		{
			buf.Replace(" ","%20");
			PlayList.Add(buf);
			PlayListAT.Add("");
		}
		else
			if(buf[1]==':'||buf[0]=='\\'&&buf[1]=='\\')
			{
			PlayList.Add(buf);
			PlayListAT.Add("");
			}
			else
				if(buf[0]=='\\')
				{
					PlayList.Add(CurDisk+buf);
					PlayListAT.Add("");
				}
				else
				{
					PlayList.Add(CurPath+buf);
					PlayListAT.Add("");
				}
	}
	plfile.Close();
	PlayListLength=PlayList.GetSize();
	if(PlayListLength==0)
	{
		CRect rect;
		if(MP3InfoDlg!=NULL)
		{
			MP3InfoDlg->SaveWindowPosAndDestroy();
		}
		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->FillPlaylist();
			PlaylistDlg->ShowFileName();
		}
		UpdMBTR();
		return;
	}
	if((RandomFirst||ShuffleMode)&&!(Add&&PLLPrev>0))
		FirstInMyRandom=Current=MyRandom(true, true);
	else
		if(!Add||PLLPrev==0){Current=0;FirstInMyRandom=-1;}
	
	if(PlaylistDlg!=NULL)
	{
		PlaylistDlg->FillPlaylist();
		PlaylistDlg->ShowFileName();
	}

	if(!Add||PLLPrev==0)
	{
		bool first=true;
		int q=0;
		do
		{
			if(!first)
			{
				if(Current<PlayListLength-1)
				{
					Current++;
				}
				else
				{
					Current=0;
					q++;
					if(m_Repeat!=1)
						break;
				}
			} else first=false;
			m_Player.SetInName(PlayList[Current]);
			if(!m_Player.InitStream()) continue;
			if(AutoPlay||ForceStart)
			{
				SetOut();
				m_Player.Play();
			} else m_Player.Close();
			break;
		}
		while(q<2);
		ReadTag(PlayList[Current]);
	}
	UpdMBTR();
}

void CMainWnd::OnPopupmenuOpenfolder() 
{
	if(opening) return;
	opening=true;

	LPMALLOC pMalloc;
	if (SHGetMalloc (&pMalloc)!= NOERROR)
		return;

	BROWSEINFO bi;
	char buf[MAX_PATH];
	CString title;
	title=MyLoadString(IDS_OPENFOLDER);
	bi.hwndOwner=m_hWnd;
	bi.pszDisplayName=buf;
	bi.pidlRoot=NULL;
	bi.lpszTitle=LPCTSTR(title);
	bi.ulFlags=BIF_RETURNONLYFSDIRS;
	bi.lpfn=BrowseCallbackProc;

	LPITEMIDLIST pidl;
	if((pidl=SHBrowseForFolder(&bi))==NULL)
	{
		pMalloc->Free(pidl);
		pMalloc ->Release();
		opening=false;
		return;
	}
	if(SHGetPathFromIDList(pidl,buf)==false)
	{	
		pMalloc->Free(pidl);
		pMalloc ->Release();
		opening=false;
		return;
	}
	pMalloc->Free(pidl);
	pMalloc->Release();
	
	opening=false;
	
	AddRecent(buf);
	InitDir=buf;
	OpenFolder(buf,RandomFirst==1);
}

void CMainWnd::FindMP3Files(CString path, bool nodups)
{
	CFileFind finder;
	CString fp,fext;
	BOOL bWorking = finder.FindFile(path+"*.*");
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		fp=finder.GetFilePath();
		fext=fp.Mid(fp.ReverseFind('.')+1,3);fext.MakeUpper();
		if(fext=="MP3"||fext=="WAV"&&IncludeWAVs==1)
			if(finder.GetLength()>0)
			{
				if(nodups)
				{
					bool flag=false;
					for(int i=0;i<PlayList.GetSize();i++)
					{
						if(PlayList[i].CompareNoCase(fp)==0) { flag=true; break;}
					}
					if(flag) continue;
				}
				PlayList.Add(fp);
				PlayListAT.Add("");
				continue;
			}
		if(finder.IsDirectory()&&!finder.IsDots())
			FindMP3Files(fp+"\\", nodups);
	}
}

void CMainWnd::OnPopupmenuFileinfo() 
{
	if(MP3InfoDlg==NULL)
	{
		MP3InfoDlg=new CMP3InfoDlg(IDD_DIALOG_MP3INFOR);
		MP3InfoDlg->Create(IDD_DIALOG_MP3INFOR,pMainFrame);
	}
	else
	{
		MP3InfoDlg->SaveWindowPosAndDestroy();
	}	
}

void CMainWnd::OnUpdatePopupmenuFileinfo(CCmdUI* pCmdUI) 
{
	if(PlayListLength==0)
		pCmdUI->Enable(false);
	else
		pCmdUI->Enable(true);
	if(MP3InfoDlg!=NULL)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainWnd::OnUpdatePopupmenuSettingsRepeat(CCmdUI* pCmdUI) 
{
	if(m_Repeat==1)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
	if(ExitAfterEnd||ShutdownAfterEnd)
		pCmdUI->Enable(false);
	else
		pCmdUI->Enable(true);
}

void CMainWnd::OnPopupmenuSettingsRepeattrack() 
{
	if(m_RepeatTrack==1) m_RepeatTrack=0; else {m_RepeatTrack=1;m_Repeat=0;}	
}

void CMainWnd::OnUpdatePopupmenuSettingsRepeattrack(CCmdUI* pCmdUI) 
{
	if(m_RepeatTrack==1)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
	if(ExitAfterEnd||ShutdownAfterEnd)
		pCmdUI->Enable(false);
	else
		pCmdUI->Enable(true);
}

void CMainWnd::OpenFolder(CString theDir, bool RandomFirst, bool Add, bool ForceStart)
{
	int PLLPrev=PlayListLength;
	if(theDir[theDir.GetLength()-1]!='\\')
		theDir+="\\";

	if(!Add)
	{
		PlayList.RemoveAll();
		PlayListAT.RemoveAll();
		Current=0;
		m_Player.Close();
	}

	FindMP3Files(theDir);	
	
	PlayListLength=PlayList.GetSize();
	if(PlayListLength==0)
	{
		if(MP3InfoDlg!=NULL)
		{
			MP3InfoDlg->SaveWindowPosAndDestroy();
		}
		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->FillPlaylist();
			PlaylistDlg->ShowFileName();
		}
		UpdMBTR();
		return;
	}

	SortRec(Add?PLLPrev:0, PlayListLength-1);
	if((RandomFirst||ShuffleMode)&&!(Add&&PLLPrev>0))
		FirstInMyRandom=Current=MyRandom(true, true);
	else
		if(!Add||PLLPrev==0) {Current=0;FirstInMyRandom=-1;}

	if(PlaylistDlg!=NULL)
	{
		PlaylistDlg->FillPlaylist();
		PlaylistDlg->ShowFileName();
	}

	if(!Add||PLLPrev==0)
	{
		bool first=true;
		int q=0;
		do
		{
			if(!first)
			{
				if(Current<PlayListLength-1)
				{
					Current++;
				}
				else
				{
					Current=0;
					q++;
					if(m_Repeat!=1)
						break;
				}
			} else first=false;
			m_Player.SetInName(PlayList[Current]);
			if(!m_Player.InitStream()) continue;
			if(AutoPlay||ForceStart)
			{
				SetOut();
				m_Player.Play();
			} else m_Player.Close();
			break;
		}
		while(q<2);
		ReadTag(PlayList[Current]);
	}
	UpdMBTR();
}


void CMainWnd::OpenRecent(int num)
{
	if(Recent[num]=="") return;
	if(Recent[num].Left(7).CompareNoCase("http://")==0||Recent[num].Left(6).CompareNoCase("ftp://")==0)
	{
		OpenUrl(Recent[num]);
		return;
	}
	CFileFind(finder);
	if(finder.FindFile(Recent[num]))
	{
		finder.FindNextFile();
		if(finder.IsDirectory())
			OpenFolder(Recent[num],RandomFirst==1);
		else
		{
			if((Recent[num].Mid(Recent[num].ReverseFind('.')+1,3)).CompareNoCase("M3U")==0
			 ||(Recent[num].Mid(Recent[num].ReverseFind('.')+1,3)).CompareNoCase("PLS")==0)
				OpenPlaylist(Recent[num],RandomFirst==1);
			else
				OpenFile(Recent[num]);
		}
		CString buf=Recent[num];
		for(int i=num;i>0;i--)
			Recent[i]=Recent[i-1];
		Recent[0]=buf;
	} else
	{
	for(int i=num;i<9;i++)
		Recent[i]=Recent[i+1];
	Recent[9]="";
	}
}

void CMainWnd::AddRecent(CString fdn)
{
	if(fdn[fdn.GetLength()-1]=='\\')
		fdn=fdn.Left(fdn.GetLength()-1);
	if(fdn[1]==':'&&fdn.GetLength()==2) return;
	int i;
	for(i=0;i<=9;i++)
		if(fdn.CompareNoCase(Recent[i])==0)
		{
			for(int j=i;j>0;j--)
				Recent[j]=Recent[j-1];
			Recent[0]=fdn;
			return;
		}
	for(i=9;i>0;i--)
		Recent[i]=Recent[i-1];
	Recent[0]=fdn;
}

void CMainWnd::OnPopupmenuOpenRecent(UINT nID) 
{
	OpenRecent(nID-IDM_RECENT_FILES);
}

void CMainWnd::OnEndSession(BOOL bEnding) 
{
	CFrameWnd::OnEndSession(bEnding);
	
	if(bEnding) Finish();
}

void CMainWnd::Finish()
{
	CRect rect;
	

	if(AboutDlg!=NULL) AboutDlg->DestroyWindow();
	if(SettingsDialog!=NULL) SettingsDialog->DestroyWindow();

	if(SeekDialog!=NULL)
	{
		SeekDialog->SaveWindowPosAndDestroy();
		theApp.WriteProfileInt(theApp.user,"BarAtStartup",1);
	} else theApp.WriteProfileInt(theApp.user,"BarAtStartup",0);

	if(MP3InfoDlg!=NULL)
	{
		MP3InfoDlg->SaveWindowPosAndDestroy();
	}
	if(PlaylistDlg!=NULL)
	{
		PlaylistDlg->SaveWindowPosAndDestroy();
		theApp.WriteProfileInt(theApp.user,"PlaylistAtStartup",1);
	} else theApp.WriteProfileInt(theApp.user,"PlaylistAtStartup",0);
	if(EqualizerDlg!=NULL)
	{
		EqualizerDlg->SaveWindowPosAndDestroy();
		theApp.WriteProfileInt(theApp.user,"EQAtStartup",1);
	} else theApp.WriteProfileInt(theApp.user,"EQAtStartup",0);


	SaveSettings();


	theApp.WriteProfileInt(theApp.user,"CDMode",0);


	if(WAEmu==1)
		EndWAEmu();

	if(W2Fenabled)
		PerformW2File(true);
	
	Shell_NotifyIcon(NIM_DELETE,&nid);

	DeleteObject(hMenuBitmap);
	DeleteObject(PlayIcon);
	DeleteObject(StopIcon);
	DeleteObject(PauseIcon);
	DeleteObject(StpIcon);
	DeleteObject(StpIconSm);

	m_Player.Close();
	delete pVolume;
}

void CMainWnd::OnPopupmenuSettingsRepeat() 
{
	if(m_Repeat==1) m_Repeat=0; else {m_Repeat=1;m_RepeatTrack=0;}		
}

void CMainWnd::OnPopupmenuSettingsAdvanced() 
{
	if(SettingsDialog==NULL)
	{
		SettingsDialog=new CSettingsDialog(IDD_SETTINGSR);
		SettingsDialog->Create(IDD_SETTINGSR,pMainFrame);
	}
	else SettingsDialog->SetFocus();	
}

void CMainWnd::SaveThePlaylist()
{
	char buf2[MAX_PATH+1];
	GetModuleFileName(theApp.m_hInstance, buf2, MAX_PATH);
	for(int i=strlen(buf2)-1;i>0;i--)
		if(buf2[i]=='.') {buf2[i]='\0';break;}
	CString fname;
	fname=buf2;
	fname+=".m3u";
	CString UserName;
	if(theApp.user=="Preferences")
		UserName="Global";
	else
		UserName=theApp.user.Mid(14);

	CStdioFile plfile;

	CStringArray prev;
	CString buf;
	bool flag=false;
	
	if(plfile.Open(fname,CFile::modeRead | CFile::shareDenyNone))
	{
		while(plfile.ReadString(buf))
		{
			buf.TrimLeft();buf.TrimRight();
			if(buf[0]=='[')
			{
				flag=(buf.CompareNoCase("["+UserName+"]")==0);
			}
			if(!flag)
				prev.Add(buf);
		}
		plfile.Close();
	}
	
	if(plfile.Open(fname,CFile::modeCreate | CFile::modeWrite))
	{
		unsigned int i,ps=prev.GetSize();
		for(i=0;i<ps;i++)
			plfile.WriteString(prev[i]+"\n");
		plfile.WriteString("["+UserName+"]\n");
		for(i=0;i<PlayListLength;i++)
		{
			plfile.WriteString(PlayList[i]+"\n");
			if(PlayListAT[i]!="")
				plfile.WriteString("#TAG="+PlayListAT[i]+"\n");
		}
		plfile.Close();
		theApp.WriteProfileInt(theApp.user,"CurrentInPlaylist",Current);
	}
}

void CMainWnd::LoadThePlaylist(bool DontStart)
{
	char buf2[MAX_PATH+1];
	GetModuleFileName(theApp.m_hInstance, buf2, MAX_PATH);
	for(int i=strlen(buf2)-1;i>0;i--)
		if(buf2[i]=='.') {buf2[i]='\0';break;}
	CString fname=buf2;
	fname+=".m3u";
	CString UserName;
	if(theApp.user=="Preferences")
		UserName="Global";
	else
		UserName=theApp.user.Mid(14);

	int FixedFirst=theApp.GetProfileInt(theApp.user,"CurrentInPlaylist",0);
	CStdioFile plfile;
	if(!plfile.Open(fname,CFile::modeRead | CFile::shareDenyNone)) return;

	CString buf;
	bool flag=false;
	while(plfile.ReadString(buf))
	{
		buf.TrimLeft();buf.TrimRight();
		if(buf[0]=='[')
		{
			if(flag)
				break;
			else
			{
				if(buf.CompareNoCase("["+UserName+"]")==0)
					flag=true;
				continue;
			}		
		}
		if(!flag) continue;

		if(buf.Left(5)=="#TAG="&&PlayListAT.GetSize()>0)
		{
			PlayListAT[PlayListAT.GetSize()-1]=buf.Mid(5);
//			UpdateTagCache(PlayList[PlayList.GetSize()-1],PlayListAT[PlayListAT.GetSize()-1]);
			continue;
		}
		if(buf.Left(7).CompareNoCase("http://")==0||buf.Left(6).CompareNoCase("ftp://")==0)
		{
			buf.Replace(" ","%20");
			PlayList.Add(buf);
			PlayListAT.Add("");
		}
		else
		{
			PlayList.Add(buf);
			PlayListAT.Add("");
		}
	}
	plfile.Close();
	PlayListLength=PlayList.GetSize();
	if(PlayListLength==0)
	{
//		UpdMBTR();
		return;
	}
	if(RandomFirst||ShuffleMode)
		FirstInMyRandom=Current=MyRandom(true, true);
	else
		Current=FixedFirst<PlayListLength?FixedFirst:0;

	
	if(PlaylistDlg!=NULL)
	{
		PlaylistDlg->FillPlaylist();
		PlaylistDlg->ShowFileName();
	}
//	ReadAllTags();

	m_Player.Close();

	bool first=true;
	int q=0;
	do
	{
		if(!first)
		{
			if(Current<PlayListLength-1)
			{
				Current++;
			}
			else
			{
				Current=0;
				q++;
				if(m_Repeat!=1)
					break;
			}
		} else first=false;
		m_Player.SetInName(PlayList[Current]);
		if(!m_Player.InitStream()) continue;
		if(AutoPlay&&!DontStart)
		{
			SetOut();
			m_Player.Play();
		} else m_Player.Close();
		break;
	}
	while(q<2);
	ReadTag(PlayList[Current]);

	UpdMBTR();
}

CString CMainWnd::GetWavFromMP3(CString MP3Name)
{
	CString buf;
	buf=MP3Name.Left(MP3Name.ReverseFind('.')+1)+"wav";
	return OutPath+buf.Mid(buf.ReverseFind('\\')+1);
}

void CMainWnd::OnTrackMenu(UINT nID) 
{
		Current=nID-IDM_TRACKS;
		m_Player.Close();
		bool first=true;		
		UINT q=0;
		do
		{
			q++;
			if(!first)
			{
				if(ShuffleMode)
				{
					Current=MyRandom(true);
				}
				else
				{
					int b,e; GetAlbumRange(&b,&e);
					if(Current==e)
						Current=b;
					else
						Current++;
				}
			} else first=false;
			m_Player.SetInName(PlayList[Current]);
			if(!m_Player.InitStream()) continue;
			SetOut();
			m_Player.Play();
			break;
		}
		while(q<PlayListLength*2);
		ReadTag(PlayList[Current]);
		
		UpdMBTR();

		if(PlaylistDlg!=NULL)			
			PlaylistDlg->m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
	
}

CString CMainWnd::ReplaceAmpersand(CString s)
{
	s.Replace("&","&&");
	return s;
}

void CMainWnd::ShowPopup(int MenuType)
{
	CMenu menu;
	CMenu* pPopup;
	menu.LoadMenu(IDR_MENUR);
	POINT point;
	switch(MenuType)
	{
	case 0:
		point=CurMousePos; break;
	case 1:
		GetPosForMenu(&point); break;
	case 2:
		GetCursorPos(&point); break;
	}
	pPopup = menu.GetSubMenu(0);

	CMenu *pTempMenu;

	pTempMenu=pPopup->GetSubMenu(6)->GetSubMenu(3);
	pTempMenu->DeleteMenu(0,MF_BYPOSITION);

	int i,j,k; CString rbuf;
	for(i=0;i<10;i++)
	{
		if(Recent[i]!="")
		{
			rbuf=Recent[i];
			if(rbuf.GetLength()>40)
			{
				j=1+rbuf.ReverseFind('\\')+rbuf.ReverseFind('/');
				k=j>20?18:j-3; if(k<0) k=0;
				rbuf=rbuf.Left(k)+"....."+rbuf.Mid(j);
			}
			pTempMenu->AppendMenu(MF_STRING,IDM_RECENT_FILES+i,ReplaceAmpersand(rbuf));
		}
	}

	pTempMenu=pPopup->GetSubMenu(6)->GetSubMenu(4);
	pTempMenu->DeleteMenu(0,MF_BYPOSITION);
	CString CDLetter;
	UINT dt;
	for (char c='C';c<='Z';c++)
	{
		CDLetter.Format("%c",c);
		dt=::GetDriveType(CDLetter+":\\");
		if (dt==DRIVE_REMOVABLE||dt==DRIVE_FIXED||dt==DRIVE_REMOTE||dt==DRIVE_CDROM)
		{
			pTempMenu->AppendMenu(MF_STRING,IDM_DRIVES+(UINT)(c-'C'),CDLetter);
		}
    }

	if(PlayListLength>0&&PlayListLength<10001)
	{
		if(SMAlbum)
		{
			pTempMenu=pPopup->GetSubMenu(8);
			pTempMenu->DeleteMenu(0,MF_BYPOSITION);
			BuildAlbumMenu(pTempMenu->m_hMenu);
		} else pPopup->DeleteMenu(8,MF_BYPOSITION);
		if(SMTracks)
		{
			pTempMenu=pPopup->GetSubMenu(7);
			pTempMenu->DeleteMenu(0,MF_BYPOSITION);
			BuildMenu(pTempMenu->m_hMenu);
		} else pPopup->DeleteMenu(7,MF_BYPOSITION);
	} else
	{
		pPopup->DeleteMenu(8,MF_BYPOSITION);
		pPopup->DeleteMenu(7,MF_BYPOSITION);
	}

	if(MenuType<2)
	{


		pPopup->DeleteMenu(pPopup->GetMenuItemCount()-1, MF_BYPOSITION);

		SetForegroundWindow();
		pPopup->TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
				point.x, point.y,
				this);
		PostMessage(WM_NULL, 0, 0);
	}
	else
	{

		//pPopup->DeleteMenu(pPopup->GetMenuItemCount()-1, MF_BYPOSITION);
		//pPopup->DeleteMenu(0,MF_BYPOSITION);

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
				point.x, point.y+6,
				this);

	}
	menu.DestroyMenu();
}


void CMainWnd::OnPopupmenuSettingsShufflemode() 
{
	if(ShuffleMode==1) ShuffleMode=0; else ShuffleMode=1;
}

void CMainWnd::OnUpdatePopupmenuSettingsShufflemode(CCmdUI* pCmdUI) 
{
	if(ShuffleMode==1)
		pCmdUI->SetCheck(1);	
	else
		pCmdUI->SetCheck(0);
}

BOOL CMainWnd::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pData) 
{
	if(Created && pData->cbData == sizeof( MsgCmd ))
	{
		MsgCmd cmd;
        memcpy( &cmd, pData->lpData, sizeof( MsgCmd ) );
		
		KillTimer(3);
		
		CFileFind finder;
		bool Add=false,CD=false;
		switch(cmd.command)
		{
			case 1:Add=true;break;
			case 2:CD=true;break;
		}

		CString buf=cmd.fname;
		if(buf.GetLength()==3&&buf[1]==':')
		{
			OpenFolder(buf.Left(2)+'\\', RandomFirst==1,Add||AddFromExp,!(Add||AddFromExp));
		}
		else
		if(finder.FindFile(buf))
		{
			finder.FindNextFile();
			if(finder.IsDirectory())
			{
				OpenFolder(buf, RandomFirst==1,Add||AddFromExp,!(Add||AddFromExp));
			}
			else
			{
				if((buf.Mid(buf.ReverseFind('.')+1,3)).CompareNoCase("M3U")==0||(buf.Mid(buf.ReverseFind('.')+1,3)).CompareNoCase("PLS")==0)
				{
					OpenPlaylist(buf, RandomFirst==1,Add||AddFromExp,!(Add||AddFromExp));
				}
				else
				{
					OpenFile(buf,Add||AddFromExp,!(Add||AddFromExp));
				}
			}
			AddRecent(buf);
			AddFromExp=true;
			SetTimer(3,(DWORD)2000,NULL);
		}
		return TRUE;
	} else return FALSE;
}

void CMainWnd::Start()
{
	struct CmdLineStruct {
		CString fname;
		bool AddFlag;
		bool CDFlag;
		bool DefSetFlag;
	} CmdLine;
	CmdLine.fname="";
	CmdLine.AddFlag=false;
	CmdLine.CDFlag=false;
	CmdLine.DefSetFlag=false;

	for (int i = 1; i < __argc; i++)
	{
		LPCTSTR pszParam = __targv[i];
		BOOL bFlag = FALSE;
		if (pszParam[0] == '-')
		{
			// remove flag specifier
			bFlag = TRUE;
			pszParam++;
		}
		if(bFlag)
		{
			if (lstrcmpA(pszParam, "a") == 0)
				CmdLine.AddFlag=true;
			else if (lstrcmpA(pszParam, "c") == 0)
				CmdLine.CDFlag=true;
			else if (lstrcmpA(pszParam, "g") == 0)
				CmdLine.DefSetFlag=true;
		} else
		{
			if(CmdLine.fname=="") CmdLine.fname=pszParam;
		}
	}
	
	theApp.user="Preferences";

	if(!CmdLine.DefSetFlag) 
	{
		char uname[256];
		DWORD w=256;
		if(::GetUserName(uname,&w))
		{
			theApp.user+=" - ";
			theApp.user+=uname;
		}
	}

    genres.Add("Blues");
    genres.Add("Classic Rock");
    genres.Add("Country");
    genres.Add("Dance");
    genres.Add("Disco");
    genres.Add("Funk");
    genres.Add("Grunge");
    genres.Add("Hip-Hop");
    genres.Add("Jazz");
    genres.Add("Metal");
    genres.Add("New Age");
    genres.Add("Oldies");
    genres.Add("Other");
    genres.Add("Pop");
    genres.Add("R&B");
    genres.Add("Rap");
    genres.Add("Reggae");
    genres.Add("Rock");
    genres.Add("Techno");
    genres.Add("Industrial");
    genres.Add("Alternative");
    genres.Add("Ska");
    genres.Add("Death Metal");
    genres.Add("Pranks");
    genres.Add("Soundtrack");
    genres.Add("Euro-Techno");
    genres.Add("Ambient");
    genres.Add("Trip-Hop");
    genres.Add("Vocal");
    genres.Add("Jazz+Funk");
    genres.Add("Fusion");
    genres.Add("Trance");
    genres.Add("Classical");
    genres.Add("Instrumental");
    genres.Add("Acid");
    genres.Add("House");
    genres.Add("Game");
    genres.Add("Sound Clip");
    genres.Add("Gospel");
    genres.Add("Noise");
    genres.Add("Alt. Rock");
    genres.Add("Bass");
    genres.Add("Soul");
    genres.Add("Punk");
    genres.Add("Space");
    genres.Add("Meditative");
    genres.Add("Instrumental Pop");
    genres.Add("Instrumental Rock");
    genres.Add("Ethnic");
    genres.Add("Gothic");
    genres.Add("Darkwave");
    genres.Add("Techno-Industrial");
    genres.Add("Electronic");
    genres.Add("Pop-Folk");
    genres.Add("Eurodance");
    genres.Add("Dream");
    genres.Add("Southern Rock");
    genres.Add("Comedy");
    genres.Add("Cult");
    genres.Add("Gangsta Rap");
    genres.Add("Top 40");
    genres.Add("Christian Rap");
    genres.Add("Pop/Funk");
    genres.Add("Jungle");
    genres.Add("Native American");
    genres.Add("Cabaret");
    genres.Add("New Wave");
    genres.Add("Psychedelic");
    genres.Add("Rave");
    genres.Add("Showtunes");
    genres.Add("Trailer");
    genres.Add("Lo-Fi");
    genres.Add("Tribal");
    genres.Add("Acid Punk");
    genres.Add("Acid Jazz");
    genres.Add("Polka");
    genres.Add("Retro");
    genres.Add("Musical");
    genres.Add("Rock & Roll");
    genres.Add("Hard Rock");
    genres.Add("Folk");
    genres.Add("Folk/Rock");
    genres.Add("National Folk");
    genres.Add("Swing");
    genres.Add("Fast-Fusion");
    genres.Add("Bebob");
    genres.Add("Latin");
    genres.Add("Revival");
    genres.Add("Celtic");
    genres.Add("Bluegrass");
    genres.Add("Avantgarde");
    genres.Add("Gothic Rock");
    genres.Add("Progressive Rock");
    genres.Add("Psychedelic Rock");
    genres.Add("Symphonic Rock");
    genres.Add("Slow Rock");
    genres.Add("Big Band");
    genres.Add("Chorus");
    genres.Add("Easy Listening");
    genres.Add("Acoustic");
    genres.Add("Humour");
    genres.Add("Speech");
    genres.Add("Chanson");
    genres.Add("Opera");
    genres.Add("Chamber Music");
    genres.Add("Sonata");
    genres.Add("Symphony");
    genres.Add("Booty Bass");
    genres.Add("Primus");
    genres.Add("Porn Groove");
    genres.Add("Satire");
    genres.Add("Slow Jam");
    genres.Add("Club");
    genres.Add("Tango");
    genres.Add("Samba");
    genres.Add("Folklore");
    genres.Add("Ballad");
    genres.Add("Power Ballad");
    genres.Add("Rhythmic Soul");
    genres.Add("Freestyle");
    genres.Add("Duet");
    genres.Add("Punk Rock");
    genres.Add("Drum Solo");
    genres.Add("A Cappella");
    genres.Add("Euro-House");
    genres.Add("Dance Hall");
    genres.Add("Goa");
    genres.Add("Drum & Bass");
    genres.Add("Club-House");
    genres.Add("Hardcore");
    genres.Add("Terror");
    genres.Add("Indie");
    genres.Add("BritPop");
    genres.Add("Negerpunk");
    genres.Add("Polsk Punk");
    genres.Add("Beat");
    genres.Add("Christian Gangsta Rap");
    genres.Add("Heavy Metal");
    genres.Add("Black Metal");
    genres.Add("Crossover");
    genres.Add("Contemporary Christian");
    genres.Add("Christian Rock");
    genres.Add("Merengue");
    genres.Add("Salsa");
    genres.Add("Thrash Metal");
    genres.Add("Anime");
    genres.Add("JPop");
    genres.Add("Synthpop");

	// initiating random list
	rnd=GetTickCount();
	{
		UINT i,j,k,l;
		for(i=0;i<9001;i++)
		{
			rndlst[i]=i;
		}
		for(i=0;i<9001;i++)
		{
			j=9001.*frand();
			k=9001.*frand();
			l=rndlst[j]; rndlst[j]=rndlst[k]; rndlst[k]=l;
		}
		rndpntr=rndlst;
	}

	FirstInMyRandom=-1;

	TrackDurI=0;

	ShutdownAfterEnd=0;
	ExitAfterEnd=0;

	TraySeeking=false;
	IconShown=true;

	m_Player.SetWindow(m_hWnd);

	hCDDBThread=NULL;

	lbd=rbd=false;
	lbs=rbs=0;

	AddFromExp=false;

	CurMousePos.x=CurMousePos.y=0;

	CDLetter=theApp.GetProfileString(theApp.user,"CDLetter","");
	if(CDLetter!="")
		if (GetDriveType(CDLetter+":\\") == DRIVE_CDROM) CDLetter="";
	if(CDLetter=="")
	{
	    for (char c='A';c<='Z';c++)
		{
			CDLetter.Format("%c",c);

			if (GetDriveType(CDLetter+":\\")==DRIVE_CDROM)
				break;
			CDLetter="";
        }
	}

	W2Ffile=theApp.GetProfileString(theApp.user,"W2Ffile","");
	W2Fplay=theApp.GetProfileString(theApp.user,"W2Fplay","Now playing: %T");
	W2Fpause=theApp.GetProfileString(theApp.user,"W2Fpause","Now paused: %T");
	W2Fstop=theApp.GetProfileString(theApp.user,"W2Fstop","Now stopped: %T");
	W2Fexit=theApp.GetProfileString(theApp.user,"W2Fexit","STP is closed");
	W2Foem=(int)theApp.GetProfileInt(theApp.user,"W2Foem",0);
	W2Fdel=(int)theApp.GetProfileInt(theApp.user,"W2Fdel",0);
	W2Fenabled=(int)theApp.GetProfileInt(theApp.user,"W2Fenabled",0);

	AutSort=(int)theApp.GetProfileInt(theApp.user,"AutSort",0);
	AutRemove=(int)theApp.GetProfileInt(theApp.user,"AutRemove",0);
	AutRemovedup=(int)theApp.GetProfileInt(theApp.user,"AutRemovedup",0);
	AutRescan=(int)theApp.GetProfileInt(theApp.user,"AutRescan",0);
	AutPeriod=(int)theApp.GetProfileInt(theApp.user,"AutPeriod",5);
	AutEvery=(int)theApp.GetProfileInt(theApp.user,"AutEvery",0);
	AutOnStart=(int)theApp.GetProfileInt(theApp.user,"AutOnStart",0);
	AutSaveset=(int)theApp.GetProfileInt(theApp.user,"AutSaveset",0);

	int AutDirsCnt=(int)theApp.GetProfileInt(theApp.user,"AutDirsCnt",0);

	CString adtmp; int adc;
	for(adc=0;adc<AutDirsCnt;adc++)
	{
		adtmp.Format("%d",adc+1);
		adtmp=theApp.GetProfileString(theApp.user,"AutDir"+adtmp,"");
		if(adtmp!="")
			AutDirs.Add(adtmp);
	}

	CurrentSkin=theApp.GetProfileString(theApp.user,"CurrentSkin","");

	CDDBServer=theApp.GetProfileString(theApp.user,"CDDBSvr","http://freedb.freedb.org/~cddb/cddb.cgi");

	EMailAddress=theApp.GetProfileString(theApp.user,"EMailAddress","yourname@yourdomain.com");

	RNTemplate=theApp.GetProfileString(theApp.user,"RNTemplate","%1 - %3");

	SMTracks=(int)theApp.GetProfileInt(theApp.user,"SMTracks",1);
	SMAlbum=(int)theApp.GetProfileInt(theApp.user,"SMAlbum",1);

	DockSD=(int)theApp.GetProfileInt(theApp.user,"DockMinibar",0);

//	Language=(int)theApp.GetProfileInt(theApp.user,"Language",0);

	PressAndHold=(int)theApp.GetProfileInt(theApp.user,"PressAndHold",2);

	ADevice=(int)theApp.GetProfileInt(theApp.user,"ADevice",WAVE_MAPPER);
	MDevice=(int)theApp.GetProfileInt(theApp.user,"MDevice",0);

	ForceMono=(int)theApp.GetProfileInt(theApp.user,"ForceMono",0);

	Downsampling=(int)theApp.GetProfileInt(theApp.user,"Downsampling",0);
	
//	ExtPlaylistFormat=(int)theApp.GetProfileInt(theApp.user,"ExtPlaylistFormat",0);

	AutoCDDB=(int)theApp.GetProfileInt(theApp.user,"AutoCDDB",0);

	AlbumStop=(int)theApp.GetProfileInt(theApp.user,"AlbumStop",0);

	ShowingMode=(int)theApp.GetProfileInt(theApp.user,"ShowingMode",1);

	
	ShowRemainingTime=(int)theApp.GetProfileInt(theApp.user,"ShowRemainingTime",0);
	ShowTTT=(int)theApp.GetProfileInt(theApp.user,"ShowTTT",1);

	WAEmu=(int)theApp.GetProfileInt(theApp.user,"WAEmu",0);

	PlaylistOnTop=(int)theApp.GetProfileInt(theApp.user,"PlaylistOnTop",0);
	EQOnTop=(int)theApp.GetProfileInt(theApp.user,"EQOnTop",0);
	InfoOnTop=(int)theApp.GetProfileInt(theApp.user,"InfoOnTop",0);
	NoClicks=(int)theApp.GetProfileInt(theApp.user,"NoClicks",0);

	GapBtwTracks=(int)theApp.GetProfileInt(theApp.user,"Gap",0);

	Clicks1=theApp.GetProfileInt(theApp.user,"Clicks1",1);
	Clicks2=theApp.GetProfileInt(theApp.user,"Clicks2",0);
	Clicks3=theApp.GetProfileInt(theApp.user,"Clicks3",0);
	Clicks4=theApp.GetProfileInt(theApp.user,"Clicks4",0);
	RClicks1=theApp.GetProfileInt(theApp.user,"RClicks1",10);
	RClicks2=theApp.GetProfileInt(theApp.user,"RClicks2",0);
	RClicks3=theApp.GetProfileInt(theApp.user,"RClicks3",0);
	RClicks4=theApp.GetProfileInt(theApp.user,"RClicks4",0);

	m_NPKey=theApp.GetProfileInt(theApp.user,"NPKey",0);
	m_NPMod=theApp.GetProfileInt(theApp.user,"NPMod",0);

	m_ModeKey=theApp.GetProfileInt(theApp.user,"ModeKey",0);
	m_ModeMod=theApp.GetProfileInt(theApp.user,"ModeMod",0);

	m_ExitKey=theApp.GetProfileInt(theApp.user,"ExitKey",0);
	m_ExitMod=theApp.GetProfileInt(theApp.user,"ExitMod",0);

	m_PlayKey=theApp.GetProfileInt(theApp.user,"PlayKey",0);
	m_PlayMod=theApp.GetProfileInt(theApp.user,"PlayMod",0);
	m_StopKey=theApp.GetProfileInt(theApp.user,"StopKey",0);
	m_StopMod=theApp.GetProfileInt(theApp.user,"StopMod",0);
	m_PrevKey=theApp.GetProfileInt(theApp.user,"PrevKey",0);
	m_PrevMod=theApp.GetProfileInt(theApp.user,"PrevMod",0);
	m_NextKey=theApp.GetProfileInt(theApp.user,"NextKey",0);
	m_NextMod=theApp.GetProfileInt(theApp.user,"NextMod",0);
	m_ForwKey=theApp.GetProfileInt(theApp.user,"ForwKey",0);
	m_ForwMod=theApp.GetProfileInt(theApp.user,"ForwMod",0);
	m_BackKey=theApp.GetProfileInt(theApp.user,"BackKey",0);
	m_BackMod=theApp.GetProfileInt(theApp.user,"BackMod",0);
	m_VUpKey=theApp.GetProfileInt(theApp.user,"VUpKey",0);
	m_VUpMod=theApp.GetProfileInt(theApp.user,"VUpMod",0);
	m_VDownKey=theApp.GetProfileInt(theApp.user,"VDownKey",0);
	m_VDownMod=theApp.GetProfileInt(theApp.user,"VDownMod",0);

	m_OpenKey1=theApp.GetProfileInt(theApp.user,"OpenKey1",0); 
	m_OpenMod1=theApp.GetProfileInt(theApp.user,"OpenMod1",0); 
	m_OpenKey2=theApp.GetProfileInt(theApp.user,"OpenKey2",0); 
	m_OpenMod2=theApp.GetProfileInt(theApp.user,"OpenMod2",0);
	m_OpenKey3=theApp.GetProfileInt(theApp.user,"OpenKey3",0); 
	m_OpenMod3=theApp.GetProfileInt(theApp.user,"OpenMod3",0);
	m_MinibarKey=theApp.GetProfileInt(theApp.user,"MinibarKey",0);
	m_MinibarMod=theApp.GetProfileInt(theApp.user,"MinibarMod",0);
	m_MP3InfoKey=theApp.GetProfileInt(theApp.user,"MP3InfoKey",0);
	m_MP3InfoMod=theApp.GetProfileInt(theApp.user,"MP3InfoMod",0);
	m_PlaylistKey=theApp.GetProfileInt(theApp.user,"PlstKey",0);
	m_PlaylistMod=theApp.GetProfileInt(theApp.user,"PlstMod",0);
	m_EqualizerKey=theApp.GetProfileInt(theApp.user,"EqualizerKey",0);
	m_EqualizerMod=theApp.GetProfileInt(theApp.user,"EqualizerMod",0);
	m_RepeatKey=theApp.GetProfileInt(theApp.user,"RptKey",0);
	m_RepeatMod=theApp.GetProfileInt(theApp.user,"RptMod",0);
	m_ShuffleKey=theApp.GetProfileInt(theApp.user,"ShflKey",0);
	m_ShuffleMod=theApp.GetProfileInt(theApp.user,"ShflMod",0);
	m_AlbummodeKey=theApp.GetProfileInt(theApp.user,"AlbummodeKey",0);
	m_AlbummodeMod=theApp.GetProfileInt(theApp.user,"AlbummodeMod",0);
	m_TrayIconKey=theApp.GetProfileInt(theApp.user,"TrayIconKey",0);
	m_TrayIconMod=theApp.GetProfileInt(theApp.user,"TrayIconMod",0);
	m_MenuKey=theApp.GetProfileInt(theApp.user,"MenuKey",0);
	m_MenuMod=theApp.GetProfileInt(theApp.user,"MenuMod",0);
	m_TracksKey=theApp.GetProfileInt(theApp.user,"TracksKey",0);
	m_TracksMod=theApp.GetProfileInt(theApp.user,"TracksMod",0);
	m_AlbumKey=theApp.GetProfileInt(theApp.user,"AlbumKey",0);
	m_AlbumMod=theApp.GetProfileInt(theApp.user,"AlbumMod",0);
	m_AutomationKey=theApp.GetProfileInt(theApp.user,"AutomationKey",0);
	m_AutomationMod=theApp.GetProfileInt(theApp.user,"AutomationMod",0);

	m_JeltiyKey=theApp.GetProfileInt(theApp.user,"JeltiyKey",0);
	m_JeltiyMod=theApp.GetProfileInt(theApp.user,"JeltiyMod",0);

	RegHotKeys();

	CFileFind finder;
	
	opening=false;

	Current=PlayListLength=0;

	OutputModule=(int)theApp.GetProfileInt(theApp.user,"OutputModule",1);
	
	OutPath=theApp.GetProfileString(theApp.user,"OutPath","C:\\");

	InitDir=theApp.GetProfileString(theApp.user,"InitDir","C:\\");

	LoadSkin();

	Recent[0]=theApp.GetProfileString(theApp.user,"Recent0","");
	Recent[1]=theApp.GetProfileString(theApp.user,"Recent1","");
	Recent[2]=theApp.GetProfileString(theApp.user,"Recent2","");
	Recent[3]=theApp.GetProfileString(theApp.user,"Recent3","");
	Recent[4]=theApp.GetProfileString(theApp.user,"Recent4","");
	Recent[5]=theApp.GetProfileString(theApp.user,"Recent5","");
	Recent[6]=theApp.GetProfileString(theApp.user,"Recent6","");
	Recent[7]=theApp.GetProfileString(theApp.user,"Recent7","");
	Recent[8]=theApp.GetProfileString(theApp.user,"Recent8","");
	Recent[9]=theApp.GetProfileString(theApp.user,"Recent9","");


	AutoPlay=(int)theApp.GetProfileInt(theApp.user,"AutoPlay",1);
	RandomFirst=(int)theApp.GetProfileInt(theApp.user,"RandomFirst",0);


	JeltiySeek=(int)theApp.GetProfileInt(theApp.user,"JeltiySeek",0);

	IncludeWAVs=(int)theApp.GetProfileInt(theApp.user,"IncludeWAVs",0);

	EQPreset=(int)theApp.GetProfileInt(theApp.user,"EQPreset",-1);
	BuffersType=(int)theApp.GetProfileInt(theApp.user,"Buffers",4);
	InputBuffersType=(int)theApp.GetProfileInt(theApp.user,"InputBuffers",4);


	PlayerPriority=(int)theApp.GetProfileInt(theApp.user,"Priority",5);
	switch(PlayerPriority)
	{
		case 1:
			m_Player.SetPriority(THREAD_PRIORITY_LOWEST);
			break;
		case 2:
			m_Player.SetPriority(THREAD_PRIORITY_BELOW_NORMAL);
			break;
		case 3:
			m_Player.SetPriority(THREAD_PRIORITY_NORMAL);
			break;
		case 4:
			m_Player.SetPriority(THREAD_PRIORITY_ABOVE_NORMAL);
			break;
		case 5:
			m_Player.SetPriority(THREAD_PRIORITY_HIGHEST);
			break;
	}

	SBDockR=(int)theApp.GetProfileInt(theApp.user,"SBDockR",0);
	SBDockB=(int)theApp.GetProfileInt(theApp.user,"SBDockB",0);
	SeekBarX=(int)theApp.GetProfileInt(theApp.user,"SeekBarX",-1000);
	SeekBarY=(int)theApp.GetProfileInt(theApp.user,"SeekBarY",-1000);
	SeekBarW=(int)theApp.GetProfileInt(theApp.user,"SeekBarW",-1000);
	EqualizerX=(int)theApp.GetProfileInt(theApp.user,"EqualizerX",-1000);
	EqualizerY=(int)theApp.GetProfileInt(theApp.user,"EqualizerY",-1000);
	PlaylistX=(int)theApp.GetProfileInt(theApp.user,"PlaylistX",-1000);
	PlaylistY=(int)theApp.GetProfileInt(theApp.user,"PlaylistY",-1000);
	PlaylistW=(int)theApp.GetProfileInt(theApp.user,"PlaylistW",-1000);
	PlaylistH=(int)theApp.GetProfileInt(theApp.user,"PlaylistH",-1000);
	InfoX=(int)theApp.GetProfileInt(theApp.user,"InfoX",-1000);
	InfoY=(int)theApp.GetProfileInt(theApp.user,"InfoY",-1000);

	m_Repeat=(int)theApp.GetProfileInt(theApp.user,"Repeat",0);
	m_RepeatTrack=(int)theApp.GetProfileInt(theApp.user,"RepeatTrack",0);
	ShuffleMode=(int)theApp.GetProfileInt(theApp.user,"ShuffleMode",0);

	m_preamp=(int)theApp.GetProfileInt(theApp.user,"Preamp",0);
	m_EEQ=(int)theApp.GetProfileInt(theApp.user,"EnableEQ",0);

	m_s1=(int)theApp.GetProfileInt(theApp.user,"EQ1",0);
	m_s2=(int)theApp.GetProfileInt(theApp.user,"EQ2",0);
	m_s3=(int)theApp.GetProfileInt(theApp.user,"EQ3",0);
	m_s4=(int)theApp.GetProfileInt(theApp.user,"EQ4",0);
	m_s5=(int)theApp.GetProfileInt(theApp.user,"EQ5",0);
	m_s6=(int)theApp.GetProfileInt(theApp.user,"EQ6",0);
	m_s7=(int)theApp.GetProfileInt(theApp.user,"EQ7",0);
	m_s8=(int)theApp.GetProfileInt(theApp.user,"EQ8",0);
	m_s9=(int)theApp.GetProfileInt(theApp.user,"EQ9",0);
	m_s10=(int)theApp.GetProfileInt(theApp.user,"EQ10",0);

	int qq=theApp.GetProfileInt(theApp.user,"Presets",4);
	
	CString buf,buf2,buf3;

	for(i=0;i<qq;i++)
	{
		buf.Format("PresetName%d",i);
		switch(i)
		{
		case 0:
			buf2="Classic";
			break;
		case 1:
			buf2="Loudness";
			break;
		case 2:
			buf2="Pop";
			break;
		case 3:
			buf2="Rock";
			break;
		default:
			buf2="";
			break;
		}
		buf2=theApp.GetProfileString(theApp.user,buf,buf2);
		if(buf2=="") continue;
		buf.Format("PresetEQ%d",i);
		switch(i)
		{
		case 0:
			buf3="knjgjlnopqq";
			break;
		case 1:
			buf3="kqnlkkkmoqr";
			break;
		case 2:
			buf3="kkmnmlkkkkk";
			break;
		case 3:
			buf3="komkijlnopp";
			break;
		default:
			buf3="";
			break;
		}
		buf3=theApp.GetProfileString(theApp.user,buf,buf3);
		if(buf3=="") continue;
		presets.Add(buf2+"\t"+buf3);
	}

	SetEQ();

	CDMode=((CmdLine.CDFlag||theApp.GetProfileInt(theApp.user,"CDMode",0)&&CmdLine.fname=="")&&CDLetter!="");

	CurrentVolume=0;

	nid.cbSize=sizeof(nid);
	nid.hWnd=this->m_hWnd;
	nid.uID=0;
	nid.uFlags=NIF_ICON | NIF_TIP | NIF_MESSAGE;
	nid.uCallbackMessage=WM_ICON_NOTIFY;
	HICON m_hIcon = StopIcon;
	nid.hIcon=m_hIcon;
	strcpy(nid.szTip,"STP");

	Shell_NotifyIcon(NIM_ADD,&nid);	

	pVolume = new CVolume(0);
		CurrentVolume=pVolume->GetCurrentVolume();

		if(CmdLine.fname!="")
		{
			if(CmdLine.fname.GetLength()==3&&CmdLine.fname[1]==':')
			{
				OpenFolder(CmdLine.fname.Left(2)+'\\',RandomFirst==1,CmdLine.AddFlag,!CmdLine.AddFlag);
			}
			else
			if(finder.FindFile(CmdLine.fname))
			{
				finder.FindNextFile();
				if(finder.IsDirectory())
					OpenFolder(CmdLine.fname,RandomFirst==1,CmdLine.AddFlag,!CmdLine.AddFlag);
				else
				{
					if((CmdLine.fname.Mid(CmdLine.fname.ReverseFind('.')+1,3)).CompareNoCase("M3U")==0||(CmdLine.fname.Mid(CmdLine.fname.ReverseFind('.')+1,3)).CompareNoCase("PLS")==0)
						OpenPlaylist(CmdLine.fname,RandomFirst==1,CmdLine.AddFlag,!CmdLine.AddFlag);
					else
						OpenFile(CmdLine.fname,CmdLine.AddFlag,!CmdLine.AddFlag);
				}
				AddRecent(CmdLine.fname);
				AddFromExp=true;
				SetTimer(3,(DWORD)2000,NULL);
			}
		} else
		{
			LoadThePlaylist(false);
			if(AutOnStart) PerformAutomation();
		}
		if(theApp.GetProfileInt(theApp.user,"BarAtStartup",0)==1)
		{
			SeekDialog=new CSeekDialog(IDD_SEEK);
			SeekDialog->Create(IDD_SEEK,pMainFrame);
		}
		if(theApp.GetProfileInt(theApp.user,"PlaylistAtStartup",0)==1)
		{
			PlaylistDlg=new CPlaylistDlg(IDD_PLAYLISTR);
			PlaylistDlg->Create(IDD_PLAYLISTR,pMainFrame);
		}
		if(theApp.GetProfileInt(theApp.user,"EQAtStartup",0)==1)
		{
			EqualizerDlg=new CEqualizerDlg(IDD_EQUALIZER_DIALOGR);
			EqualizerDlg->Create(IDD_EQUALIZER_DIALOGR,pMainFrame);
		}

	if(WAEmu==1)
		StartWAEmu();
	SetTimer(10,250,NULL);

	SetTimer(11,1000,NULL);
	SetTimer(12,AutPeriod*60000,NULL);
}

int CMainWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	Start();

	Created=true;
	
	return 0;
}

void CMainWnd::SetEQ()
{
	double eq[32];

    if (m_EEQ==0) {
        // unset the equalizer
		Args->UseEqualizer = FALSE;
        return;
    }
	Args->UseEqualizer = TRUE;

    // compute channel bands;

    eq[ 0] = m_s1;
    eq[ 1] = m_s2;
    eq[ 2] = m_s3;
    eq[ 3] = m_s4;
    eq[ 4] = m_s5;
    eq[ 5] = m_s6;
    eq[ 6] = m_s7;
    eq[ 7] = m_s7;
    eq[ 8] = m_s8;
    eq[ 9] = m_s8;
    eq[10] = m_s8;
    eq[11] = m_s8;
    eq[12] = m_s9;
    eq[13] = m_s9;
    eq[14] = m_s9;
    eq[15] = m_s9;
    eq[16] = m_s9;
    eq[17] = m_s9;
    eq[18] = m_s9;
    eq[19] = m_s9;
    eq[20] = m_s10;
    eq[21] = m_s10;
    eq[22] = m_s10;
    eq[23] = m_s10;
    eq[24] = m_s10;
    eq[25] = m_s10;
    eq[26] = m_s10;
    eq[27] = m_s10;
    eq[28] = m_s10;
    eq[29] = m_s10;
    eq[30] = m_s10;
    eq[31] = m_s10;

	for(int i = 0; i < 32; i++)
	{
		equalizer[i] =
			(1+eq[i]*.05)*(1+eq[i]*.05)*(1+m_preamp*.05)*(1+m_preamp*.05);
	}
}

void CMainWnd::SetOut()
{
	PlayListAT[Current]=ReadTagAT(PlayList[Current]);

	if(MP3InfoDlg!=NULL)
		MP3InfoDlg->PrevFile="*";

	if(OutputModule==0)
	{
		CString buf=GetWavFromMP3(PlayList[Current]);
		char buf2[MAX_PATH];
		strcpy(buf2,LPCTSTR(buf));
		m_Player.SetOutName(buf);
		m_Player.SetOutMode(omWaveFile);
	} else
	{
		Args->AudioDevice=ADevice;
		m_Player.SetOutMode(omMMSystem);
	}
}

unsigned int CMainWnd::MyRandom(bool forw, bool init)
{
	if(init)
		Current=PlayListLength*frand();
	else
		if(FirstInMyRandom==-1) FirstInMyRandom=Current;
	while(*rndpntr!=Current)
	{
		if(rndpntr==rndlst+9000)
			rndpntr=rndlst;
		else
			rndpntr++;
	}
	int b,e; GetAlbumRange(&b,&e);
	do
	{
		if(forw)
		{
			if(rndpntr==rndlst+9000)
				rndpntr=rndlst;
			else
				rndpntr++;
		}
		else
		{
			if(rndpntr==rndlst)
				rndpntr=rndlst+9000;
			else
				rndpntr--;
		}
	} while (*rndpntr<b||*rndpntr>e);
	return *rndpntr;
}

bool CMainWnd::StartWAEmu()
{
	// Register our unique class name that we wish to use
	WNDCLASS wndcls;
	memset(&wndcls, 0, sizeof(WNDCLASS));   // start with NULL defaults

	wndcls.lpfnWndProc = ::DefWindowProc;
	wndcls.hInstance = AfxGetInstanceHandle();
//	wndcls.hIcon = LoadIcon(IDR_MAINFRAME);
//	wndcls.hCursor = LoadCursor( IDC_ARROW );
	wndcls.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wndcls.lpszMenuName = NULL;

	// Specify our own class name for using FindWindow later
	wndcls.lpszClassName = "Winamp v1.x";

	// Register new class and exit if it fails
	if(!AfxRegisterClass(&wndcls))
			return FALSE;

	WAEmuWnd = new CWAEmuWnd;

	WAEmuWnd->Create("Winamp v1.x","Winamp");
	
//	WAEmuWnd->ShowWindow(SW_SHOW);
//	WAEmuWnd->UpdateWindow();

	return TRUE;
}

bool CMainWnd::EndWAEmu()
{
	BOOL ret=TRUE;
	if(WAEmuWnd!=NULL)
		ret=WAEmuWnd->DestroyWindow();
	return ret&&(::UnregisterClass("Winamp v1.x",AfxGetInstanceHandle()));
}



void CMainWnd::IamWinamp(int f)
{
	switch(f)
	{
	case 1:
		// play
		OnPopupmenuPlay();
		break;
	case 2:
		// pause
		OnPopupmenuPause();
		break;
	case 3:
		// stop
		OnPopupmenuStop();
		break;
	case 4:
		// prev
		OnPopupmenuPrevious();
		break;
	case 5:
		// next
		OnPopupmenuNext();
		break;
	case 6:
		// vol up
		CurrentVolume+=5;
		if(CurrentVolume>100)CurrentVolume=100;
		pVolume->SetCurrentVolume(CurrentVolume);
		if(SeekDialog!=NULL) SeekDialog->m_vol.SetPos(CurrentVolume);
//		if(CDBar!=NULL) CDBar->m_vol.SetPos(CurrentVolume);
		break;
	case 7:
		// vol down
		CurrentVolume-=5;
		if(CurrentVolume<0)CurrentVolume=0;
		pVolume->SetCurrentVolume(CurrentVolume);
		if(SeekDialog!=NULL) SeekDialog->m_vol.SetPos(CurrentVolume);
//		if(CDBar!=NULL) CDBar->m_vol.SetPos(CurrentVolume);
		break;
	case 8:
		// open file
		OnPopupmenuOpenFile();
		break;
	case 9:
		// open URL
		OnPopupmenuOpenUrl();
		break;
	case 10:
		// Equalizer
		{
			if(EqualizerDlg==NULL)
			{
				EqualizerDlg=new CEqualizerDlg(IDD_EQUALIZER_DIALOGR);
				EqualizerDlg->Create(IDD_EQUALIZER_DIALOGR);
			} else
			{
				EqualizerDlg->SaveWindowPosAndDestroy();
			}
		}
		break;
	case 11:
		// Playlist
		{
			if(PlaylistDlg==NULL)
			{
				PlaylistDlg=new CPlaylistDlg(IDD_PLAYLISTR);
				PlaylistDlg->Create(IDD_PLAYLISTR);
			} else
			{
				PlaylistDlg->SaveWindowPosAndDestroy();
			}
		}
		break;
	case 12:
		// Minibar
		{
			if(SeekDialog==NULL)
			{
				SeekDialog=new CSeekDialog(IDD_SEEK);
				SeekDialog->Create(IDD_SEEK);
			}
			else
			{
				SeekDialog->SaveWindowPosAndDestroy();
			}
		} 
		break;
	case 13:
		// EXIT
		OnPopupmenuExit();
		break;
	case 14:
		// repeat
		if(m_Repeat==0&&m_RepeatTrack==0) m_Repeat=1;
		else if(m_Repeat==1&&m_RepeatTrack==0) {m_Repeat=0;m_RepeatTrack=1;}
		else if(m_Repeat==0&&m_RepeatTrack==1) m_RepeatTrack=0;
		break;
	case 15:
		// shuffle
			if(ShuffleMode==1) ShuffleMode=0; else ShuffleMode=1;
		break;
	case 16:
		// 5 sec forward
		if(!CDMode)
		{
				if(PlayListLength>0&&m_Player.CanSetPos()) m_Player.SetPos(m_Player.GetPos()/10/TrackDurI+1);
				UpdMBTR();
		} else
		{
			CString buf,buf1,buf2;
			char buf3[64];
			mciSendString("status stp position",buf3,64,NULL);
			buf=buf3;
			int q=atoi(buf.Left(2));
			buf2.Format("status stp length track %d",q);
			mciSendString(buf2,buf3,64,NULL);
			buf2=buf3;
			int l=atoi(buf2.Left(2))*60+atoi(buf2.Mid(3,2));
			buf=buf.Mid(3,5);
			int p=atoi(buf.Left(2))*60+atoi(buf.Right(2));
			p+=5;if(p>l)p=l;

			mciSendString("status stp number of tracks",buf3,64,NULL);
			if(CurrentCD<atoi(buf3))
				buf.Format("play stp from %d:%d:%d to %d notify",CurrentCD,p/60,p%60,CurrentCD+1);
			else
				buf.Format("play stp from %d:%d:%d notify",CurrentCD,p/60,p%60);
			mciSendString(buf,NULL,0,m_hWnd);
			CDStatus=CDPLAYING;
			Notified=true;
			UpdMBTRCD();
		}
		break;
	case 17:
		// 5 sec backward
		{
				if(PlayListLength>0&&m_Player.CanSetPos()) m_Player.SetPos(m_Player.GetPos()/10/TrackDurI-1);
				UpdMBTR();
		}
		break;
	}
}

void CMainWnd::OnUpdatePopupmenuEqualizer(CCmdUI* pCmdUI) 
{
	if(EqualizerDlg!=NULL)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);

}

void CMainWnd::OnUpdatePopupmenuPlaylisteditor(CCmdUI* pCmdUI) 
{
	if(PlaylistDlg!=NULL)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainWnd::OnUpdatePopupmenuSeek(CCmdUI* pCmdUI) 
{
	if(SeekDialog!=NULL)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainWnd::OnClose() 
{
//	Finish();	
//	CFrameWnd::OnClose();
}

void CMainWnd::OnPopupmenuElapsedtime() 
{
	ShowRemainingTime=0;	
	UpdMBTR();

}

void CMainWnd::OnUpdatePopupmenuElapsedtime(CCmdUI* pCmdUI) 
{
	if(ShowRemainingTime==1)
		pCmdUI->SetCheck(0);
	else
		pCmdUI->SetCheck(1);
}

void CMainWnd::OnPopupmenuRemainingtime() 
{
	ShowRemainingTime=1;
	UpdMBTR();
}

void CMainWnd::OnUpdatePopupmenuRemainingtime(CCmdUI* pCmdUI) 
{
	if(ShowRemainingTime==1)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainWnd::OnPopupmenuSettingsRandomlyselectfirsttrack() 
{
	if(RandomFirst==1) RandomFirst=0; else RandomFirst=1;		
}

void CMainWnd::OnUpdatePopupmenuSettingsRandomlyselectfirsttrack(CCmdUI* pCmdUI) 
{
	if(RandomFirst==1)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainWnd::SortRec(int d,int h, bool ForAut)
{
	if(d>h)return;
	int i,j;
	CString str;

	i = h;
	j = d;

	str = PlayList[((int) ((d+h) / 2))];

	do {
		for(;;)
		{
			if(PlayList[j].Left(1+PlayList[j].ReverseFind('/')+PlayList[j].ReverseFind('\\')).Find(str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')))==0&&
			   PlayList[j].Left(1+PlayList[j].ReverseFind('/')+PlayList[j].ReverseFind('\\')).GetLength()!=str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).GetLength())
			{
				j++; continue;
			} else
			{
				if(str.CompareNoCase(PlayList[j])>0&&
					!(
						str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).Find(PlayList[j].Left(1+PlayList[j].ReverseFind('/')+PlayList[j].ReverseFind('\\')))==0&&
						str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).GetLength()!=PlayList[j].Left(1+PlayList[j].ReverseFind('/')+PlayList[j].ReverseFind('\\')).GetLength()					
					))
				{
					j++; continue;
				}
			}
			break;
		}
		for(;;)
		{
			if(str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).Find(PlayList[i].Left(1+PlayList[i].ReverseFind('/')+PlayList[i].ReverseFind('\\')))==0&&
			   str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).GetLength()!=PlayList[i].Left(1+PlayList[i].ReverseFind('/')+PlayList[i].ReverseFind('\\')).GetLength())
			{
				i--; continue;
			} else
			{
				if(PlayList[i].CompareNoCase(str)>0&&
					!(
						PlayList[i].Left(1+PlayList[i].ReverseFind('/')+PlayList[i].ReverseFind('\\')).Find(str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')))==0&&
						PlayList[i].Left(1+PlayList[i].ReverseFind('/')+PlayList[i].ReverseFind('\\')).GetLength()!=str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).GetLength()					
					))
				{
					i--; continue;
				}
			}
			break;
		}

		if ( i >= j ) {

			if ( i != j ) {
				CString zal;

				zal = PlayList[i];
				PlayList[i] = PlayList[j];
				PlayList[j] = zal;
				if(ForAut)
				{
					zal = PlayListAT[i];
					PlayListAT[i] = PlayListAT[j];
					PlayListAT[j] = zal;
					if(Current==i) Current=j;
					else if(Current==j) Current=i;
					if(PlaylistDlg!=NULL)
					{
						int zj=PlaylistDlg->m_playlistat.GetSel(i);
						int zk=PlaylistDlg->m_playlistat.GetSel(j);
						PlaylistDlg->m_playlistat.SetSel(i,zk);
						PlaylistDlg->m_playlistat.SetSel(j,zj);
						if(PlaylistDlg->m_playlistat.GetCaretIndex()==i) PlaylistDlg->m_playlistat.SetCaretIndex(j,TRUE);
						else if(PlaylistDlg->m_playlistat.GetCaretIndex()==j) PlaylistDlg->m_playlistat.SetCaretIndex(i,TRUE);
					}
				}
			}

			i--;
			j++;
		}
	} while (j <= i);

	if (d < i) SortRec(d,i,ForAut);
	if (j < h) SortRec(j,h,ForAut);
}

void CMainWnd::OnPopupmenuFilename() 
{
	ShowingMode=2;
	UpdMBTR();
}

void CMainWnd::OnUpdatePopupmenuFilename(CCmdUI* pCmdUI) 
{
	if(ShowingMode==2)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);	
}

void CMainWnd::OnPopupmenuTitle() 
{
	ShowingMode=0;
	UpdMBTR();
}

void CMainWnd::OnUpdatePopupmenuTitle(CCmdUI* pCmdUI) 
{
	if(ShowingMode==0)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);	
}

void CMainWnd::OnPopupmenuArtisttitle() 
{
	ShowingMode=1;
	UpdMBTR();
}

void CMainWnd::OnUpdatePopupmenuArtisttitle(CCmdUI* pCmdUI) 
{
	if(ShowingMode==1)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);	
}

void CMainWnd::ShowTracksMenu(int MenuType, bool CurAlbOnly)
{
	if(PlayListLength>0&&PlayListLength<10001)
	{
		POINT point;
		switch(MenuType)
		{
		case 0:
			point=CurMousePos; break;
		case 1:
			GetPosForMenu(&point); break;
		case 2:
			GetCursorPos(&point); break;
		}

		CMenu tmenu;
		tmenu.CreatePopupMenu();

		tmenu.DeleteMenu(0,MF_BYPOSITION);
		
		if(CurAlbOnly)
			BuildAlbumMenu(tmenu.m_hMenu);
		else
			BuildMenu(tmenu.m_hMenu);

		if(MenuType<2)
		{
			SetForegroundWindow();
			tmenu.TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
					point.x, point.y,
					this);
			PostMessage(WM_NULL, 0, 0);
		} else
		{
			tmenu.TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
					point.x, point.y,
					this);
		}
		tmenu.DestroyMenu();
	}

}

void CMainWnd::ShowCDPopup(int MenuType)
{
	CMenu menu;
	CMenu* pPopup;
	menu.LoadMenu(IDR_MENUR);
	POINT point;
	switch(MenuType)
	{
	case 0:
		point=CurMousePos; break;
	case 1:
		GetPosForMenu(&point); break;
	case 2:
		GetCursorPos(&point); break;
	}
	pPopup = menu.GetSubMenu(0);

	CMenu *pTempMenu;

	pTempMenu=pPopup->GetSubMenu(6)->GetSubMenu(3);
	pTempMenu->DeleteMenu(0,MF_BYPOSITION);

	int i,j,k; CString rbuf;
	for(i=0;i<10;i++)
	{
		if(Recent[i]!="")
		{
			rbuf=Recent[i];
			if(rbuf.GetLength()>40)
			{
				j=1+rbuf.ReverseFind('\\')+rbuf.ReverseFind('/');
				k=j>20?18:j-3; if(k<0) k=0;
				rbuf=rbuf.Left(k)+"....."+rbuf.Mid(j);
			}
			pTempMenu->AppendMenu(MF_STRING,IDM_RECENT_FILES+i,ReplaceAmpersand(rbuf));
		}
	}

	pTempMenu=pPopup->GetSubMenu(6)->GetSubMenu(4);
	pTempMenu->DeleteMenu(0,MF_BYPOSITION);
	CString CDLetter;
	UINT dt;
	for (char c='C';c<='Z';c++)
	{
		CDLetter.Format("%c",c);
		dt=::GetDriveType(CDLetter+":\\");
		if (dt==DRIVE_REMOVABLE||dt==DRIVE_FIXED||dt==DRIVE_REMOTE||dt==DRIVE_CDROM)
		{
			pTempMenu->AppendMenu(MF_STRING,IDM_DRIVES+(UINT)(c-'C'),CDLetter);
		}
    }

	pTempMenu=pPopup->GetSubMenu(7);

	CString buf,buf1,cdid,tmp1,tmp2;
	char buf2[64];
	char trackbuf[256];

	mciSendString("info stp identity",buf2,64,NULL);
	cdid.Format("%X",atoi(buf2));

	char orderbuf[256];
	::GetPrivateProfileString(cdid,"order","",orderbuf,256,"CDPLAYER.INI");
	mciSendString("status stp number of tracks",buf2,64,NULL);
	int q=atoi(buf2);

	CWordArray trks;
	bool ordered=false;
	if(strcmp(orderbuf,"")!=0)
	{
		ordered=true;
		CString buf=orderbuf;
		buf.TrimLeft();buf.TrimRight();
		buf=buf+" ";
		do
		{
			trks.Add(1+atoi(buf.Left(buf.Find(' '))));
			buf=buf.Mid(buf.Find(' ')+1);
		} while(buf.GetLength()>0);
		q=trks.GetSize();
	}

	if(q>0)
	{
		CMenu tmenu;
		tmenu.CreatePopupMenu();

		::GetPrivateProfileString(cdid,"Artist","Unknown",trackbuf,256,"CDPLAYER.INI");
		tmp1=trackbuf;
		::GetPrivateProfileString(cdid,"Title","Unknown",trackbuf,256,"CDPLAYER.INI");
		tmp2=trackbuf;

		mciSendString("status stp position",buf2,64,NULL);
		buf=buf2;
		int p=atoi(buf.Left(2));p--;

		bool af=false;
		CString cdtitle=tmp1+" - "+tmp2;
		
		MCI_STATUS_PARMS sMCIStatus;
		sMCIStatus.dwItem = MCI_CDA_STATUS_TYPE_TRACK;
		for(int i=0;i<q;i++)
		{
			sMCIStatus.dwTrack=i+1;
			mciSendCommand (mciGetDeviceID("stp"), MCI_STATUS, MCI_STATUS_ITEM | MCI_TRACK | MCI_WAIT, 
							(DWORD) (LPVOID) &sMCIStatus);
			if (sMCIStatus.dwReturn == MCI_CDA_TRACK_AUDIO)
				af=true;
			else
				continue;
			buf.Format("status stp length track %d",ordered?trks[i]:i+1);
			mciSendString(buf,buf2,64,NULL);
			buf=buf2;
			buf=buf.Left(5);
			tmp1.Format("%d",ordered?trks[i]-1:i);
			tmp2.Format("Track %d",ordered?trks[i]:i+1);
			::GetPrivateProfileString(cdid,tmp1,tmp2,trackbuf,256,"CDPLAYER.INI");
			buf1.Format("%s (%s)",trackbuf,buf);
			pTempMenu->AppendMenu(MF_STRING,IDM_TRACKS+(ordered?trks[i]-1:i),ReplaceAmpersand(buf1));
			if(p==i&&CDStatus!=CDSTOPPED)
				pTempMenu->SetDefaultItem(pTempMenu->GetMenuItemCount()-1, TRUE);
		}
		if(af)
		{
			pTempMenu->InsertMenu(5,MF_BYPOSITION | MF_STRING,ID_POPUPMENU_DISK_PLAYLIST,ReplaceAmpersand(cdtitle));
			pTempMenu->InsertMenu(6,MF_BYPOSITION | MF_SEPARATOR);
		} else
		{
			pTempMenu->AppendMenu(MF_STRING,ID_POPUPMENU_DISK_PLAYLIST,"Data CD");
		}
	} else
	{
		pTempMenu->DeleteMenu(4,MF_BYPOSITION);
	}

	if(MenuType==2)
	{
//		pPopup->DeleteMenu(ID_POPUPMENU_PLAY,MF_BYCOMMAND);
//		pPopup->DeleteMenu(ID_POPUPMENU_PAUSE,MF_BYCOMMAND);
//		pPopup->DeleteMenu(ID_POPUPMENU_STOP,MF_BYCOMMAND);
//		pPopup->DeleteMenu(ID_POPUPMENU_PREVIOUS,MF_BYCOMMAND);
//		pPopup->DeleteMenu(ID_POPUPMENU_NEXT,MF_BYCOMMAND);
		//pPopup->DeleteMenu(0,MF_BYPOSITION);

		pPopup->TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
				point.x, point.y,
				this);
	} else
	{
/*		if(GraphicalButtons==1)
		{
			pPopup->ModifyMenu(ID_POPUPMENU_PLAY, MF_OWNERDRAW | MF_BYCOMMAND,ID_POPUPMENU_PLAY);
			pPopup->ModifyMenu(ID_POPUPMENU_PAUSE, MF_OWNERDRAW | MF_BYCOMMAND,ID_POPUPMENU_PAUSE);
			pPopup->ModifyMenu(ID_POPUPMENU_STOP, MF_OWNERDRAW | MF_BYCOMMAND,ID_POPUPMENU_STOP);
			pPopup->ModifyMenu(ID_POPUPMENU_PREVIOUS, MF_OWNERDRAW | MF_BYCOMMAND,ID_POPUPMENU_PREVIOUS);
			pPopup->ModifyMenu(ID_POPUPMENU_NEXT, MF_OWNERDRAW | MF_BYCOMMAND,ID_POPUPMENU_NEXT);
		}

		if(ShowGradientBar==1)
		{
			pPopup->InsertMenu(0, MF_OWNERDRAW | MF_BYPOSITION, ID_POPUPMENU_PIC);
			CString buf;
			pPopup->GetMenuString(ID_POPUPMENU_EXIT,buf,MF_BYCOMMAND);
			pPopup->ModifyMenu(ID_POPUPMENU_EXIT,MF_BYCOMMAND | MF_MENUBARBREAK | MF_STRING, ID_POPUPMENU_EXIT, buf);
		}*/
		pPopup->DeleteMenu(pPopup->GetMenuItemCount()-1, MF_BYPOSITION);
		pPopup->DeleteMenu(pPopup->GetMenuItemCount()-1, MF_BYPOSITION);
		pPopup->DeleteMenu(pPopup->GetMenuItemCount()-1, MF_BYPOSITION);

		SetForegroundWindow();
		pPopup->TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
				point.x, point.y,
				this);
		PostMessage(WM_NULL, 0, 0);
	}
	menu.DestroyMenu();

}





void CMainWnd::OnPopupmenuEjectdisk() 
{
	mciSendString("set stp door open",NULL,0,NULL);
	CDStatus=CDSTOPPED;
	UpdMBTRCD();
}

void CMainWnd::OnPopupmenuDiskLoaddisk() 
{
	mciSendString("set stp door closed",NULL,0,NULL);	
}

void CMainWnd::ShowCDTracksMenu(int MenuType)
{
	CString buf,buf1,cdid,tmp1,tmp2;
	char buf2[64];
	char trackbuf[256];

	mciSendString("info stp identity",buf2,64,NULL);
	cdid.Format("%X",atoi(buf2));

	char orderbuf[256];
	::GetPrivateProfileString(cdid,"order","",orderbuf,256,"CDPLAYER.INI");
	mciSendString("status stp number of tracks",buf2,64,NULL);
	int q=atoi(buf2);

	CWordArray trks;
	bool ordered=false;
	if(strcmp(orderbuf,"")!=0)
	{
		ordered=true;
		CString buf=orderbuf;
		buf.TrimLeft();buf.TrimRight();
		buf=buf+" ";
		do
		{
			trks.Add(1+atoi(buf.Left(buf.Find(' '))));
			buf=buf.Mid(buf.Find(' ')+1);
		} while(buf.GetLength()>0);
		q=trks.GetSize();
	}
	
	if(q>0)
	{
		POINT point;
		switch(MenuType)
		{
		case 0:
			point=CurMousePos; break;
		case 1:
			GetPosForMenu(&point); break;
		case 2:
			GetCursorPos(&point); break;
		}
		
		CMenu tmenu;
		tmenu.CreatePopupMenu();

		::GetPrivateProfileString(cdid,"Artist","Unknown",trackbuf,256,"CDPLAYER.INI");
		tmp1=trackbuf;
		::GetPrivateProfileString(cdid,"Title","Unknown",trackbuf,256,"CDPLAYER.INI");
		tmp2=trackbuf;

		mciSendString("status stp position",buf2,64,NULL);
		buf=buf2;
		int p=atoi(buf.Left(2));p--;
		bool af=false;
		CString cdtitle=tmp1+" - "+tmp2;
		MCI_STATUS_PARMS sMCIStatus;
		sMCIStatus.dwItem = MCI_CDA_STATUS_TYPE_TRACK;
		for(int i=0;i<q;i++)
		{
			sMCIStatus.dwTrack=i+1;
			mciSendCommand (mciGetDeviceID("stp"), MCI_STATUS, MCI_STATUS_ITEM | MCI_TRACK | MCI_WAIT, 
							(DWORD) (LPVOID) &sMCIStatus);
			if (sMCIStatus.dwReturn == MCI_CDA_TRACK_AUDIO)
				af=true;
			else
				continue;
			buf.Format("status stp length track %d",ordered?trks[i]:i+1);
			mciSendString(buf,buf2,64,NULL);
			buf=buf2;
			buf=buf.Left(5);
			tmp1.Format("%d",ordered?trks[i]-1:i);
			tmp2.Format("Track %d",ordered?trks[i]:i+1);
			::GetPrivateProfileString(cdid,tmp1,tmp2,trackbuf,256,"CDPLAYER.INI");
			buf1.Format("%s (%s)",trackbuf,buf);
			tmenu.AppendMenu(MF_STRING,IDM_TRACKS+(ordered?trks[i]-1:i),ReplaceAmpersand(buf1));
			if(p==i&&CDStatus!=CDSTOPPED)
				tmenu.SetDefaultItem(tmenu.GetMenuItemCount()-1, TRUE);
		}
		if(af)
		{
			tmenu.InsertMenu(0,MF_BYPOSITION | MF_SEPARATOR);
			tmenu.InsertMenu(0,MF_BYPOSITION | MF_STRING,ID_POPUPMENU_DISK_PLAYLIST,ReplaceAmpersand(cdtitle));
		} else
		{
			tmenu.InsertMenu(0,MF_BYPOSITION | MF_STRING,ID_POPUPMENU_DISK_PLAYLIST,"Data CD");
		}

		if(MenuType<2)
		{
			SetForegroundWindow();
			tmenu.TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
					point.x, point.y,
					this);
			PostMessage(WM_NULL, 0, 0);
		} else
		{
			tmenu.TrackPopupMenu(TPM_RIGHTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
					point.x, point.y,
					this);
		}
		tmenu.DestroyMenu();
	}
}

CString CMainWnd::GetCDTrackTitle(int num, bool ForTray, bool DontCare)
{
	CString buf,cdid,tmp1,tmp2;
	char buf2[64];
	char trackbuf[256];

	if(ShowingMode==2&&!ForTray&&!DontCare)
	{
		buf.Format("Track %d",num);
		return buf;
	}

	mciSendString("info stp identity",buf2,64,NULL);
	cdid.Format("%X",atoi(buf2));

	tmp1.Format("%d",num-1);
	tmp2.Format("Track %d",num);
	::GetPrivateProfileString(cdid,tmp1,tmp2,trackbuf,256,"CDPLAYER.INI");
	if((ShowingMode==0||ForTray)&&!DontCare)
	{
		buf=trackbuf;
		if(ForTray)
		{
			if(buf.GetLength()>40) buf=buf.Left(37)+"...";
			buf.Replace("&","&&");
		}
		return buf;
	}
	buf=trackbuf;
	::GetPrivateProfileString(cdid,"Artist","Unknown",trackbuf,256,"CDPLAYER.INI");
	buf=" - "+buf;
	buf=trackbuf+buf;
	return buf;
}

void CMainWnd::OnPopupmenuCddb() 
{
	tot_trks = read_cdtoc_from_drive();
	
	if(tot_trks==0) return;

	char buf2[64];

	mciSendString("info stp identity",buf2,64,NULL);
	curcdid.Format("%X",atoi(buf2));

	if(hCDDBThread!=NULL)
	{
		::TerminateThread(hCDDBThread,0);
	}

	DWORD q;
	hCDDBThread=::CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)QueryCDDB,NULL,0,&q);
	::SetThreadPriority(hCDDBThread,THREAD_PRIORITY_LOWEST);
}

int CMainWnd::NextRandCD(int n,int t,bool frw)
{
	char buf3[64];
	char orderbuf[256];
	mciSendString("info stp identity",buf3,64,NULL);
	CString cdid;
	cdid.Format("%X",atoi(buf3));
	::GetPrivateProfileString(cdid,"order","",orderbuf,256,"CDPLAYER.INI");
	CString buf="",buf2;
	if(strcmp(orderbuf,"")!=0)
	{
		buf=orderbuf;
		buf.TrimLeft();buf.TrimRight();
		buf=" "+buf+" ";
	}

	for(int i=0;i<100;i++)
	{
		if(CDRandom[i]==n||n==0)
		{
			int k=i;
			for(;;)
			{
				k=k+(frw?1:-1);
				if(k==-1) k=99;
				if(k==100) k=0;
				if(CDRandom[k]<=t)
				{
					buf2.Format(" %d ",CDRandom[k]-1);
					if(buf==""||buf.Find(buf2)>-1)
						return CDRandom[k];
				}
			}
		}
	}
	return n;
}

int CMainWnd::NextOrderCD(int n, bool frw)
{
	char buf3[64];
	char orderbuf[256];
	mciSendString("info stp identity",buf3,64,NULL);
	CString cdid;
	cdid.Format("%X",atoi(buf3));
	::GetPrivateProfileString(cdid,"order","",orderbuf,256,"CDPLAYER.INI");
	if(strcmp(orderbuf,"")==0)
	{
		if(n==-1) return 1; else return n+(frw?1:-1);
	}
	CString buf=orderbuf;
	buf.TrimLeft();buf.TrimRight();
	buf=" "+buf+" ";
	CString buf2;
	buf2.Format(" %d ",n-1);
	if(frw)
	{
		int q=buf.Find(buf2);
		if(q!=-1)
			q+=buf2.GetLength();
		else
			q=1;
		buf=buf.Mid(q);
		if(buf.GetLength()==0) return 0;
		buf=buf.Left(buf.Find(' '));
		return atoi(buf)+1;
	} else
	{
		int q=buf.Find(buf2);
		if(q==-1)
			q=buf.GetLength();
		buf=buf.Left(q);
		if(buf.GetLength()==0) return 0;
		buf=buf.Mid(buf.ReverseFind(' ')+1);
		return atoi(buf)+1;
	}
}



void CMainWnd::UpdMBTR(bool updtray)
{
	if(PlayListLength==0)
	{
		SetWindowText("dSTP MP3 Player");
		nid.hIcon=StopIcon;
		if(IconShown)Shell_NotifyIcon(NIM_MODIFY,&(nid));
		if(SeekDialog!=NULL)
		{
			SeekDialog->CurrentSong="";
			SeekDialog->m_bar.SetPos(0);
			SeekDialog->m_bar.RedrawWindow();
		}
		return;
	}
	if(PlayListAT[Current]=="")
		PlayListAT[Current]=ReadTagAT(PlayList[Current]);

	CString tmp=PlayListAT[Current].Mid(PlayListAT[Current].ReverseFind('(')+1);
	tmp=tmp.Left(tmp.GetLength()-1);

	TrackDurI=atoi(tmp.Left(tmp.Find(':')))*60+
			  atoi(tmp.Mid(tmp.Find(':')+1));

	if(TrackDurI==0&&m_Player.PlayerMode()>=pmClosed)
		TrackDurI=(int)(m_Player.GetSize()/1000);

	if(TrackDurI==0)
		TrackDurI=1;

	int p=0;
	switch(m_Player.PlayerMode())
	{
		case pmPlaying:
			nid.hIcon=PlayIcon;
			p=m_Player.GetPos()/1000;
			break;
		case pmPaused:
			nid.hIcon=PauseIcon;
			p=m_Player.GetPos()/1000;
			break;
		default:
			nid.hIcon=StopIcon;
			break;
	}
	if(p>TrackDurI) p=TrackDurI;
	if(SeekDialog!=NULL)if(!SeekDialog->ScrollFlag)
		{
			SeekDialog->m_bar.SetPos((int)((float)1000*(float)p/(float)TrackDurI));
			if(ShowTTT)
				SeekDialog->CurrentTime.Format("%02d:%02d/%02d:%02d",
								   ShowRemainingTime==1?(int)((TrackDurI-p)/60):p/60,
								   ShowRemainingTime==1?((TrackDurI-p)%60):p%60,
								   TrackDurI/60,TrackDurI%60);
			else
				SeekDialog->CurrentTime.Format("%02d:%02d",
								   ShowRemainingTime==1?(int)((TrackDurI-p)/60):p/60,
								   ShowRemainingTime==1?((TrackDurI-p)%60):p%60);
			SeekDialog->CurrentSong=(ShowingMode==2?CurrentFileName:ShowingMode==1?CurrentFileLong:CurrentFile);
			SeekDialog->m_bar.RedrawWindow();

		}
	sprintf(nid.szTip, "%s - %02d:%02d/%02d:%02d",
			ReplaceAmpersand((CurrentFile.GetLength()<=30?CurrentFile:CurrentFile.Left(30)+"...")),
			ShowRemainingTime==1?(int)((TrackDurI-p)/60):p/60,
			ShowRemainingTime==1?((TrackDurI-p)%60):p%60,
			TrackDurI/60,TrackDurI%60);

	MP3Info.Format("%d@%d@%s",
			GetBitrate(fr.lsf,fr.lay,fr.bitrate_index),
			freqs[fr.sampling_frequency],
			fr.mode==0?"Stereo":fr.mode==1?"Joint-stereo":fr.mode==2?"Dual-channel":"Mono");
	if(MP3InfoDlg!=NULL)
		MP3InfoDlg->ReadInfo();

	ForNP=CurrentFileLong;
	if(WAEmuWnd!=NULL)
		WAEmuWnd->SetWindowText(ForNP+" - Winamp");

	SetWindowText("STP: "+ForNP);

	if(IconShown&&updtray)Shell_NotifyIcon(NIM_MODIFY,&(nid));
}

void CMainWnd::UpdMBTRCD(bool updtray)
{
;
}

void CMainWnd::GoNext()
{
	if(GapBtwTracks>0)
		Sleep(GapBtwTracks);

	if(m_RepeatTrack==1)
	{
		m_Player.Close();
		if(m_Player.InitStream())
		{
			SetOut();
			m_Player.Play();
		}
	}
	else
	{
		if(PlayListLength>0)
		{
			m_Player.Close();
			UINT q=0;
			CString lastfolder;
			do
			{
				q++;
				if(ShuffleMode)
				{
					Current=MyRandom(true);
					if(Current==FirstInMyRandom&&m_Repeat!=1)
					{
						if(TryToEnd()) return;
						m_Player.SetInName(PlayList[Current]);
						break;
					}
				}
				else
				{
					int b,e; GetAlbumRange(&b,&e);
					if(Current==e)
					{
						Current=b;
						if(m_Repeat!=1)
						{
							if(TryToEnd()) return;
							m_Player.SetInName(PlayList[Current]);
							break;
						}
					}
					else
						Current++;
				}
				m_Player.SetInName(PlayList[Current]);
				if(!m_Player.InitStream()) continue;
				SetOut();
				m_Player.Play();
				break;
			}
			while(q<PlayListLength*2);
			ReadTag(PlayList[Current]);
		}
	}
	UpdMBTR();
	if(PlaylistDlg!=NULL)           
		PlaylistDlg->m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);

}

bool CMainWnd::TryToEnd()
{
	if(ShutdownAfterEnd)
	{
		Finish();
		OSVERSIONINFO osinfo;
		osinfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
		::GetVersionEx(&osinfo);
		if(osinfo.dwPlatformId==VER_PLATFORM_WIN32_NT)
		{
			HANDLE hToken; 
			TOKEN_PRIVILEGES tkp; 
			
			if (OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) 
			{
				LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tkp.Privileges[0].Luid); 
				tkp.PrivilegeCount = 1;
				tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED; 
				AdjustTokenPrivileges(hToken, FALSE, &tkp, 0, (PTOKEN_PRIVILEGES)NULL, 0); 
				if (GetLastError() == ERROR_SUCCESS) 
					ExitWindowsEx( EWX_POWEROFF | EWX_FORCE,0);
			}
		} else ExitWindowsEx(EWX_SHUTDOWN | EWX_FORCE,0);
		DestroyWindow();	
		AfxPostQuitMessage(0);
		return true;
	} else
	if(ExitAfterEnd)
	{
		Finish();
		DestroyWindow();	
		AfxPostQuitMessage(0);
		return true;
	}
	return false;
}

void CMainWnd::OpenUrl(CString m_URL, bool Add)
{
	CRect rect;

//	if(CDMode) EndCDMode();
	int PLLPrev=PlayListLength;
	if(!Add)
	{
//		StopReadAll();
		PlayList.RemoveAll();
		PlayListAT.RemoveAll();
		Current=0;
		m_Player.Close();
	}

	PlayList.Add(m_URL);
	PlayListAT.Add("");
	PlayListLength=PlayList.GetSize();
	if(!Add||PLLPrev==0)
	{
		ReadTag(m_URL);
		m_Player.SetInName(m_URL);
		if(AutoPlay)
		{
			m_Player.InitStream();
			SetOut();
			m_Player.Play();
		}
	}
	UpdMBTR();
	if(PlaylistDlg!=NULL)
	{
		PlaylistDlg->FillPlaylist();
		PlaylistDlg->ShowFileName();
	}
//	ReadAllTags();
}

void CMainWnd::OnPopupmenuOpenUrl() 
{
	if(opening) return;
	opening=true;
    
	CUrlDlg dialog(IDD_ENTER_URL_DIALOGR);

    int ret;
    ret = dialog.DoModal();
    if (ret == IDOK) {
	CString buf=dialog.m_URL;
	buf.Replace(" ","%20");
	OpenUrl(buf);
	AddRecent(buf);
    }
	opening=false;	
}

CString CMainWnd::ReadTagMin(CString fname)
{
	CString ToReturn=fname;
	ToReturn.Replace('_',' ');
	
	if(ToReturn.Left(7).CompareNoCase("http://")==0||ToReturn.Left(6).CompareNoCase("ftp://")==0)
	{
		ToReturn.Replace("%20"," ");
		int i,j;
		if((i=ToReturn.ReverseFind('.'))>-1)
			if(ToReturn.Mid(i+1,3).CompareNoCase("MP3")==0)
			{
				j=ToReturn.ReverseFind('/');
				ToReturn=ToReturn.Mid(j+1,i-ToReturn.ReverseFind('/')-1);		
			}
		//if(ToReturn.GetLength()>30) ToReturn=ToReturn.Left(30)+"...";
		return ToReturn;
	}
	ToReturn=ToReturn.Mid(ToReturn.ReverseFind('\\')+1);
	return ToReturn;
}

void CMainWnd::OnDrivesMenu(UINT nID) 
{
	CString CDLetter;
	CDLetter.Format("%c",(char)(nID-IDM_DRIVES)+'C');
	OpenFolder(CDLetter+":\\",RandomFirst==1);
}

bool CMainWnd::ExtractLevel(CString s, int l, CString *r)
{
	int i,j;
	int start=0;
	if(s.Left(2)=="\\\\") start=2;
	else
	if(s.Left(7)=="http://") {start=7; l--;}
	else
	if(s.Left(6)=="ftp://") {start=6; l--;}
	if(l==0)
	{
		*r=s.Left(start);
		return true;
	}
	j=start-1;
	for(i=start;i<s.GetLength();i++)
	{
		if(s[i]=='\\'||s[i]=='/')
		{
			l--;
			if(l==0)
			{
				*r=s.Mid(j+1,i-j-1);
				return true;
			}
			j=i;
		}
	}
	return false;
}

CString CMainWnd::ExtractLevelPath(CString s, int l)
{
	int i;
	int start=0;
	if(s.Left(2)=="\\\\") start=2;
	else
	if(s.Left(7)=="http://") {start=7; l--;}
	else
	if(s.Left(6)=="ftp://") {start=6; l--;}
	if(l==0)
		return s.Left(start);
	for(i=start;i<s.GetLength();i++)
	{
		if(s[i]=='\\'||s[i]=='/')
		{
			l--;
			if(l==0)
				return s.Left(i+1);
		}
	}
	return "";
}

int CMainWnd::BuildMenuLevel(HMENU m, int l, unsigned int start, unsigned int finish, CString cur, int *counter)
{
	int cnt=-1;
	if(counter!=NULL) cnt=*counter;
	int cl=cur.GetLength();
	CString buf;
	for(unsigned int i=start;i<finish;i++)
	{
		if(PlayList[i].Left(cl).CompareNoCase(cur)!=0)
			return i-1;

		if(ExtractLevel(PlayList[i],l+1,&buf))
		{
			HMENU nm=::CreatePopupMenu();
			cnt++;
			::AppendMenu(m,MF_POPUP | 0,(UINT)nm,ReplaceAmpersand(buf));
			unsigned int j=BuildMenuLevel(nm,l+1,i,finish,ExtractLevelPath(PlayList[i],l+1));
			if(Current>=i&&Current<=j)
				::SetMenuDefaultItem(m,::GetMenuItemCount(m)-1,TRUE);
			i=j;
			continue;
		}
		cnt++;
		if(PlayListAT[i]!="")
			::AppendMenu(m,MF_STRING | 0,IDM_TRACKS+i,ReplaceAmpersand(PlayListAT[i]));
		else
			::AppendMenu(m,MF_STRING | 0,IDM_TRACKS+i,ReplaceAmpersand(ReadTagMin(PlayList[i])));
		if(i==Current)
		{
			::SetMenuDefaultItem(m,::GetMenuItemCount(m)-1,TRUE);
		}
	}
	if(counter!=NULL) *counter=cnt;
	return i-1;
}

int CMainWnd::GetStartLevel(unsigned int start, unsigned int finish)
{
	int sl=0;
	bool flag;
	unsigned int i;
	CString buf;

	do
	{
		sl++;
		buf=ExtractLevelPath(PlayList[start],sl);
		if(buf=="") {flag=false; break;}
		flag=true;
		for(i=start;i<finish;i++)
		{
			if(PlayList[i].Left(buf.GetLength()).CompareNoCase(buf)!=0)
			{
				flag=false;
				break;
			}
		}
	} while(flag);
	return sl-1;
}

void CMainWnd::LoadSkin()
{
	CString fname=CurrentSkin;
	CStdioFile sknfile;
	if(!sknfile.Open(fname,CFile::modeRead | CFile::shareDenyNone))
	{
	//	Buttons=(HBITMAP)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDB_BUTTONS), IMAGE_BITMAP,90,90, LR_DEFAULTCOLOR);
	//	ButtonsDn=(HBITMAP)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDB_BUTTONSDN), IMAGE_BITMAP,90,90, LR_DEFAULTCOLOR);
		PlayIcon=(HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		StopIcon=(HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		PauseIcon=(HICON)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		CurrentSkin="";
		return;
	}
	CString buf;
	CString CurPath=fname.Left(fname.ReverseFind('\\')+1);
	if(sknfile.ReadString(buf))
	{
		
		if(buf!="*")
		{
			if((PlayIcon=(HICON)::LoadImage(0,CurPath+buf, IMAGE_ICON, 16, 16, LR_LOADFROMFILE))==NULL)
				PlayIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
		} else PlayIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
	} else PlayIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_PLAY), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
	if(sknfile.ReadString(buf))
	{
		if(buf!="*")
		{
			if((PauseIcon=(HICON)::LoadImage(0,CurPath+buf, IMAGE_ICON, 16, 16, LR_LOADFROMFILE))==NULL)
				PauseIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
		} else PauseIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
	} else PauseIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_PAUSE), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
	if(sknfile.ReadString(buf))
	{
		if(buf!="*")
		{
			if((StopIcon=(HICON)::LoadImage(0,CurPath+buf, IMAGE_ICON, 16, 16, LR_LOADFROMFILE))==NULL)
				StopIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
		} else StopIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
	} else StopIcon=(HICON)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(IDI_STOP), IMAGE_ICON,16,16, LR_DEFAULTCOLOR);
	sknfile.Close();
}

void CMainWnd::ResetSkin()
{
	HICON m_hIcon;

    switch (m_Player.PlayerMode()) {
      case pmPlaying:
		m_hIcon = PlayIcon;
		break;
	  case pmPaused:
		m_hIcon = PauseIcon;
		break;
	  default:
		m_hIcon = StopIcon;
		break;
	}
	
	nid.hIcon=m_hIcon;
	if(IconShown)Shell_NotifyIcon(NIM_MODIFY,&nid);
}




void CMainWnd::ClickAction(int action)
{
	switch(action)
	{
	// play-pause
	case 1:
			if(!CDMode)
			{
				if(PlayListLength>0)
				{
					switch (m_Player.PlayerMode()) {
					  case pmClosed:
						m_Player.InitStream();
						SetOut();
						m_Player.Play();
						break;
					  case pmPaused:
						m_Player.Resume();
						break;
					  case pmPlaying:
						m_Player.Pause();
						break;
					}
					UpdMBTR();
				}
			}
		break;
	// stop-play
	case 2:
		
			if(PlayListLength>0)
			{
				switch (m_Player.PlayerMode()) {
					case pmPaused:
					case pmPlaying:
						m_Player.Close();
					break;
					case pmClosed:
						m_Player.InitStream();
						SetOut();
						m_Player.Play();
					break;
				}
				UpdMBTR();
			}
		
		break;
	// prev
	case 3:
		OnPopupmenuPrevious();
		break;
	// next
	case 4:
		OnPopupmenuNext();
		break;
	// tracks
	case 5:
			ShowTracksMenu();
		break;
	// minibar
	case 6:
		::SetForegroundWindow(m_hWnd);
		OnPopupmenuSeek();

	case 7:
			::SetForegroundWindow(m_hWnd);
			OnPopupmenuPlaylisteditor();
		break;
	// equalizer
	case 8:
			::SetForegroundWindow(m_hWnd);
			OnPopupmenuEqualizer();
		break;
	// mp3 info
	case 9:
		if(PlayListLength>0)
		{
			::SetForegroundWindow(m_hWnd);
			OnPopupmenuFileinfo();
		}
		break;
	case 10:
			ShowPopup();
		break;
	// album tracks
	case 11:
			ShowTracksMenu(0, true);
		break;
	}
}

void CMainWnd::BuildMenu(HMENU m)
{
	unsigned int i=0,j=0;
	int cnt=-1;
	int sl;
	CString buf;

	do
	{
		if(PlayList[i].Left(2)=="\\\\")
			buf=PlayList[i].Left(PlayList[i].Find("\\",2)+1);
		else
			buf=PlayList[i].Left(PlayList[i].FindOneOf("\\/")+1);
		do
		{
			i++;
		} while (i<PlayListLength&&PlayList[i].Left(buf.GetLength()).CompareNoCase(buf)==0);
		sl=GetStartLevel(j,i);
		if(sl>0&&!(j==0&&i==PlayListLength))
			if(sl==GetMaxLevel(j,i))
				sl--;
		BuildMenuLevel(m,sl,j,i,"",&cnt);
		j=i;
	} while (i<PlayListLength);
}

int CMainWnd::GetMaxLevel(unsigned int start, unsigned int finish)
{
	int ml=0,cl;
	unsigned int i;
	int j,st;
	CString buf;

	for(i=start;i<finish;i++)
	{
		cl=0;
		if(PlayList[i].Left(2)=="\\\\") st=2;
		else
		if(PlayList[i].Left(7)=="http://") {st=7; cl++;}
		else
		if(PlayList[i].Left(6)=="ftp://") {st=6; cl++;}
		else st=0;
		for(j=st;j<PlayList[i].GetLength();j++)
			if(PlayList[i][j]=='\\'||PlayList[i][j]=='/') cl++;
		if(cl>ml) ml=cl;
	}
	return ml;
}

void CMainWnd::OnPopupmenuSettingsAfterendoftheplaybackExitstp() 
{
	ShutdownAfterEnd=false;
	ExitAfterEnd=!ExitAfterEnd;
	if(ExitAfterEnd)
	{
		if(m_Repeat||m_RepeatTrack)
		{
			m_Repeat=m_RepeatTrack=0;
			MessageBox(MyLoadString(IDS_AUTOEXIT),"STP",MB_OK | MB_ICONWARNING);
		}
	}
}

void CMainWnd::OnUpdatePopupmenuSettingsAfterendoftheplaybackExitstp(CCmdUI* pCmdUI) 
{
	if(ExitAfterEnd)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainWnd::OnPopupmenuSettingsAfterendoftheplaybackTurnoffthecomputer() 
{
	ShutdownAfterEnd=!ShutdownAfterEnd;
	ExitAfterEnd=false;
	if(ShutdownAfterEnd)
	{
		if(m_Repeat||m_RepeatTrack)
		{
			m_Repeat=m_RepeatTrack=0;
			MessageBox(MyLoadString(IDS_AUTOEXIT),"STP",MB_OK | MB_ICONWARNING);
		}
	}
}

void CMainWnd::OnUpdatePopupmenuSettingsAfterendoftheplaybackTurnoff(CCmdUI* pCmdUI) 
{
	if(ShutdownAfterEnd)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}



void CMainWnd::OnTimer(UINT nIDEvent) 
{
	if(SeekDialog!=NULL)
	{
		//    
		pVolume = new CVolume(0);
		SeekDialog->m_vol.SetPos(pVolume->GetCurrentVolume());
		SeekDialog->m_vol.RedrawWindow(NULL,NULL,RDW_INVALIDATE); //  _

	if(JeltiySeek!=1)
		{
			SeekDialog->SetWindowPos(&wndTopMost,0,0,GetSystemMetrics(SM_CXSCREEN),5,SWP_NOACTIVATE);//   
			SeekDialog->m_clock.RedrawWindow(NULL,NULL,RDW_INVALIDATE); //  
		}else
		{
			SeekDialog->SetWindowPos(&wndTopMost,0,0,GetSystemMetrics(SM_CXSCREEN),2,SWP_NOACTIVATE);//   
			SeekDialog->m_clock.RedrawWindow(NULL,NULL,RDW_INVALIDATE); //  
		}
	}


	if(nIDEvent==6)
	{
		if(TraySeeking==false)
		{
			TraySeeking=true;
			KillTimer(6);
			if(PressAndHold==0)
				SetTimer(6,500,NULL);
			else
				SetTimer(6,50,NULL);
		}
		if(PressAndHold==0)
		{
					if(PlayListLength>0&&m_Player.CanSetPos()) m_Player.SetPos(m_Player.GetPos()/10/TrackDurI-1);
					UpdMBTR();
		
		} else
		{
			CurrentVolume-=2;
			if(CurrentVolume<0)CurrentVolume=0;
			pVolume->SetCurrentVolume(CurrentVolume);
			if(SeekDialog!=NULL) SeekDialog->m_vol.SetPos(CurrentVolume);
		}
		return;
	}
	if(nIDEvent==7)
	{
		if(TraySeeking==false)
		{
			TraySeeking=true;
			KillTimer(7);
			if(PressAndHold==0)
				SetTimer(7,500,NULL);
			else
				SetTimer(7,50,NULL);
		}
		if(PressAndHold==0)
		{
					if(PlayListLength>0&&m_Player.CanSetPos()) m_Player.SetPos(m_Player.GetPos()/10/TrackDurI+1);
					UpdMBTR();
		}
		return;
	}
	if(nIDEvent==10)
	{
			if(m_Player.PlayerMode()==pmPlaying)
			{
				UpdMBTR(false);
			}
		return;
	}

	if(nIDEvent==1)
	{
		KillTimer(1);
		switch(lbs)
		{
		case 1:
			ClickAction(Clicks1);
			break;
		case 2:
			ClickAction(Clicks2);
			break;
		case 3:
			ClickAction(Clicks3);
			break;
		case 4:
			ClickAction(Clicks4);
			break;
		}
		lbs=0;
		return;
	}
	if(nIDEvent==2)
	{
		KillTimer(2);
		switch(rbs)
		{
		case 1:
			ClickAction(RClicks1);
			break;
		case 2:
			ClickAction(RClicks2);
			break;
		case 3:
			ClickAction(RClicks3);
			break;
		case 4:
			ClickAction(RClicks4);
			break;
		}
		rbs=0;
		return;
	}

	if(nIDEvent==3)
	{
		KillTimer(3);
		AddFromExp=false;
		return;
	}

	if(nIDEvent==11)
	{
		if(W2Fenabled)
			PerformW2File(false);
		return;
	}
	
	if(nIDEvent==12)
	{
		if(AutEvery)
		{
			PerformAutomation();
			if(AutSaveset)
				SaveSettings();
		}
		return;
	}

	CFrameWnd::OnTimer(nIDEvent);

		

}

void CMainWnd::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	if (lpMeasureItemStruct->itemID == ID_POPUPMENU_PAUSE||
		lpMeasureItemStruct->itemID == ID_POPUPMENU_STOP||
		lpMeasureItemStruct->itemID == ID_POPUPMENU_PREVIOUS||
		lpMeasureItemStruct->itemID == ID_POPUPMENU_NEXT)
		{
			lpMeasureItemStruct->itemHeight=18;
			lpMeasureItemStruct->itemWidth=90-GetSystemMetrics(SM_CXMENUCHECK)*2;
			//if(psI->itemWidth+2*GetSystemMetrics(SM_CXMENUCHECK)<90) psI->itemWidth=90-GetSystemMetrics(SM_CXMENUCHECK)*2;
		} 
	else
    if (lpMeasureItemStruct->itemID == ID_POPUPMENU_PIC)
		lpMeasureItemStruct->itemWidth = 20-GetSystemMetrics(SM_CXMENUCHECK);
}

void CMainWnd::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
    if (lpDrawItemStruct->itemID == ID_POPUPMENU_PIC && lpDrawItemStruct->itemAction == ODA_DRAWENTIRE)
	{
        RECT sRect;

        ::GetMenuItemRect(m_hWnd,(HMENU)lpDrawItemStruct->hwndItem,1, &sRect);
		int menutop=sRect.top;

        ::GetMenuItemRect(m_hWnd,(HMENU)lpDrawItemStruct->hwndItem,::GetMenuItemCount((HMENU)lpDrawItemStruct->hwndItem)-1, &sRect);
		int menubottom=sRect.bottom;

        HDC hDC = CreateCompatibleDC(lpDrawItemStruct->hDC);
        hMenuBitmap = (HBITMAP)SelectObject(hDC, hMenuBitmap);

        lpDrawItemStruct->rcItem.bottom = (menubottom - menutop);
        BitBlt(lpDrawItemStruct->hDC, lpDrawItemStruct->rcItem.left, lpDrawItemStruct->rcItem.bottom - 100, 20, 100, hDC, 0, 0, SRCCOPY);

        if (lpDrawItemStruct->rcItem.bottom - 100 > 0)
		{
            lpDrawItemStruct->rcItem.top = 0;
            lpDrawItemStruct->rcItem.bottom = lpDrawItemStruct->rcItem.bottom-100;
			lpDrawItemStruct->rcItem.right = lpDrawItemStruct->rcItem.left+20;

            FillRect(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, (HBRUSH)GetStockObject(BLACK_BRUSH));
        }

        hMenuBitmap = (HBITMAP)SelectObject(hDC, hMenuBitmap);
        DeleteDC(hDC);
	}


}


void CMainWnd::OnPopupmenuShowTotaltracktime() 
{
	if(ShowTTT) ShowTTT=0; else ShowTTT=1;
	UpdMBTR();
}

void CMainWnd::OnUpdatePopupmenuShowTotaltracktime(CCmdUI* pCmdUI) 
{
	if(ShowTTT)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainWnd::OnPopupmenuSettingsStopaftereachalbum() 
{
	if(AlbumStop)
		AlbumStop=0;
	else
		AlbumStop=1;
}

void CMainWnd::OnUpdatePopupmenuSettingsStopaftereachalbum(CCmdUI* pCmdUI) 
{
	if(AlbumStop)
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}

void CMainWnd::GetAlbumRange(int *b, int *e, bool force, int track)
{
	if(track==-1) track=Current;
	if(!AlbumStop&&!force)
	{
		*b=0;
		*e=PlayListLength-1;
	}
	else
	{
		CString lastfolder=PlayList[track].Left(1+PlayList[track].ReverseFind('\\')+PlayList[track].ReverseFind('/'));
		int i;
		for(i=track-1;i>=0;i--)
			if(lastfolder.CompareNoCase(PlayList[i].Left(1+PlayList[i].ReverseFind('\\')+PlayList[i].ReverseFind('/')))!=0)
				break;
		*b=i+1;
		for(i=track+1;i<PlayListLength;i++)
			if(lastfolder.CompareNoCase(PlayList[i].Left(1+PlayList[i].ReverseFind('\\')+PlayList[i].ReverseFind('/')))!=0)
				break;
		*e=i-1;
	}
}

void CMainWnd::BuildAlbumMenu(HMENU m)
{
	int start, finish, cnt=-1;
	GetAlbumRange(&start,&finish, true);
	for(unsigned int i=start;i<=finish;i++)
	{
		cnt++;
		if(PlayListAT[i]!="")
			::AppendMenu(m,MF_STRING | 0,IDM_TRACKS+i,ReplaceAmpersand(PlayListAT[i]));
		else
			::AppendMenu(m,MF_STRING | 0,IDM_TRACKS+i,ReplaceAmpersand(ReadTagMin(PlayList[i])));
		if(i==Current)
		{
			::SetMenuDefaultItem(m,::GetMenuItemCount(m)-1,TRUE);
		}
	}

}

void CMainWnd::SaveSettings()
{


	theApp.WriteProfileInt(theApp.user,"InfoX",InfoX);
	theApp.WriteProfileInt(theApp.user,"InfoY",InfoY);
	theApp.WriteProfileInt(theApp.user,"SBDockR",SBDockR);
	theApp.WriteProfileInt(theApp.user,"SBDockB",SBDockB);
	theApp.WriteProfileInt(theApp.user,"SeekBarX",SeekBarX);
	theApp.WriteProfileInt(theApp.user,"SeekBarY",SeekBarY);
	theApp.WriteProfileInt(theApp.user,"SeekBarW",SeekBarW);
	theApp.WriteProfileInt(theApp.user,"EqualizerX",EqualizerX);
	theApp.WriteProfileInt(theApp.user,"EqualizerY",EqualizerY);
	theApp.WriteProfileInt(theApp.user,"PlaylistX",PlaylistX);
	theApp.WriteProfileInt(theApp.user,"PlaylistY",PlaylistY);
	theApp.WriteProfileInt(theApp.user,"PlaylistW",PlaylistW);
	theApp.WriteProfileInt(theApp.user,"PlaylistH",PlaylistH);
	theApp.WriteProfileInt(theApp.user,"Clicks1",Clicks1);
	theApp.WriteProfileInt(theApp.user,"Clicks2",Clicks2);
	theApp.WriteProfileInt(theApp.user,"Clicks3",Clicks3);
	theApp.WriteProfileInt(theApp.user,"Clicks4",Clicks4);
	theApp.WriteProfileInt(theApp.user,"RClicks1",RClicks1);
	theApp.WriteProfileInt(theApp.user,"RClicks2",RClicks2);
	theApp.WriteProfileInt(theApp.user,"RClicks3",RClicks3);
	theApp.WriteProfileInt(theApp.user,"RClicks4",RClicks4);
//	theApp.WriteProfileString(theApp.user,"CDLetter",CDLetter);
//	theApp.WriteProfileString(theApp.user,"CurrentSkin",CurrentSkin);
	theApp.WriteProfileString(theApp.user,"CDDBSvr",CDDBServer);
	theApp.WriteProfileString(theApp.user,"EMailAddress",EMailAddress);
	theApp.WriteProfileString(theApp.user,"RNTemplate",RNTemplate);
	theApp.WriteProfileInt(theApp.user,"DockMinibar",DockSD);
	theApp.WriteProfileInt(theApp.user,"SMTracks",SMTracks);
	theApp.WriteProfileInt(theApp.user,"SMAlbum",SMAlbum);
	theApp.WriteProfileInt(theApp.user,"ADevice",ADevice);
	theApp.WriteProfileInt(theApp.user,"MDevice",MDevice);
	theApp.WriteProfileInt(theApp.user,"ForceMono",ForceMono);
	theApp.WriteProfileInt(theApp.user,"Downsampling",Downsampling);
	theApp.WriteProfileInt(theApp.user,"PressAndHold",PressAndHold);
	theApp.WriteProfileInt(theApp.user,"ShowRemainingTime",ShowRemainingTime);
	theApp.WriteProfileInt(theApp.user,"ShowTTT",ShowTTT);
//	theApp.WriteProfileInt(theApp.user,"ExtPlaylistFormat",ExtPlaylistFormat);
	theApp.WriteProfileInt(theApp.user,"AutoCDDB",AutoCDDB);
	theApp.WriteProfileInt(theApp.user,"AlbumStop",AlbumStop);
	theApp.WriteProfileInt(theApp.user,"ShowingMode",ShowingMode);	
	theApp.WriteProfileInt(theApp.user,"NoClicks",NoClicks);
	theApp.WriteProfileInt(theApp.user,"PlaylistOnTop",PlaylistOnTop);
	theApp.WriteProfileInt(theApp.user,"EQOnTop",EQOnTop);
	theApp.WriteProfileInt(theApp.user,"InfoOnTop",InfoOnTop);
	theApp.WriteProfileInt(theApp.user,"WAEmu",WAEmu);
	theApp.WriteProfileInt(theApp.user,"JeltiySeek",JeltiySeek);
	theApp.WriteProfileInt(theApp.user,"AutoPlay",AutoPlay);
	theApp.WriteProfileInt(theApp.user,"RandomFirst",RandomFirst);
	theApp.WriteProfileInt(theApp.user,"OutputModule",OutputModule);
	theApp.WriteProfileInt(theApp.user,"Gap",GapBtwTracks);
	theApp.WriteProfileInt(theApp.user,"ModeKey",m_ModeKey);
	theApp.WriteProfileInt(theApp.user,"ModeMod",m_ModeMod);
	theApp.WriteProfileInt(theApp.user,"NPKey",m_NPKey);
	theApp.WriteProfileInt(theApp.user,"NPMod",m_NPMod);
	theApp.WriteProfileInt(theApp.user,"ExitMod",m_ExitMod);
	theApp.WriteProfileInt(theApp.user,"ExitKey",m_ExitKey);

	theApp.WriteProfileInt(theApp.user,"JeltiyKey",m_JeltiyKey);
	theApp.WriteProfileInt(theApp.user,"JeltiyMod",m_JeltiyMod);

	theApp.WriteProfileInt(theApp.user,"ForwKey",m_ForwKey);
	theApp.WriteProfileInt(theApp.user,"ForwMod",m_ForwMod);
	theApp.WriteProfileInt(theApp.user,"BackKey",m_BackKey);
	theApp.WriteProfileInt(theApp.user,"BackMod",m_BackMod);
	theApp.WriteProfileInt(theApp.user,"PlayKey",m_PlayKey);
	theApp.WriteProfileInt(theApp.user,"PlayMod",m_PlayMod);
	theApp.WriteProfileInt(theApp.user,"StopKey",m_StopKey);
	theApp.WriteProfileInt(theApp.user,"StopMod",m_StopMod);
	theApp.WriteProfileInt(theApp.user,"PrevKey",m_PrevKey);
	theApp.WriteProfileInt(theApp.user,"PrevMod",m_PrevMod);
	theApp.WriteProfileInt(theApp.user,"NextKey",m_NextKey);
	theApp.WriteProfileInt(theApp.user,"NextMod",m_NextMod);
	theApp.WriteProfileInt(theApp.user,"VUpKey",m_VUpKey);
	theApp.WriteProfileInt(theApp.user,"VUpMod",m_VUpMod);
	theApp.WriteProfileInt(theApp.user,"VDownKey",m_VDownKey);
	theApp.WriteProfileInt(theApp.user,"VDownMod",m_VDownMod);
	theApp.WriteProfileInt(theApp.user,"OpenKey1",m_OpenKey1);
	theApp.WriteProfileInt(theApp.user,"OpenMod1",m_OpenMod1);
	theApp.WriteProfileInt(theApp.user,"OpenKey2",m_OpenKey2);
	theApp.WriteProfileInt(theApp.user,"OpenMod2",m_OpenMod2);
	theApp.WriteProfileInt(theApp.user,"OpenKey3",m_OpenKey3);
	theApp.WriteProfileInt(theApp.user,"OpenMod3",m_OpenMod3);
	theApp.WriteProfileInt(theApp.user,"MinibarKey",m_MinibarKey);
	theApp.WriteProfileInt(theApp.user,"MinibarMod",m_MinibarMod);
	theApp.WriteProfileInt(theApp.user,"MP3InfoKey",m_MP3InfoKey);
	theApp.WriteProfileInt(theApp.user,"MP3InfoMod",m_MP3InfoMod);
	theApp.WriteProfileInt(theApp.user,"PlstKey",m_PlaylistKey);
	theApp.WriteProfileInt(theApp.user,"PlstMod",m_PlaylistMod);
	theApp.WriteProfileInt(theApp.user,"EqualizerKey",m_EqualizerKey);
	theApp.WriteProfileInt(theApp.user,"EqualizerMod",m_EqualizerMod);
	theApp.WriteProfileInt(theApp.user,"RptKey",m_RepeatKey);
	theApp.WriteProfileInt(theApp.user,"RptMod",m_RepeatMod);
	theApp.WriteProfileInt(theApp.user,"ShflKey",m_ShuffleKey);
	theApp.WriteProfileInt(theApp.user,"ShflMod",m_ShuffleMod);
	theApp.WriteProfileInt(theApp.user,"AlbummodeKey",m_AlbummodeKey);
	theApp.WriteProfileInt(theApp.user,"AlbummodeMod",m_AlbummodeMod);
	theApp.WriteProfileInt(theApp.user,"TrayIconKey",m_TrayIconKey);
	theApp.WriteProfileInt(theApp.user,"TrayIconMod",m_TrayIconMod);
	theApp.WriteProfileInt(theApp.user,"MenuKey",m_MenuKey);
	theApp.WriteProfileInt(theApp.user,"MenuMod",m_MenuMod);
	theApp.WriteProfileInt(theApp.user,"TracksKey",m_TracksKey);
	theApp.WriteProfileInt(theApp.user,"TracksMod",m_TracksMod);
	theApp.WriteProfileInt(theApp.user,"AlbumKey",m_AlbumKey);
	theApp.WriteProfileInt(theApp.user,"AlbumMod",m_AlbumMod);
	theApp.WriteProfileInt(theApp.user,"AutomationKey",m_AutomationKey);
	theApp.WriteProfileInt(theApp.user,"AutomationMod",m_AutomationMod);
	theApp.WriteProfileString(theApp.user,"OutPath",OutPath);
	theApp.WriteProfileString(theApp.user,"InitDir",InitDir);
	theApp.WriteProfileString(theApp.user,"Recent0",Recent[0]);
	theApp.WriteProfileString(theApp.user,"Recent1",Recent[1]);
	theApp.WriteProfileString(theApp.user,"Recent2",Recent[2]);
	theApp.WriteProfileString(theApp.user,"Recent3",Recent[3]);
	theApp.WriteProfileString(theApp.user,"Recent4",Recent[4]);
	theApp.WriteProfileString(theApp.user,"Recent5",Recent[5]);
	theApp.WriteProfileString(theApp.user,"Recent6",Recent[6]);
	theApp.WriteProfileString(theApp.user,"Recent7",Recent[7]);
	theApp.WriteProfileString(theApp.user,"Recent8",Recent[8]);
	theApp.WriteProfileString(theApp.user,"Recent9",Recent[9]);
	theApp.WriteProfileInt(theApp.user,"IncludeWAVs",IncludeWAVs);
	theApp.WriteProfileInt(theApp.user,"EQPreset",EQPreset);
	theApp.WriteProfileInt(theApp.user,"Buffers",BuffersType);
	theApp.WriteProfileInt(theApp.user,"InputBuffers",InputBuffersType);
	theApp.WriteProfileInt(theApp.user,"Priority",PlayerPriority);
	theApp.WriteProfileInt(theApp.user,"Repeat",m_Repeat);
	theApp.WriteProfileInt(theApp.user,"RepeatTrack",m_RepeatTrack);
	theApp.WriteProfileInt(theApp.user,"ShuffleMode",ShuffleMode);
	theApp.WriteProfileInt(theApp.user,"Preamp",m_preamp);
	theApp.WriteProfileInt(theApp.user,"EnableEQ",m_EEQ);
	theApp.WriteProfileInt(theApp.user,"EQ1",m_s1);
	theApp.WriteProfileInt(theApp.user,"EQ2",m_s2);
	theApp.WriteProfileInt(theApp.user,"EQ3",m_s3);
	theApp.WriteProfileInt(theApp.user,"EQ4",m_s4);
	theApp.WriteProfileInt(theApp.user,"EQ5",m_s5);
	theApp.WriteProfileInt(theApp.user,"EQ6",m_s6);
	theApp.WriteProfileInt(theApp.user,"EQ7",m_s7);
	theApp.WriteProfileInt(theApp.user,"EQ8",m_s8);
	theApp.WriteProfileInt(theApp.user,"EQ9",m_s9);
	theApp.WriteProfileInt(theApp.user,"EQ10",m_s10);
	theApp.WriteProfileString(theApp.user,"W2Ffile",W2Ffile);
	theApp.WriteProfileString(theApp.user,"W2Fplay","\""+W2Fplay+"\"");
	theApp.WriteProfileString(theApp.user,"W2Fpause","\""+W2Fpause+"\"");
	theApp.WriteProfileString(theApp.user,"W2Fstop","\""+W2Fstop+"\"");
	theApp.WriteProfileString(theApp.user,"W2Fexit","\""+W2Fexit+"\"");
	theApp.WriteProfileInt(theApp.user,"W2Foem",W2Foem);
	theApp.WriteProfileInt(theApp.user,"W2Fdel",W2Fdel);
	theApp.WriteProfileInt(theApp.user,"W2Fenabled",W2Fenabled);
	theApp.WriteProfileInt(theApp.user,"AutSort",AutSort);
	theApp.WriteProfileInt(theApp.user,"AutRemove",AutRemove);
	theApp.WriteProfileInt(theApp.user,"AutRemovedup",AutRemovedup);
	theApp.WriteProfileInt(theApp.user,"AutRescan",AutRescan);
	theApp.WriteProfileInt(theApp.user,"AutPeriod",AutPeriod);
	theApp.WriteProfileInt(theApp.user,"AutEvery",AutEvery);
	theApp.WriteProfileInt(theApp.user,"AutOnStart",AutOnStart);
	theApp.WriteProfileInt(theApp.user,"AutSaveset",AutSaveset);

	int AutDirsCnt=AutDirs.GetSize();
	theApp.WriteProfileInt(theApp.user,"AutDirsCnt",AutDirsCnt);

	CString adtmp;
	for(int i=0;i<AutDirsCnt;i++)
	{
		adtmp.Format("%d",i+1);
		theApp.WriteProfileString(theApp.user,"AutDir"+adtmp,AutDirs[i]);
	}

	int q;
	q=presets.GetSize();
	theApp.WriteProfileInt(theApp.user,"Presets",q);

	CString buf,buf2;
	for(i=0;i<q;i++)
	{
		buf2.Format("PresetName%d",i);
		theApp.WriteProfileString(theApp.user,buf2,presets[i].Left(presets[i].Find('\t')));
		buf2.Format("PresetEQ%d",i);
		theApp.WriteProfileString(theApp.user,buf2,presets[i].Mid(presets[i].Find('\t')+1));
	}

	SaveThePlaylist();
}

bool CMainWnd::IsAudioCD()
{
	char buf2[64];
	mciSendString("status stp number of tracks",buf2,64,NULL);
	int q=atoi(buf2);
	
	MCI_STATUS_PARMS sMCIStatus;
    sMCIStatus.dwItem = MCI_CDA_STATUS_TYPE_TRACK;
	
	for(sMCIStatus.dwTrack=1;sMCIStatus.dwTrack<=q;sMCIStatus.dwTrack++)
	{
		mciSendCommand (mciGetDeviceID("stp"), MCI_STATUS, MCI_STATUS_ITEM | MCI_TRACK | MCI_WAIT, 
						(DWORD) (LPVOID) &sMCIStatus);
		if (sMCIStatus.dwReturn == MCI_CDA_TRACK_AUDIO) return true;

	}

	return false;
}

void CMainWnd::OnUpdatePopupmenuDiskPlaylist(CCmdUI* pCmdUI) 
{
	if(IsAudioCD())
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
}

void CMainWnd::OnUpdatePopupmenuCddb(CCmdUI* pCmdUI) 
{
	if(IsAudioCD())
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
}

void CMainWnd::PerformAutomation()
{
	bool b=false;
	if(AutRemove||AutRemovedup||AutRescan||AutSort)
//		b=StopReadAll();
	if(AutRescan) b=true;

	if(AutRemove)
	{
		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->m_playlistat.SetRedraw(FALSE);
		}
		int i=0;
		bool CurDeleted=false, deleted=false;
		while(i<PlayList.GetSize()&&PlayList.GetSize()>0)
			if(!PlaylistDlg->FileExists(PlayList[i]))
			{
				deleted=true;
				if(PlaylistDlg!=NULL)
					PlaylistDlg->m_playlistat.DeleteString(i);
				PlayList.RemoveAt(i);
				PlayListAT.RemoveAt(i);
				if(i<Current)Current--;
				else if(i==Current&&!CurDeleted) CurDeleted=true;
			} else i++;
		PlayListLength=PlayList.GetSize();
		if(CurDeleted)
		{
			Current=0;
			if(PlayListLength>0)
			{
				ReadTag(PlayList[Current]);
				m_Player.Close();
				m_Player.SetInName(PlayList[Current]);
			}
			else
			{
				m_Player.Close();
				CRect rect;
				if(MP3InfoDlg!=NULL)
				{
					MP3InfoDlg->SaveWindowPosAndDestroy();
				}
			}
			UpdMBTR();
		}
		if(PlaylistDlg!=NULL&&deleted)
			PlaylistDlg->m_playlistat.SetSel(-1,FALSE);

		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->ShowFileName();
			PlaylistDlg->m_playlistat.SetRedraw(TRUE);
			PlaylistDlg->m_playlistat.Invalidate();
		}
	}

	if(AutRemovedup)
	{
		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->m_playlistat.SetRedraw(FALSE);
		}
		int i=0,j;
		bool deleted=false;
		while(i<PlayList.GetSize()&&PlayList.GetSize()>0)
		{
			j=i+1;
			while(j<PlayList.GetSize())
			{
				if(PlayList[i]==PlayList[j])
				{
					if(PlaylistDlg!=NULL)
						PlaylistDlg->m_playlistat.DeleteString(j);
					deleted=true;
					PlayList.RemoveAt(j);
					PlayListAT.RemoveAt(j);
					if(j<Current)Current--;
					else if(j==Current) Current=i;
				} else j++;
			}
			i++;
		}
		PlayListLength=PlayList.GetSize();
		if(PlaylistDlg!=NULL&&deleted)
			PlaylistDlg->m_playlistat.SetSel(-1,FALSE);

		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->ShowFileName();
			PlaylistDlg->m_playlistat.SetRedraw(TRUE);
			PlaylistDlg->m_playlistat.Invalidate();
		}
	}
	
	if(AutRescan)
	{
		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->m_playlistat.SetRedraw(FALSE);
		}
		int PLLPrev=PlayListLength;
		for(int i=0;i<AutDirs.GetSize();i++)
		{
			FindMP3Files(AutDirs[i], true);
		}
		PlayListLength=PlayList.GetSize();
		SortRec(PLLPrev, PlayListLength-1);

		if((RandomFirst||ShuffleMode)&&PLLPrev==0)
			FirstInMyRandom=Current=MyRandom(true, true);
		else
			if(PLLPrev==0){Current=0;FirstInMyRandom=-1;}

		if(PlaylistDlg!=NULL)
		{
			if(PlayListLength!=PLLPrev)
			{
				PlaylistDlg->FillPlaylist();
				PlaylistDlg->ShowFileName();
			}
			PlaylistDlg->m_playlistat.SetRedraw(TRUE);
			PlaylistDlg->m_playlistat.Invalidate();
		}
			
		if(PLLPrev==0)
		{
			m_Player.Close();

			bool first=true;
			int q=0;
			do
			{
				if(!first)
				{
					if(Current<PlayListLength-1)
					{
						Current++;
					}
					else
					{
						Current=0;
						q++;
						if(m_Repeat!=1)
							break;
					}
				} else first=false;
				m_Player.SetInName(PlayList[Current]);
				if(!m_Player.InitStream()) continue;
				m_Player.Close();
				break;
			}
			while(q<2);
			ReadTag(PlayList[Current]);
			UpdMBTR();
		}
	}

	if(AutSort)
	{
		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->m_playlistat.SetRedraw(FALSE);
		}

		SortRec(0,PlayListLength-1,true);

		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->ShowFileName();
			PlaylistDlg->m_playlistat.SetTopIndex(PlaylistDlg->m_playlistat.GetFirstSelected()!=-1?PlaylistDlg->m_playlistat.GetFirstSelected():Current);
			PlaylistDlg->m_playlistat.SetRedraw(TRUE);
			PlaylistDlg->m_playlistat.Invalidate();
		}
	}
//	if(b) ReadAllTags();
}

void CMainWnd::PerformW2File(bool ex)
{
	if(W2Ffile!="")
	{
		CStdioFile f;
		if(f.Open(W2Ffile,CFile::modeCreate | CFile::modeWrite))
		{
			CString buf;
			if(!ex)
			{
				if(!CDMode)
				{
					switch(m_Player.PlayerMode())
					{
					case pmPlaying:
						{
							buf=W2Fplay;
							buf.Replace("%t","%T");
							buf.Replace("%T",ForNP);
							break;
						}
					case pmPaused:
						{
							buf=W2Fpause;
							buf.Replace("%t","%T");
							buf.Replace("%T",ForNP);
							break;
						}
					default:
						{
							buf=W2Fstop;
							buf.Replace("%t","%T");
							buf.Replace("%T",ForNP);
							break;
						}
					}
				}
			} else buf=W2Fexit;
			if(W2Foem) buf.AnsiToOem();
			buf.TrimLeft(); buf.TrimRight();
			f.WriteString(buf);
			f.Close();
			if(W2Fdel&&ex) ::DeleteFile(W2Ffile);
		}
	}
}

void CMainWnd::OnAutomationSetup() 
{
	if(AutDlg==NULL)
	{
		AutDlg=new CAutDlg(IDD_AUTOMATIONR);
		AutDlg->Create(IDD_AUTOMATIONR,pMainFrame);
	}
	else AutDlg->SetFocus();	
}

void CMainWnd::OnAutomationPerformnow() 
{
	PerformAutomation();
	if(AutSaveset)
		SaveSettings();
}

void CMainWnd::RegHotKeys()
{
	if(m_PlayKey!=0)
		RegisterHotKey(m_hWnd, 101, m_PlayMod, m_PlayKey);
	if(m_StopKey!=0)
		RegisterHotKey(m_hWnd, 102, m_StopMod, m_StopKey);
	if(m_PrevKey!=0)
		RegisterHotKey(m_hWnd, 103, m_PrevMod, m_PrevKey);
	if(m_NextKey!=0)
		RegisterHotKey(m_hWnd, 104, m_NextMod, m_NextKey);
	if(m_VDownKey!=0)
		RegisterHotKey(m_hWnd, 202, m_VDownMod, m_VDownKey);
	if(m_VUpKey!=0)
		RegisterHotKey(m_hWnd, 201, m_VUpMod, m_VUpKey);
	if(m_OpenKey1!=0)
		RegisterHotKey(m_hWnd, 301, m_OpenMod1, m_OpenKey1);
	if(m_OpenKey2!=0)
		RegisterHotKey(m_hWnd, 302, m_OpenMod2, m_OpenKey2);
	if(m_OpenKey3!=0)
		RegisterHotKey(m_hWnd, 303, m_OpenMod3, m_OpenKey3);
	if(m_MinibarKey!=0)
		RegisterHotKey(m_hWnd, 501, m_MinibarMod, m_MinibarKey);
	if(m_MP3InfoKey!=0)
		RegisterHotKey(m_hWnd, 901, m_MP3InfoMod, m_MP3InfoKey);
	if(m_PlaylistKey!=0)
		RegisterHotKey(m_hWnd, 801, m_PlaylistMod, m_PlaylistKey);
	if(m_EqualizerKey!=0)
		RegisterHotKey(m_hWnd, 601, m_EqualizerMod, m_EqualizerKey);
	if(m_RepeatKey!=0)
		RegisterHotKey(m_hWnd, 701, m_RepeatMod, m_RepeatKey);
	if(m_ShuffleKey!=0)
		RegisterHotKey(m_hWnd, 401, m_ShuffleMod, m_ShuffleKey);
	if(m_AlbummodeKey!=0)
		RegisterHotKey(m_hWnd, 1601, m_AlbummodeMod, m_AlbummodeKey);
	if(m_ExitKey!=0)
		RegisterHotKey(m_hWnd, 1001, m_ExitMod, m_ExitKey);
	if(m_ModeKey!=0)
		RegisterHotKey(m_hWnd, 1101, m_ModeMod, m_ModeKey);
	if(m_NPKey!=0)
		RegisterHotKey(m_hWnd, 1201, m_NPMod, m_NPKey);
	if(m_ForwKey!=0)
		RegisterHotKey(m_hWnd, 1301, m_ForwMod, m_ForwKey);
	if(m_BackKey!=0)
		RegisterHotKey(m_hWnd, 1302, m_BackMod, m_BackKey);
	if(m_TrayIconKey!=0)
		RegisterHotKey(m_hWnd, 1401, m_TrayIconMod, m_TrayIconKey);
	if(m_MenuKey!=0)
		RegisterHotKey(m_hWnd, 1501, m_MenuMod, m_MenuKey);
	if(m_TracksKey!=0)
		RegisterHotKey(m_hWnd, 1502, m_TracksMod, m_TracksKey);
	if(m_AlbumKey!=0)
		RegisterHotKey(m_hWnd, 1503, m_AlbumMod, m_AlbumKey);
	if(m_AutomationKey!=0)
		RegisterHotKey(m_hWnd, 1701, m_AutomationMod, m_AutomationKey);
	if(m_JeltiyKey!=0)
		RegisterHotKey(m_hWnd, 1802, m_JeltiyMod, m_JeltiyKey);
}

void CMainWnd::UnregHotKeys()
{
	UnregisterHotKey(m_hWnd, 101);
	UnregisterHotKey(m_hWnd, 102);
	UnregisterHotKey(m_hWnd, 103);
	UnregisterHotKey(m_hWnd, 104);
	UnregisterHotKey(m_hWnd, 201);
	UnregisterHotKey(m_hWnd, 202);

	UnregisterHotKey(m_hWnd, 301);
	UnregisterHotKey(m_hWnd, 302);
	UnregisterHotKey(m_hWnd, 303);
	UnregisterHotKey(m_hWnd, 401);
	UnregisterHotKey(m_hWnd, 501);
	UnregisterHotKey(m_hWnd, 601);
	UnregisterHotKey(m_hWnd, 701);
	UnregisterHotKey(m_hWnd, 801);
	UnregisterHotKey(m_hWnd, 901);

	UnregisterHotKey(m_hWnd, 1001);
	UnregisterHotKey(m_hWnd, 1101);

	UnregisterHotKey(m_hWnd, 1201);

	UnregisterHotKey(m_hWnd, 1301);
	UnregisterHotKey(m_hWnd, 1302);

	UnregisterHotKey(m_hWnd, 1401);

	UnregisterHotKey(m_hWnd, 1501);
	UnregisterHotKey(m_hWnd, 1502);
	UnregisterHotKey(m_hWnd, 1503);

	UnregisterHotKey(m_hWnd, 1601);

	UnregisterHotKey(m_hWnd, 1701);

	UnregisterHotKey(m_hWnd, 1802);
}

void CMainWnd::GetPosForMenu(LPPOINT point)
{
	CRect rect1,rect2,rect3;
	::GetWindowRect(::FindWindow("Shell_TrayWnd",NULL),&rect1);
	::GetWindowRect(::GetDesktopWindow(),&rect2);
	::SystemParametersInfo(SPI_GETWORKAREA,0,&rect3,0);
	if(rect1.right<rect2.right)
	{
		point->x=rect3.left;
		point->y=rect3.top;
	} else
	if(rect1.left>rect2.left)
	{
		point->x=rect3.right;
		point->y=rect3.top;
	} else
	if(rect1.bottom<rect2.bottom)
	{
		point->x=rect3.right;
		point->y=rect3.top;
	} else
	{
		point->x=rect3.right;
		point->y=rect3.bottom;
	}
}
