// PlaylistDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "PlaylistDlg.h"
#include "MainWnd.h"
#include "TagEditor.h"
#include "SeekDialog.h"
#include "MP3InfoDlg.h"
#include "RenameDlg.h"
#include "SearcherDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSysTrayPlayApp theApp;

extern CMainWnd* pMainFrame;
extern CPlaylistDlg *PlaylistDlg;
extern CSeekDialog *SeekDialog;
extern CMP3InfoDlg *MP3InfoDlg;
extern CSearcherDlg *SearcherDlg;

//extern void ReadAllTags();
//extern bool StopReadAll();
extern CString ReadTagAT(CString fname);

extern unsigned long rnd;
extern double frand();

static int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	CString dir;
	dir=pMainFrame->InitDir;
	if(dir.Right(1)=="\\")
		dir=dir.Left(dir.GetLength()-1);

	if (uMsg == BFFM_INITIALIZED)
		::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)LPCTSTR(dir));
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CPlaylistDlg dialog


CPlaylistDlg::CPlaylistDlg(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CPlaylistDlg)
	//}}AFX_DATA_INIT
	CanResize=false;
}


void CPlaylistDlg::DoDataExchange(CDataExchange* pDX)
{

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlaylistDlg)
	DDX_Control(pDX, IDC_FILENAME, m_filename);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_PLAYLIST_AT, m_playlistat);
//	DDX_Control(pDX, IDC_SEARCH, m_search);
}


BEGIN_MESSAGE_MAP(CPlaylistDlg, CDialog)
	//{{AFX_MSG_MAP(CPlaylistDlg)
	ON_WM_CLOSE()
	ON_COMMAND(ID_FILE_ADDFILE, OnFileAddfile)
	ON_COMMAND(ID_FILE_ADDFOLDER, OnFileAddfolder)
	ON_COMMAND(ID_FILE_EDITTAG, OnFileEdittag)
	ON_COMMAND(ID_FILE_REMOVE, OnFileRemove)
	ON_COMMAND(ID_PLAYLIST_OPEN, OnPlaylistOpen)
	ON_COMMAND(ID_PLAYLIST_SAVE, OnPlaylistSave)
	ON_COMMAND(ID_SEARCHER_CALL, OnSearcherCall)
	ON_COMMAND(ID_ARRANGE_SHUFFLE, OnArrangeShuffle)
	ON_COMMAND(ID_ARRANGE_SORT, OnArrangeSort)
	ON_COMMAND(ID_ARRANGE_SORTBYFILENAME, OnArrangeSortbyfilename)
	ON_COMMAND(ID_TRACKS_SELECTION_ADDTOEXISTENTPLAYLIST, OnTracksSelectionAddtoexistentplaylist)
	ON_COMMAND(ID_TRACKS_SELECTION_CREATENEWPLAYLIST, OnTracksSelectionCreatenewplaylist)
	ON_COMMAND(ID_TRACKS_ADDPLAYLIST, OnTracksAddplaylist)
	ON_LBN_KILLFOCUS(IDC_PLAYLIST_AT, OnKillfocusPlaylistAt)
	ON_COMMAND(ID_ARRANGE_REMOVENE, OnArrangeRemovene)
	ON_COMMAND(ID_ARRANGE_REMOVEDUPLICATEENTRIES, OnArrangeRemoveduplicateentries)
	ON_COMMAND(ID_WINDOW_RESTOR, OnWindowRestor)
//	ON_EN_CHANGE(IDC_SEARCH, OnChangeSearch)
	ON_COMMAND(ID_TRACKS_REMOVEALL, OnTracksRemoveall)
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	ON_COMMAND(ID_POPUP_SELECTALL, OnPopupSelectall)
//	ON_COMMAND(ID_TRACKS_REREADALLTAGS, OnTracksRereadalltags)
	ON_COMMAND(ID_TRACKS_RENAMEFILES, OnTracksRenamefiles)
	ON_COMMAND(ID_TRACKS_FILEMANAGEMENT_DELETE, OnTracksFilemanagementDelete)
	ON_COMMAND(ID_TRACKS_FILEMANAGEMENT_COPYTO, OnTracksFilemanagementCopyto)
	ON_COMMAND(ID_TRACKS_FILEMANAGEMENT_MOVETO, OnTracksFilemanagementMoveto)
//	ON_COMMAND(ID_FILE_SAVEINEXTENDEDFORMAT, OnFileSaveinextendedformat)
	//}}AFX_MSG_MAP
	ON_WM_ENTERMENULOOP()
	ON_WM_DROPFILES()
	ON_WM_SYSCOMMAND()
	ON_COMMAND_RANGE(IDM_TRACKS,IDM_TRACKS+9000,OnTrackMenu)
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CPLLB,CListBox)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND( )
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CSrchEdit,CEdit)
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlaylistDlg message handlers

BOOL CPlaylistDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	SetIcon(pMainFrame->StpIcon, TRUE);
	SetIcon(pMainFrame->StpIconSm, FALSE);

	accel=LoadAccelerators(theApp.m_hInstance,MAKEINTRESOURCE(IDR_PLACCEL));

	CRect rect1,rect2;

	GetClientRect(&rect1);

	GetDlgItem(IDC_PLAYLIST_AT)->GetWindowRect(&rect2);
	PlAtH=rect1.Height()-rect2.Height();
	PlAtW=rect1.Width()-rect2.Width();
	GetDlgItem(IDC_FILENAME)->GetWindowRect(&rect2);
	FNameH=rect2.Height();
	FNameW=rect1.Width()-rect2.Width();

//	ScreenToClient(&rect2);
//	FNameL=rect2.left;
//	FNameT=rect1.Height()-rect2.top;


	::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	GetWindowRect(&rect2);
	if(pMainFrame->PlaylistW==-1000)
		pMainFrame->PlaylistW=rect2.Width();
	if(pMainFrame->PlaylistH==-1000)
		pMainFrame->PlaylistH=rect2.Height();
	if(pMainFrame->PlaylistX==-1000)
		pMainFrame->PlaylistX=(rect1.right-pMainFrame->PlaylistW)/2;
	if(pMainFrame->PlaylistY==-1000)
		pMainFrame->PlaylistY=(rect1.bottom-pMainFrame->PlaylistH)/2;
	if(pMainFrame->PlaylistX<0)
		pMainFrame->PlaylistX=0;
	if(pMainFrame->PlaylistY<0)
		pMainFrame->PlaylistY=0;
	if(pMainFrame->PlaylistX+pMainFrame->PlaylistW>rect1.right)
		pMainFrame->PlaylistX=rect1.right-pMainFrame->PlaylistW;
	if(pMainFrame->PlaylistY+pMainFrame->PlaylistH>rect1.bottom)
		pMainFrame->PlaylistY=rect1.bottom-pMainFrame->PlaylistH;
	SetWindowPos(NULL,pMainFrame->PlaylistX,pMainFrame->PlaylistY,pMainFrame->PlaylistW,pMainFrame->PlaylistH, SWP_NOZORDER|SWP_NOACTIVATE);

	GetClientRect(&rect1);

	GetDlgItem(IDC_PLAYLIST_AT)->SetWindowPos(NULL,0,0,rect1.Width()-PlAtW,rect1.Height()-PlAtH,SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE);
	GetDlgItem(IDC_FILENAME)->SetWindowPos(NULL,0,0,rect1.Width()-FNameW,FNameH,SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE);
	//	GetDlgItem(IDC_FILENAME)->SetWindowPos(NULL,FNameL,rect1.Height()-FNameT,rect1.Width()-FNameW,FNameH,SWP_NOZORDER|SWP_NOACTIVATE);
	
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, 9999, MyLoadString(IDS_ALWAYSONTOP));
	}
	if(pMainFrame->PlaylistOnTop==1)
	{
		pSysMenu->CheckMenuItem(9999,MF_BYCOMMAND | MF_CHECKED);
		SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
	} else
	{
		ModifyStyleEx(0,WS_EX_APPWINDOW);
	}
	
	FillPlaylist();
	if(pMainFrame->PlayListLength>0)
	{
		m_playlistat.SetSel(pMainFrame->Current,TRUE);
		m_playlistat.SetCaretIndex(pMainFrame->Current,TRUE);
		m_playlistat.SetTopIndex(pMainFrame->Current-2);

	}
	ShowFileName();

//	GetMenu()->CheckMenuItem(ID_FILE_SAVEINEXTENDEDFORMAT,MF_BYCOMMAND | (pMainFrame->ExtPlaylistFormat?MF_CHECKED:MF_UNCHECKED));

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPlaylistDlg::PlayTheFile(int fnum)
{
	pMainFrame->Current=fnum;
	pMainFrame->m_Player.Close();

	bool first=true;
	int q=0;
	do
	{
		if(!first)
		{
			if(pMainFrame->Current<pMainFrame->PlayListLength-1)
			{
				pMainFrame->Current++;
			}
			else
			{
				pMainFrame->Current=0;
				q++;
				if(pMainFrame->m_Repeat!=1)
					break;
			}
		} else first=false;
		pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
		if(!pMainFrame->m_Player.InitStream()) continue;
		pMainFrame->SetOut();
		pMainFrame->m_Player.Play();
		break;
	}
	while(q<2);
	pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
	pMainFrame->UpdMBTR();
}

void CPlaylistDlg::FillPlaylist()
{
	m_playlistat.SetRedraw(FALSE);
	m_playlistat.ResetContent();
	for(unsigned int i=0;i<pMainFrame->PlayListLength;i++)
	{
		m_playlistat.SetItemHeight( i, 11 );
		m_playlistat.AddString("");
	}
	ShowFileName();
	m_playlistat.SetRedraw(TRUE);
	m_playlistat.Invalidate();
}

void CPlaylistDlg::OnClose() 
{
	SaveWindowPosAndDestroy();
}

void CPlaylistDlg::OnCancel() 
{
	SaveWindowPosAndDestroy();
}

void CPlaylistDlg::FindMP3Files(CString path)
{
	CFileFind finder;
	CString fp,fext;
	BOOL bWorking = finder.FindFile(path+"*.*");
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		fp=finder.GetFilePath();
		fext=fp.Mid(fp.ReverseFind('.')+1,3);fext.MakeUpper();
		if(fext=="MP3"||fext=="WAV"&&pMainFrame->IncludeWAVs==1)
			if(finder.GetLength()>0)
			{
				CString buf;
				pMainFrame->PlayList.Add(fp);
				m_playlistat.AddString("");
				pMainFrame->PlayListAT.Add("");
				continue;
			}
		if(finder.IsDirectory()&&!finder.IsDots())
			FindMP3Files(fp+"\\");
	}
}

void CPlaylistDlg::OnDropFiles(HDROP hDropInfo)
{
	m_playlistat.SetRedraw(FALSE);

	int PLLPrev=pMainFrame->PlayListLength;

	TCHAR szFileName[_MAX_PATH];
	CString buf;
	UINT nFileCount = ::DragQueryFile(hDropInfo, 0xFFFFFFFF, NULL, 0);
	for (UINT i=0;i<nFileCount;i++)
	{
		::DragQueryFile(hDropInfo, i, szFileName, _MAX_PATH);
		buf=szFileName;
		if(::GetFileAttributes(szFileName)&FILE_ATTRIBUTE_DIRECTORY)
		{
			if(buf[buf.GetLength()-1]!='\\')
				buf+="\\";
			FindMP3Files(buf);
		}
		else
		{
			if((buf.Right(4)).CompareNoCase(".M3U")==0||(buf.Right(4)).CompareNoCase(".PLS")==0)
			{
				pMainFrame->OpenPlaylist(buf,false,false);
			}
			else
			{
				pMainFrame->PlayList.Add(buf);
				m_playlistat.AddString("");
				pMainFrame->PlayListAT.Add("");
			}
		}
	}
	pMainFrame->PlayListLength=pMainFrame->PlayList.GetSize();
	SortRec(true,PLLPrev,pMainFrame->PlayListLength-1);
	if(pMainFrame->PlayListLength>0)
	{
		if(PLLPrev==0)
		{
			pMainFrame->m_Player.Close();
			if(pMainFrame->ShuffleMode)
				pMainFrame->FirstInMyRandom=pMainFrame->Current=pMainFrame->MyRandom(true, true);
			else
			{
				pMainFrame->Current=0;pMainFrame->FirstInMyRandom=-1;
			}
			bool first=true;
			int q=0;
			do
			{
				if(!first)
				{
					if(pMainFrame->Current<pMainFrame->PlayListLength-1)
					{
						pMainFrame->Current++;
					}
					else
					{
						pMainFrame->Current=0;
						q++;
						if(pMainFrame->m_Repeat!=1)
							break;
					}
				} else first=false;
				pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
				if(!pMainFrame->m_Player.InitStream()) continue;
				if(pMainFrame->AutoPlay)
				{
					pMainFrame->SetOut();
					pMainFrame->m_Player.Play();
				} else pMainFrame->m_Player.Close();
				break;
			}
			while(q<2);
			pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
		}
		pMainFrame->UpdMBTR();

	}
	ShowFileName();
	m_playlistat.SetRedraw(TRUE);
	m_playlistat.Invalidate();

	::DragFinish(hDropInfo);
}

CPLLB::CPLLB():
	CListBox()
{
	MemDCCreated=false;
	ShiftDown=false;
	CtrlDown=false;
	prev=-1;
}

void CPLLB::DrawItem(LPDRAWITEMSTRUCT lpDIS) 
{
	if ((int)lpDIS->itemID < 0)
		return; 

	CDC* pDC = CDC::FromHandle(lpDIS->hDC);

	COLORREF crText;
	CString sText;

	if(lpDIS->itemAction & (ODA_SELECT | ODA_DRAWENTIRE))
		if (lpDIS->itemState & ODS_SELECTED)
		{   //   
			CBrush brush(RGB(40,70,200)); 
			pDC->FillRect(&lpDIS->rcItem, &brush);
		}
		else
		{   //  
			CBrush brush(RGB(0,0,0));
			pDC->FillRect(&lpDIS->rcItem, &brush);
		}	 	



	int nBkMode = pDC->SetBkMode(TRANSPARENT);

	if (lpDIS->itemState & ODS_SELECTED)
		crText = pDC->SetTextColor(RGB(0,200,0));//  
	else if (lpDIS->itemState & ODS_DISABLED)
		crText = pDC->SetTextColor(::GetSysColor(COLOR_GRAYTEXT)); //  ( )
	else    //  
		crText = pDC->SetTextColor(lpDIS->itemID==pMainFrame->Current?RGB(255,255,90): RGB(0,255,230)); //  


	bool atflag;
	if(atflag=(sText==""))
		sText=pMainFrame->ReadTagMin(pMainFrame->PlayList[lpDIS->itemID]);
	// pMainFrame->PlayListAT[lpDIS->itemID]=sText=ReadTagAT(pMainFrame->PlayList[lpDIS->itemID]);
	CRect rect;
	UINT nFormat;

//   
	CString temp;
	temp.Format("%d",lpDIS->itemID+1);

	int digits,q=pMainFrame->PlayListLength,chw=LOWORD(GetDialogBaseUnits());
	
	for(digits=1;digits<4;digits++)
		if((q=(int)(q/10))==0)break;

	rect = lpDIS->rcItem;
	rect.right=rect.left+digits*chw;

	nFormat = DT_LEFT | DT_SINGLELINE | DT_VCENTER;

	pDC->DrawText(temp, -1, &rect, nFormat | DT_NOPREFIX);


	rect = lpDIS->rcItem;
	rect.left=rect.left+28;
	rect.right=rect.right;

	nFormat = DT_LEFT | DT_SINGLELINE | DT_VCENTER;
//   

//  
	pDC->DrawText(sText.Left(sText.GetLength()-4), -1, &rect, nFormat | DT_NOPREFIX);

	pDC->SetTextColor(crText); 
	pDC->SetBkMode(nBkMode);
}


void CPLLB::MeasureItem(LPMEASUREITEMSTRUCT lpMIS)
{
   // Get current font metrics
   TEXTMETRIC metrics;
   HDC dc = ::GetDC( PlaylistDlg->m_hWnd );
   GetTextMetrics( dc, &metrics );
   ::ReleaseDC( m_hWnd, dc );
   
   // Set the height
   lpMIS->itemHeight = metrics.tmHeight + metrics.tmExternalLeading;
}



void CPlaylistDlg::OnOK()
{
		if(m_playlistat.GetFirstSelected()!=-1)
		{
			PlayTheFile(m_playlistat.GetFirstSelected());
			m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
		}
}

void CPLLB::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(nFlags&MK_LBUTTON)
	{
		//if(hTagsThread!=NULL)
		//	::SuspendThread(hTagsThread);
//		bool b=StopReadAll();
		CString buf;
		BOOL q;
		CPoint point2;
		CRect rect;
		GetClientRect(&rect);
		int nTargetIndex=ItemFromPoint(point,q);
		for(;;)
		{
			if(!q)
			{
				if(posfrom>=0&&nTargetIndex>=0)
				{
					if(point.y-rect.top>0&&point.y-rect.top<10&&nTargetIndex>0) nTargetIndex--;
					if(rect.bottom-point.y>0&&rect.bottom-point.y<10&&nTargetIndex<GetCount()-1) nTargetIndex++;
					SetRedraw(FALSE);
					if(posfrom>nTargetIndex)
					{
						//for(int j=0;j<posfrom-nTargetIndex;j++)
						int offset=posfrom-nTargetIndex;
						if(!GetSel(0))
						{
							for(int i=1;i<GetCount();i++)
							{
								if(GetSel(i))
								{
									offset=(i-offset<0?i:offset);
									buf=pMainFrame->PlayList[i];
									pMainFrame->PlayList.RemoveAt(i);
									pMainFrame->PlayList.InsertAt(i-offset,buf);
									buf=pMainFrame->PlayListAT[i];
									pMainFrame->PlayListAT.RemoveAt(i);
									pMainFrame->PlayListAT.InsertAt(i-offset,buf);
									SetSel(i,FALSE);
									SetSel(i-offset,TRUE);

									if(pMainFrame->Current==i) pMainFrame->Current=(i-offset);
										else if(pMainFrame->Current<i&&pMainFrame->Current>=(i-offset)) pMainFrame->Current++;
								}
							}
						}
					}
					if(posfrom<nTargetIndex)
					{
						//for(int j=0;j<nTargetIndex-posfrom;j++)
						int offset=nTargetIndex-posfrom;
						if(!GetSel(GetCount()-1))
						{
							for(int i=GetCount()-2;i>=0;i--)
							{
								if(GetSel(i))
								{
									offset=(i+offset<GetCount()?offset:GetCount()-1-i);
									buf=pMainFrame->PlayList[i];
									pMainFrame->PlayList.RemoveAt(i);
									pMainFrame->PlayList.InsertAt(i+offset,buf);
									buf=pMainFrame->PlayListAT[i];
									pMainFrame->PlayListAT.RemoveAt(i);
									pMainFrame->PlayListAT.InsertAt(i+offset,buf);
									SetSel(i,FALSE);
									SetSel(i+offset,TRUE);
									
									if(pMainFrame->Current==i) pMainFrame->Current=(i+offset);
										else if(pMainFrame->Current>i&&pMainFrame->Current<=(i+offset)) pMainFrame->Current--;
								}
							}		
						}
					}
				SetRedraw(TRUE);
				Invalidate();
				posfrom=nTargetIndex;
				}
			}
			::GetCursorPos(&point2);
			ScreenToClient(&point2);
			nTargetIndex=ItemFromPoint(point,q);
			if(point2.y-rect.top>0&&point2.y-rect.top<3||
			   rect.bottom-point2.y>0&&rect.bottom-point2.y<3)
			   RedrawWindow();
			else break;
		} 
///		if(b) ReadAllTags();
	}
	CListBox::OnMouseMove(nFlags, point);

}

void CPLLB::OnLButtonDown(UINT nFlags, CPoint point) 
{


	
	BOOL qqq;
	int item;
	item=ItemFromPoint(point,qqq);
	CString buf;
	if(!qqq)
	{	
		PlaylistDlg->SetWindowText("item");
//		PlaylistDlg->PlayTheFile();
	}


	CListBox::OnLButtonDblClk(nFlags, point);  //       
	
	BOOL q;
	posfrom=ItemFromPoint(point,q);
	if(q) posfrom=-1;
	if(!(nFlags&MK_CONTROL)&&!(nFlags&MK_SHIFT))
		SetSel(-1,FALSE);
	int last=GetCaretIndex();
	if(nFlags&MK_SHIFT)
	{
		if(last!=posfrom)
		{
			SetSel(-1,FALSE);
			if(posfrom<last)
				SelItemRange(TRUE,posfrom,last);
			else
				SelItemRange(TRUE,last,posfrom);
		}
	} 
	else
	if(nFlags&MK_CONTROL)
	{
		SetCaretIndex(posfrom);
		SetSel(posfrom,!GetSel(posfrom));
	}
	else
	if(posfrom>-1)
	{
		SetCaretIndex(posfrom);
		SetSel(posfrom,TRUE);
	}
	PlaylistDlg->ShowFileName();



}

void CPLLB::OnRButtonDown(UINT nFlags, CPoint point) 
{
	BOOL q;
	posfrom=ItemFromPoint(point,q);
	if(q) posfrom=-1;
	if(!(nFlags&MK_CONTROL)&&!(nFlags&MK_SHIFT))
		SetSel(-1,FALSE);
	int last=GetCaretIndex();
	if(nFlags&MK_SHIFT)
	{
		if(last!=posfrom)
		{
			SetSel(-1,FALSE);
			if(posfrom<last)
				SelItemRange(TRUE,posfrom,last);
			else
				SelItemRange(TRUE,last,posfrom);
		}
	} 
	else
		if(posfrom>-1)
		{
			SetFocus();
			SetCaretIndex(posfrom);
			SetSel(posfrom,TRUE);
		}

	PlaylistDlg->ShowFileName();
}

void CPLLB::OnLButtonDblClk(UINT nFlags, CPoint point) 
{


	BOOL q;
	int item;
	item=ItemFromPoint(point,q);
	if(!q)
	{
		PlaylistDlg->PlayTheFile(item);
		RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
	}
	CListBox::OnLButtonDblClk(nFlags, point);

}

void CPLLB::OnKeyUp( UINT nChar, UINT nRepCnt, UINT nFlags )
{
	if(nChar==VK_SHIFT)
	{
		ShiftDown=false;
		prev=-1;
	}
	if(nChar==VK_CONTROL)
		CtrlDown=false;
	//CListBox::OnKeyUp(nChar,nRepCnt,nFlags);
}

void CPLLB::OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags )
{
	switch(nChar)
	{
	case VK_UP:
	case VK_DOWN:
	case VK_PRIOR:
	case VK_NEXT:
	case VK_HOME:
	case VK_END:
			{
				CListBox::OnKeyDown(nChar,nRepCnt,nFlags);
				if(ShiftDown)
				{
					int now=GetCaretIndex();
					if(prev==-1) prev=now;
					if(prev<now)
					{
						SetSel(-1,FALSE);
						SelItemRange(TRUE,prev,now);
					}
					else
					{
						SetSel(-1,FALSE);
						SelItemRange(TRUE,now,prev);
					}
				}
				else
				{
					SetSel(-1,FALSE);
					SetSel(GetCaretIndex(),TRUE);
				}
				PlaylistDlg->ShowFileName();
				break;
			}
	case VK_ADD:
			SetCaretIndex(0);
			SetSel(-1,TRUE);
			PlaylistDlg->ShowFileName();
			break;
	case VK_MULTIPLY:
		{
			SetRedraw(FALSE);
			int e=GetTopIndex();
			int w=GetCaretIndex();
			int q=GetCount();
			for(int i=0;i<q;i++)
				SetSel(i,!GetSel(i));
			PlaylistDlg->ShowFileName();
			SetCaretIndex(w);
			SetTopIndex(e-2);
			SetRedraw(TRUE);
			Invalidate();
			break;
		}
	case VK_DELETE:
		PlaylistDlg->Remove();
		break;
	case VK_SHIFT:
			prev=GetCaretIndex();
			ShiftDown=true;
			break;
	case VK_CONTROL:
			CtrlDown=true;
			break;
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case '0':
//		PlaylistDlg->GetDlgItem(IDC_SEARCH)->SetFocus();
//		PlaylistDlg->GetDlgItem(IDC_SEARCH)->PostMessage(WM_KEYDOWN,nChar,nRepCnt+0x10000*nFlags);
		return;
		break;
	}
	SetFocus();
//	CListBox::OnKeyDown(nChar,nRepCnt,nFlags);
}

BOOL CPLLB::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CPLLB::OnPaint() 
{
	CPaintDC dc(this);
	
	if(!MemDCCreated)
	{
		
		memDC.CreateCompatibleDC(&dc);
		CRect rect;
		GetClientRect(&rect);
		memBitmap.CreateCompatibleBitmap(&dc, width=rect.Width(), height=rect.Height());
		memDC.SelectObject(&memBitmap);
		MemDCCreated=true;
	}

	memDC.FillSolidRect(0,0,width,height, RGB(0,0,0)); //  

	DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);

	dc.BitBlt(0, 0, width, height, &memDC, 0, 0, SRCCOPY);
}

int CPLLB::GetFirstSelected(int from)
{
	int q=GetCount(),i;
	for(i=from;i<q;i++)
		if(GetSel(i)>0)	return i;
	return -1;
}

void CPlaylistDlg::ShowFileName()
{

	
	int i;
	if((i=m_playlistat.GetFirstSelected())>-1)
	{
		m_filename.SetWindowText(pMainFrame->PlayList[i]);
		m_filename.SetSel(pMainFrame->PlayList[i].GetLength());
	}
	else
	{
		m_filename.SetWindowText("");
	}
	GetMenu()->EnableMenuItem(ID_PLAYLIST_SAVE,pMainFrame->PlayListLength==0?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_FILE_REMOVE,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_TRACKS_REMOVEALL,pMainFrame->PlayListLength<1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_FILE_EDITTAG,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_TRACKS_SELECTION_CREATENEWPLAYLIST,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_TRACKS_SELECTION_ADDTOEXISTENTPLAYLIST,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_ARRANGE_SORT,pMainFrame->PlayListLength==0?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_ARRANGE_SORTBYFILENAME,pMainFrame->PlayListLength==0?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_ARRANGE_SHUFFLE,pMainFrame->PlayListLength==0?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_TRACKS_RENAMEFILES,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_TRACKS_FILEMANAGEMENT_DELETE,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_TRACKS_FILEMANAGEMENT_COPYTO,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
	GetMenu()->EnableMenuItem(ID_TRACKS_FILEMANAGEMENT_MOVETO,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
}

void CPlaylistDlg::OnFileAddfile() 
{
	int PLLPrev=pMainFrame->PlayListLength;
	// open a file
	CFileDialog dialog(TRUE, 
						"mp3",
						"",
						OFN_ALLOWMULTISELECT |
						OFN_FILEMUSTEXIST    | 
						OFN_HIDEREADONLY,
						MyLoadString(IDS_OPENFILE),
						this);

	char buffer[_MAX_PATH*500+1];
	buffer[0]='\0';
	dialog.m_ofn.lpstrFile=buffer;
	dialog.m_ofn.nMaxFile=_MAX_PATH*500;
	dialog.m_ofn.lpstrInitialDir=LPCTSTR(pMainFrame->InitDir);
	int ret;
	ret = dialog.DoModal();
	if (ret == IDOK) {
        // a file was selected
		POSITION p=dialog.GetStartPosition();
		CString buf;
		while(p!=NULL)
		{
			CString buf2;
			pMainFrame->PlayList.Add(buf=dialog.GetNextPathName(p));
			m_playlistat.AddString("");
			pMainFrame->PlayListAT.Add("");
			pMainFrame->InitDir=buf.Left(buf.ReverseFind('\\')+1);
		}
		pMainFrame->PlayListLength=pMainFrame->PlayList.GetSize();
		if(PLLPrev==0)
		{
			pMainFrame->m_Player.Close();
			if(pMainFrame->ShuffleMode)
				pMainFrame->FirstInMyRandom=pMainFrame->Current=pMainFrame->MyRandom(true, true);
			else
			{
				pMainFrame->Current=0;pMainFrame->FirstInMyRandom=-1;
			}
			bool first=true;
			int q=0;
			do
			{
				if(!first)
				{
					if(pMainFrame->Current<pMainFrame->PlayListLength-1)
					{
						pMainFrame->Current++;
					}
					else
					{
						pMainFrame->Current=0;
						q++;
						if(pMainFrame->m_Repeat!=1)
							break;
					}
				} else first=false;
				pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
				if(!pMainFrame->m_Player.InitStream()) continue;
				if(pMainFrame->AutoPlay)
				{
					pMainFrame->SetOut();
					pMainFrame->m_Player.Play();
				} else pMainFrame->m_Player.Close();
				break;
			}
			while(q<2);
			pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
		}
		pMainFrame->UpdMBTR();
		ShowFileName();
	}
	m_playlistat.SetFocus();
}

void CPlaylistDlg::OnFileAddfolder() 
{
	int PLLPrev=pMainFrame->PlayListLength;

	LPMALLOC pMalloc;
	if (SHGetMalloc (&pMalloc)!= NOERROR)
		return;

	BROWSEINFO bi;
	char buf[MAX_PATH];

	CString title;
	title=MyLoadString(IDS_OPENFOLDER);

	bi.hwndOwner=m_hWnd;
	bi.pszDisplayName=buf;
	bi.pidlRoot=NULL;
	bi.lpszTitle=LPCTSTR(title);
	bi.ulFlags=BIF_RETURNONLYFSDIRS;
	bi.lpfn=BrowseCallbackProc;

	LPITEMIDLIST pidl;
	if((pidl=SHBrowseForFolder(&bi))==NULL)
	{
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	if(SHGetPathFromIDList(pidl,buf)==false)
	{	
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	pMalloc->Free(pidl);
	pMalloc->Release();

	m_playlistat.SetRedraw(FALSE);

	CString theDir=buf;
	if(theDir[theDir.GetLength()-1]!='\\')
		theDir+="\\";

	FindMP3Files(theDir);
	pMainFrame->InitDir=theDir;
	pMainFrame->PlayListLength=pMainFrame->PlayList.GetSize();
	SortRec(true,PLLPrev,pMainFrame->PlayListLength-1);
	if(pMainFrame->PlayListLength>0)
	{
		if(PLLPrev==0)
		{
			//pMainFrame->m_Player.Close();
			if(pMainFrame->ShuffleMode)
				pMainFrame->FirstInMyRandom=pMainFrame->Current=pMainFrame->MyRandom(true, true);
			else
			{
				pMainFrame->Current=0;pMainFrame->FirstInMyRandom=-1;
			}
			bool first=true;
			int q=0;
			do
			{
				if(!first)
				{
					if(pMainFrame->Current<pMainFrame->PlayListLength-1)
					{
						pMainFrame->Current++;
					}
					else
					{
						pMainFrame->Current=0;
						q++;
						if(pMainFrame->m_Repeat!=1)
							break;
					}
				} else first=false;
				pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
				if(!pMainFrame->m_Player.InitStream()) continue;
				if(pMainFrame->AutoPlay)
				{
					pMainFrame->SetOut();
					pMainFrame->m_Player.Play();
				} else pMainFrame->m_Player.Close();
				break;
			}
			while(q<2);
			pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
		}
		pMainFrame->UpdMBTR();

		ShowFileName();
	}
	ShowFileName();
	m_playlistat.SetRedraw(TRUE);
	m_playlistat.Invalidate();
}

void CPlaylistDlg::OnFileEdittag() 
{
	int i=-1;
	CString buf;
	CTagEditor TagEditor(IDD_TAGEDITR,this);
	while((i=m_playlistat.GetFirstSelected(i+1))>-1)
	{
		if(!FileExists(pMainFrame->PlayList[i])) continue;
		buf=pMainFrame->PlayList[i];
		TagEditor.m_filename=buf;
		//TagEditor.ReadTag();
		if(TagEditor.DoModal()==IDOK)
		{
			pMainFrame->PlayListAT[i]=ReadTagAT(TagEditor.m_filename);
			m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
			if(i==pMainFrame->Current)
			{
				pMainFrame->ReadTag(TagEditor.m_filename);
				if(MP3InfoDlg!=NULL)
				{
					MP3InfoDlg->PrevFile="*";
					MP3InfoDlg->ReadInfo();
				}
			}
		} else break;
		//m_playlistat.SetCaretIndex(i,TRUE);
		//m_playlistat.SetSel(i,TRUE);
	}
	SetFocus();
}

void CPlaylistDlg::OnFileRemove() 
{
	Remove();
}

void CPlaylistDlg::OnPlaylistOpen() 
{
	// open a file
	CFileDialog dialog(TRUE, 
						"m3u",
						"",
						OFN_FILEMUSTEXIST    | 
						OFN_HIDEREADONLY,
						MyLoadString(IDS_OPENPLAYLIST),
						this);
	dialog.m_ofn.lpstrInitialDir=LPCTSTR(pMainFrame->InitDir);
	int ret;
	ret = dialog.DoModal();
	if (ret == IDOK) {
		pMainFrame->OpenPlaylist(dialog.GetPathName());
		pMainFrame->InitDir=dialog.GetPathName().Left(dialog.GetPathName().ReverseFind('\\')+1);
	}
	m_playlistat.SetFocus();
}

void CPlaylistDlg::PlaylistSave(bool saveall) 
{
	if(pMainFrame->PlayListLength==0) return;
	if(!saveall&&m_playlistat.GetFirstSelected()==-1) return;
	CFileDialog dialog(FALSE, 
						"m3u",
						"",
						OFN_HIDEREADONLY |
						OFN_OVERWRITEPROMPT,
						MyLoadString(IDS_OPENPLAYLIST),
						this);
	dialog.m_ofn.lpstrInitialDir=LPCTSTR(pMainFrame->InitDir);
	int ret;
	ret = dialog.DoModal();
	if (ret == IDOK) {
        // a file was selected
		pMainFrame->InitDir=dialog.GetPathName().Left(dialog.GetPathName().ReverseFind('\\')+1);
		CStdioFile plfile;
		if(plfile.Open(dialog.GetPathName(),CFile::modeCreate | CFile::modeWrite))
		{

			CString PLPath;
			PLPath=dialog.GetPathName().Left(dialog.GetPathName().ReverseFind('\\'));
			UINT i;
			CString buf;
			for(i=0;i<pMainFrame->PlayListLength;i++)
			{
				if(m_playlistat.GetSel(i)||saveall)
				{
					buf=pMainFrame->PlayList[i];
					if(PLPath.CompareNoCase(buf.Left(PLPath.GetLength()))==0)
						buf=buf.Mid(PLPath.GetLength()+1);
					if(PLPath.Left(2).CompareNoCase(buf.Left(2))==0)
						buf=buf.Mid(2);
					plfile.WriteString(buf+"\n");
/*					if(pMainFrame->ExtPlaylistFormat==1)
					{
						if(pMainFrame->PlayListAT[i]=="")
							pMainFrame->PlayListAT[i]=ReadTagAT(pMainFrame->PlayList[i]);
						plfile.WriteString("#TAG="+pMainFrame->PlayListAT[i]+"\n");
					}*/
				}
			}
			plfile.Close();
			pMainFrame->AddRecent(dialog.GetPathName());

		} else
		{
			MessageBox(MyLoadString(IDS_CANTOPEN),"STP",MB_ICONERROR);
		}

	}	
	m_playlistat.SetFocus();
}

void CPlaylistDlg::OnPlaylistSave() 
{
	PlaylistSave();
}


void CPlaylistDlg::OnSearcherCall() ////rerere
{


		CSearcherDlg SercherDlg(IDD_SEARCHER);
		SercherDlg.DoModal();

//	CDialog SercherDlg(IDD_SEARCHER);
 //   SercherDlg.DoModal();

//	if(SearcherDlg==NULL)
//	{
//		SearcherDlg=new CSearcherDlg(IDD_SEARCHER);
//		SearcherDlg->Create(IDD_SEARCHER,pMainFrame);
//	} 

}

void CPlaylistDlg::OnArrangeShuffle() 
{
	if(m_playlistat.GetCount()<2) return;

	m_playlistat.SetRedraw(FALSE);
	
	int i,j,k,sl;
	CString buf;
	for(i=0;i<pMainFrame->PlayListLength*1.5+1;i++)
	{
		j=pMainFrame->PlayListLength*frand();
		k=pMainFrame->PlayListLength*frand();
		buf=pMainFrame->PlayList[j]; pMainFrame->PlayList[j]=pMainFrame->PlayList[k]; pMainFrame->PlayList[k]=buf;
		buf=pMainFrame->PlayListAT[j]; pMainFrame->PlayListAT[j]=pMainFrame->PlayListAT[k]; pMainFrame->PlayListAT[k]=buf;
		sl=m_playlistat.GetSel(j); m_playlistat.SetSel(j,m_playlistat.GetSel(k)); m_playlistat.SetSel(k,sl);
		if(m_playlistat.GetCaretIndex()==j)
			m_playlistat.SetCaretIndex(k,TRUE);
		else
		if(m_playlistat.GetCaretIndex()==k)
			m_playlistat.SetCaretIndex(j,TRUE);
		if(pMainFrame->Current==j)
			pMainFrame->Current=k;
		else
		if(pMainFrame->Current==k)
			pMainFrame->Current=j;
	}

	ShowFileName();
	m_playlistat.SetTopIndex(m_playlistat.GetFirstSelected()!=-1?m_playlistat.GetFirstSelected():pMainFrame->Current);
	m_playlistat.SetRedraw(TRUE);
	m_playlistat.Invalidate();
}

void CPlaylistDlg::OnArrangeSort() 
{
	if(m_playlistat.GetCount()==0) return;
	
//	bool b=StopReadAll();

	m_playlistat.SetRedraw(FALSE);

	SortRec(false,0,m_playlistat.GetCount()-1);

//	if(b) ReadAllTags();
	ShowFileName();
	m_playlistat.SetTopIndex(m_playlistat.GetFirstSelected()!=-1?m_playlistat.GetFirstSelected():pMainFrame->Current);
	m_playlistat.SetRedraw(TRUE);
	m_playlistat.Invalidate();
}

void CPlaylistDlg::OnArrangeSortbyfilename() 
{
	if(m_playlistat.GetCount()==0) return;
	

	m_playlistat.SetRedraw(FALSE);

	SortRec(true,0,m_playlistat.GetCount()-1);

	ShowFileName();
	m_playlistat.SetTopIndex(m_playlistat.GetFirstSelected()!=-1?m_playlistat.GetFirstSelected():pMainFrame->Current);
	m_playlistat.SetRedraw(TRUE);
	m_playlistat.Invalidate();
}

void CPlaylistDlg::OnTracksSelectionAddtoexistentplaylist() 
{
	CFileDialog dialog(TRUE, 
						"m3u",
						"",
						OFN_FILEMUSTEXIST    | 
						OFN_HIDEREADONLY,
						MyLoadString(IDS_OPENPLAYLIST),
						this);
	dialog.m_ofn.lpstrInitialDir=LPCTSTR(pMainFrame->InitDir);
	int ret;
	ret = dialog.DoModal();
	if (ret == IDOK) {
		pMainFrame->InitDir=dialog.GetPathName().Left(dialog.GetPathName().ReverseFind('\\')+1);
		
		CStringArray CurPL;
		CString fname=dialog.GetPathName();
		CStdioFile plfile;

		if(!plfile.Open(fname,CFile::modeRead | CFile::shareDenyNone))
		{
			MessageBox(MyLoadString(IDS_CANTOPEN),"STP",MB_ICONERROR);
			return;
		}

		CString buf;
		CString CurPath=fname.Left(fname.ReverseFind('\\')+1);
		CString CurDisk=fname.Left(fname.Find(':')+1);
		while(plfile.ReadString(buf))
		{
			buf.TrimLeft();buf.TrimRight();
			if(buf.Left(4)=="#EXT"||buf==""||buf.Left(5)=="#TAG=") continue;
			if(buf[1]==':'||buf.Left(7).CompareNoCase("http://")==0||buf.Left(6).CompareNoCase("ftp://")==0)
			{
				CurPL.Add(buf);
			}
			else
				if(buf[0]=='\\')
				{
					CurPL.Add(CurDisk+buf);
				}
				else
				{
					CurPL.Add(CurPath+buf);
				}
		}
		plfile.Close();
		if(!plfile.Open(dialog.GetPathName(),CFile::modeCreate | CFile::modeWrite))
		{
			MessageBox(MyLoadString(IDS_CANTOPEN),"STP",MB_ICONERROR);
			return;
		}

		UINT i;
		for(i=0;i<pMainFrame->PlayListLength;i++)
		{
			if(m_playlistat.GetSel(i))
			{
				CurPL.Add(pMainFrame->PlayList[i]);
			}
		}

		CurPath=CurPath.Left(CurPath.GetLength()-1);
		UINT ln=CurPL.GetUpperBound()+1;
		for(i=0;i<ln;i++)
		{
			buf=CurPL[i];
			if(CurPath.CompareNoCase(buf.Left(CurPath.GetLength()))==0)
				buf=buf.Mid(CurPath.GetLength()+1);
			if(CurPath.Left(2).CompareNoCase(buf.Left(2))==0)
				buf=buf.Mid(2);
			plfile.WriteString(buf+"\n");
/*			if(pMainFrame->ExtPlaylistFormat==1)
			{
				plfile.WriteString("#TAG="+ReadTagAT(CurPL[i])+"\n");
			}*/
		}

		plfile.Close();
	}
}

void CPlaylistDlg::OnTracksSelectionCreatenewplaylist() 
{
	PlaylistSave(false);	
}


void CPlaylistDlg::OnTracksAddplaylist() 
{
	// open a file
	CFileDialog dialog(TRUE, 
						"m3u",
						"",
						OFN_FILEMUSTEXIST    | 
						OFN_HIDEREADONLY,
						MyLoadString(IDS_OPENPLAYLIST),
						this);
	dialog.m_ofn.lpstrInitialDir=LPCTSTR(pMainFrame->InitDir);
	int ret;
	ret = dialog.DoModal();
	if (ret == IDOK) {
		pMainFrame->OpenPlaylist(dialog.GetPathName(),false,true);
		pMainFrame->InitDir=dialog.GetPathName().Left(dialog.GetPathName().ReverseFind('\\')+1);
		ShowFileName();
	}
	m_playlistat.SetFocus();
}

void CPlaylistDlg::OnKillfocusPlaylistAt() 
{
m_playlistat.CtrlDown=m_playlistat.ShiftDown=false;
m_playlistat.prev=-1;
}

void CPLLB::OnRButtonUp(UINT nFlags, CPoint point) 
{
		CMenu menu;
		CMenu* pPopup;
		menu.LoadMenu(IDR_PLPOPUPR);
		pPopup = menu.GetSubMenu(0);
		int i=PlaylistDlg->m_playlistat.GetFirstSelected();
		pPopup->EnableMenuItem(ID_FILE_REMOVE,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
		pPopup->EnableMenuItem(ID_FILE_EDITTAG,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
		pPopup->EnableMenuItem(ID_TRACKS_SELECTION_CREATENEWPLAYLIST,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);
		pPopup->EnableMenuItem(ID_TRACKS_SELECTION_ADDTOEXISTENTPLAYLIST,i==-1?MF_DISABLED|MF_GRAYED:MF_ENABLED);

/*		if(pMainFrame->PlayListLength>0&&pMainFrame->PlayListLength<5001)
		{
			CMenu *pTempMenu;
			pTempMenu=pPopup->GetSubMenu(11);
			pTempMenu->DeleteMenu(0,MF_BYPOSITION);
			pMainFrame->BuildMenuLevel(pTempMenu->m_hMenu,pMainFrame->GetStartLevel(),0,"");
		} else { pPopup->DeleteMenu(11,MF_BYPOSITION); pPopup->DeleteMenu(12,MF_BYPOSITION);}
*/
		ClientToScreen(&point);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON,
				point.x, point.y,
				PlaylistDlg);
}

void CPlaylistDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == 9999)
	{
		if(pMainFrame->PlaylistOnTop==1)
		{			
			GetSystemMenu(FALSE)->CheckMenuItem(9999,MF_BYCOMMAND | MF_UNCHECKED);
						
			ShowWindow(SW_HIDE);
			ModifyStyleEx(0,WS_EX_APPWINDOW);
			ShowWindow(SW_SHOW);
			
			SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
			
			pMainFrame->PlaylistOnTop=0;
		}
		else
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999,MF_BYCOMMAND | MF_CHECKED);
			
			ShowWindow(SW_HIDE);
			ModifyStyleEx(WS_EX_APPWINDOW,0);
			ShowWindow(SW_SHOW);
			
			SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);

			pMainFrame->PlaylistOnTop=1;
		}
		if(SeekDialog!=NULL) SeekDialog->SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CPlaylistDlg::OnArrangeRemovene() 
{
	m_playlistat.SetRedraw(FALSE);
	int i=0;
	bool CurDeleted=false;
//	bool b=StopReadAll();
	while(i<m_playlistat.GetCount()&&m_playlistat.GetCount()>0)
		if(!FileExists(pMainFrame->PlayList[i]))
		{
			m_playlistat.DeleteString(i);
			pMainFrame->PlayList.RemoveAt(i);
			pMainFrame->PlayListAT.RemoveAt(i);
			if(i<pMainFrame->Current)pMainFrame->Current--;
			else if(i==pMainFrame->Current&&!CurDeleted) CurDeleted=true;
		} else i++;
	pMainFrame->PlayListLength=pMainFrame->PlayList.GetSize();
	if(CurDeleted)
	{
		pMainFrame->Current=0;
		if(pMainFrame->PlayListLength>0)
		{
			pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
			pMainFrame->m_Player.Close();
			pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
		}
		else
		{
			pMainFrame->m_Player.Close();
			CRect rect;
			if(MP3InfoDlg!=NULL)
			{
				MP3InfoDlg->SaveWindowPosAndDestroy();
			}
		}
		pMainFrame->UpdMBTR();
	}
	m_playlistat.SetSel(-1,FALSE);
//	if(b)ReadAllTags();
	ShowFileName();
	m_playlistat.SetRedraw(TRUE);
	m_playlistat.Invalidate();
}

void CPlaylistDlg::OnArrangeRemoveduplicateentries() 
{
	m_playlistat.SetRedraw(FALSE);
	int i=0,j;
	bool CurDeleted=false;
//	bool b=StopReadAll();
	while(i<m_playlistat.GetCount()&&m_playlistat.GetCount()>0)
	{
		j=i+1;
		while(j<m_playlistat.GetCount())
		{
			if(pMainFrame->PlayList[i]==pMainFrame->PlayList[j])
			{
				m_playlistat.DeleteString(j);
				pMainFrame->PlayList.RemoveAt(j);
				pMainFrame->PlayListAT.RemoveAt(j);
				if(j<pMainFrame->Current)pMainFrame->Current--;
				else if(j==pMainFrame->Current) pMainFrame->Current=i;
			} else j++;
		}
		i++;
	}
	pMainFrame->PlayListLength=pMainFrame->PlayList.GetSize();
	m_playlistat.SetSel(-1,FALSE);
//	if(b)ReadAllTags();
	ShowFileName();
	m_playlistat.SetRedraw(TRUE);
	m_playlistat.Invalidate();
}


void CPlaylistDlg::OnWindowRestor() 
{
	SetWindowPos(NULL,GetSystemMetrics(SM_CXSCREEN)-280,27,280,GetSystemMetrics(SM_CYSCREEN)-25,SWP_NOZORDER|SWP_NOACTIVATE);
}


void CPlaylistDlg::OnTracksRemoveall() 
{
	Remove(true);
}


void CPlaylistDlg::OnSize(UINT nType, int cx, int cy) 
{
CDialog::OnSize(nType, cx, cy);




	if(CanResize)
	{	
		m_playlistat.memDC.DeleteDC();
		m_playlistat.memBitmap.DeleteObject();
		m_playlistat.MemDCCreated=false;
			
		CRect rect;
		GetClientRect(&rect);
			
		GetDlgItem(IDC_PLAYLIST_AT)->SetWindowPos(NULL,0,0,rect.Width()-PlAtW,rect.Height()-PlAtH,SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE);
	GetDlgItem(IDC_FILENAME)->SetWindowPos(NULL,0,0,rect.Width()-FNameW,FNameH,SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE);
//		GetDlgItem(IDC_FILENAME)->SetWindowPos(NULL,FNameL,rect.Height()-FNameT,rect.Width()-FNameW,FNameH,SWP_NOZORDER|SWP_NOACTIVATE);
		m_playlistat.SetRedraw(TRUE);
		m_playlistat.Invalidate();
	}
}

void CPlaylistDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	CanResize=bShow?true:false;
}

void CPlaylistDlg::OnPopupSelectall() 
{
	m_playlistat.SetCaretIndex(0);
	m_playlistat.SetSel(-1,TRUE);
	ShowFileName();
}

void CSrchEdit::OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags )
{
	switch(nChar)
	{
	case VK_UP:
	case VK_DOWN:
	case VK_PRIOR:
	case VK_NEXT:
	case VK_HOME:
	case VK_END:
		PlaylistDlg->GetDlgItem(IDC_PLAYLIST_AT)->SetFocus();
		PlaylistDlg->GetDlgItem(IDC_PLAYLIST_AT)->PostMessage(WM_KEYDOWN,nChar,nRepCnt+0x10000*nFlags);
		return;
		break;
	}
	CEdit::OnKeyDown(nChar,nRepCnt,nFlags);
}

void CPlaylistDlg::OnTrackMenu(UINT nID) 
{
	m_playlistat.SetSel(-1,FALSE);
	m_playlistat.SetSel(nID-IDM_TRACKS,TRUE);
	m_playlistat.SetCaretIndex(nID-IDM_TRACKS,TRUE);
	m_playlistat.SetTopIndex(nID-IDM_TRACKS-2);
	ShowFileName();

	PlaylistDlg->PlayTheFile(nID-IDM_TRACKS);
//	RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
//	CListBox::OnLButtonDblClk(nFlags, point);
}

void CPlaylistDlg::OnEnterMenuLoop( BOOL bIsTrackPopupMenu )
{
	if(!bIsTrackPopupMenu)
	{
		CMenu *pPopup;
		pPopup=GetMenu()->GetSubMenu(3);
		while(pPopup->DeleteMenu(0,MF_BYPOSITION));
		if(pMainFrame->PlayListLength>0&&pMainFrame->PlayListLength<10001)
		{
			pMainFrame->BuildMenu(pPopup->m_hMenu);
		}
	}
	CDialog::OnEnterMenuLoop(bIsTrackPopupMenu);
}

void CPlaylistDlg::SaveWindowPosAndDestroy()
{
	DestroyAcceleratorTable(accel);

	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->PlaylistX=rect.left;
	pMainFrame->PlaylistY=rect.top;
	pMainFrame->PlaylistW=rect.Width();
	pMainFrame->PlaylistH=rect.Height();

	DestroyWindow();
	PlaylistDlg=NULL;
}

bool CPlaylistDlg::FileExists(CString fname)
{
	if(fname.Left(7).CompareNoCase("http://")==0||fname.Left(6).CompareNoCase("ftp://")==0) return true;
	CFileFind finder;
	if(finder.FindFile(fname))
	{
		finder.FindNextFile();
		return(finder.GetLength()>0);
	}
	else
		return false;
}

BOOL CPlaylistDlg::PreTranslateMessage(MSG* pMsg) 
{
	int q=TranslateAccelerator(m_hWnd,accel,pMsg);
	if(q>0)
	{
		return q;
	}
	else
		return CDialog::PreTranslateMessage(pMsg);
}

void CPlaylistDlg::Remove(bool RAll, bool FromDisk) 
{
	int q;
	if((q=m_playlistat.GetFirstSelected())==-1&&!RAll) return;
//	bool b=StopReadAll();
	int i=0;
	bool CurDeleted=false;
	while(i<m_playlistat.GetCount()&&m_playlistat.GetCount()>0)
		if(m_playlistat.GetSel(i)||RAll)
		{
			m_playlistat.DeleteString(i);
			if(i<pMainFrame->Current)pMainFrame->Current--;
			else if(i==pMainFrame->Current&&!CurDeleted) { CurDeleted=true;pMainFrame->m_Player.Close();}
			if(FromDisk)
			{
				::SetFileAttributes(pMainFrame->PlayList[i],::GetFileAttributes(pMainFrame->PlayList[i]) & !FILE_ATTRIBUTE_READONLY);
				::DeleteFile(pMainFrame->PlayList[i]);
			}
			pMainFrame->PlayList.RemoveAt(i);
			pMainFrame->PlayListAT.RemoveAt(i);
		} else i++;
	pMainFrame->PlayListLength=pMainFrame->PlayList.GetSize();
	if(CurDeleted)
	{
		pMainFrame->Current=0;
		if(pMainFrame->PlayListLength>0)
		{
			pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
			pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
		}
		else
		{
			CRect rect;
			if(MP3InfoDlg!=NULL)
			{
				MP3InfoDlg->SaveWindowPosAndDestroy();
			}
		}
		pMainFrame->UpdMBTR();
	}
	if(m_playlistat.SetSel(q,TRUE)==LB_ERR)
		m_playlistat.SetSel(q-1,TRUE);
//	if(b)ReadAllTags();
	ShowFileName();
	m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
}

void CPlaylistDlg::SortRec(bool fn,int d,int h)
{
	if(d>h)return;
	int i,j;
	CString str;

	i = h;
	j = d;

	str = (fn?pMainFrame->PlayList[((int) ((d+h) / 2))]:pMainFrame->PlayListAT[((int) ((d+h) / 2))]);

	do {
		if(fn)
		{
			for(;;)
			{
				if(pMainFrame->PlayList[j].Left(1+pMainFrame->PlayList[j].ReverseFind('/')+pMainFrame->PlayList[j].ReverseFind('\\')).Find(str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')))==0&&
				   pMainFrame->PlayList[j].Left(1+pMainFrame->PlayList[j].ReverseFind('/')+pMainFrame->PlayList[j].ReverseFind('\\')).GetLength()!=str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).GetLength())
				{
					j++; continue;
				} else
				{
					if(str.CompareNoCase(pMainFrame->PlayList[j])>0&&
						!(
							str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).Find(pMainFrame->PlayList[j].Left(1+pMainFrame->PlayList[j].ReverseFind('/')+pMainFrame->PlayList[j].ReverseFind('\\')))==0&&
							str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).GetLength()!=pMainFrame->PlayList[j].Left(1+pMainFrame->PlayList[j].ReverseFind('/')+pMainFrame->PlayList[j].ReverseFind('\\')).GetLength()					
						))
					{
						j++; continue;
					}
				}
				break;
			}
			for(;;)
			{
				if(str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).Find(pMainFrame->PlayList[i].Left(1+pMainFrame->PlayList[i].ReverseFind('/')+pMainFrame->PlayList[i].ReverseFind('\\')))==0&&
				   str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).GetLength()!=pMainFrame->PlayList[i].Left(1+pMainFrame->PlayList[i].ReverseFind('/')+pMainFrame->PlayList[i].ReverseFind('\\')).GetLength())
				{
					i--; continue;
				} else
				{
					if(pMainFrame->PlayList[i].CompareNoCase(str)>0&&
						!(
							pMainFrame->PlayList[i].Left(1+pMainFrame->PlayList[i].ReverseFind('/')+pMainFrame->PlayList[i].ReverseFind('\\')).Find(str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')))==0&&
							pMainFrame->PlayList[i].Left(1+pMainFrame->PlayList[i].ReverseFind('/')+pMainFrame->PlayList[i].ReverseFind('\\')).GetLength()!=str.Left(1+str.ReverseFind('/')+str.ReverseFind('\\')).GetLength()					
						))
					{
						i--; continue;
					}
				}
				break;
			}
		} else
		{
			while (pMainFrame->PlayListAT[j] < str) j++;
			while (pMainFrame->PlayListAT[i] > str) i--;
		}

		if ( i >= j ) {

			if ( i != j ) {
				CString zal;

				zal = pMainFrame->PlayList[i];
				pMainFrame->PlayList[i] = pMainFrame->PlayList[j];
				pMainFrame->PlayList[j] = zal;
				zal = pMainFrame->PlayListAT[i];
				pMainFrame->PlayListAT[i] = pMainFrame->PlayListAT[j];
				pMainFrame->PlayListAT[j] = zal;
				if(pMainFrame->Current==i) pMainFrame->Current=j;
				else if(pMainFrame->Current==j) pMainFrame->Current=i;
				int zj=m_playlistat.GetSel(i);
				int zk=m_playlistat.GetSel(j);
				m_playlistat.SetSel(i,zk);
				m_playlistat.SetSel(j,zj);
				if(m_playlistat.GetCaretIndex()==i) m_playlistat.SetCaretIndex(j,TRUE);
				else if(m_playlistat.GetCaretIndex()==j) m_playlistat.SetCaretIndex(i,TRUE);
			}

			i--;
			j++;
		}
	} while (j <= i);

	if (d < i) SortRec(fn,d,i);
	if (j < h) SortRec(fn,j,h);
}



void CPlaylistDlg::OnTracksRenamefiles() 
{
	int i=-1, tdi, curpos, plmode,j;
	if(m_playlistat.GetFirstSelected()==-1) return;
	
	CRenameDlg dlg(IDD_RENAMER,this);
	dlg.m_template=pMainFrame->RNTemplate;
	
	if(dlg.DoModal()==IDOK)
	{
//		bool b=StopReadAll();

		pMainFrame->RNTemplate=dlg.m_template;
		
		CFile mpfile;

		CString track, artist, title, album, fname, albtrack;

		char buf[31];
		while((i=m_playlistat.GetFirstSelected(i+1))>-1)
		{
			if(mpfile.Open(pMainFrame->PlayList[i],CFile::modeRead | CFile::shareDenyNone))
			{
				track.Format("%02d",i+1);
				int b,e;
				pMainFrame->GetAlbumRange(&b,&e,true,i);
				albtrack.Format("%02d",i-b+1);

				if(mpfile.GetLength()<129)
				{
					mpfile.Close();
					title="Track"+albtrack;
					artist="Unknown artist";
					album="Unknown album";
					goto jump;
				}
				mpfile.Seek(-128,CFile::end);
				mpfile.Read(buf,3);buf[3]='\0';
				if(strcmp(buf,"TAG"))
				{
					mpfile.Close();
					title="Track"+albtrack;
					artist="Unknown artist";
					album="Unknown album";
					goto jump;
				}
				if(mpfile.Read(buf,30))
				{
					buf[30]='\0';
					title=buf;
					title.TrimRight();
					if(title=="")
						title="Track"+albtrack;
				}
				if(mpfile.Read(buf,30))
				{
					buf[30]='\0';
					artist=buf;
					artist.TrimRight();
					if(artist=="")
						artist="Unknown artist";
				}
				if(mpfile.Read(buf,30))
				{
					buf[30]='\0';
					album=buf;
					album.TrimRight();
					if(album=="")
						album="Unknown album";
				}
				mpfile.Close();

jump:

				fname=pMainFrame->RNTemplate;
				fname.Replace("%1",track);
				fname.Replace("%2",artist);
				fname.Replace("%3",title);
				fname.Replace("%4",album);
				fname.Replace("%5",albtrack);
				
				j=pMainFrame->PlayList[i].ReverseFind('.');
				if(j>=0)
					fname+=pMainFrame->PlayList[i].Mid(j);

				fname.Replace('\\','_');
				fname.Replace('/','_');
				fname.Replace(':','_');
				fname.Replace('*','_');
				fname.Replace('?','_');
				fname.Replace('\"','_');
				fname.Replace('<','_');
				fname.Replace('>','_');
				fname.Replace('|','_');
				
				fname=pMainFrame->PlayList[i].Left(pMainFrame->PlayList[i].ReverseFind('\\')+1)+fname;

				if(i==pMainFrame->Current)
				{
					CString tmp=pMainFrame->PlayListAT[pMainFrame->Current].Mid(pMainFrame->PlayListAT[pMainFrame->Current].ReverseFind('(')+1);
					tmp=tmp.Left(tmp.GetLength()-1);

					tdi=atoi(tmp.Left(tmp.Find(':')))*60+
					    atoi(tmp.Mid(tmp.Find(':')+1));
					
					curpos=pMainFrame->m_Player.GetPos()/1000;

					plmode=pMainFrame->m_Player.PlayerMode();

					pMainFrame->m_Player.Close();
				}
			
				if(::MoveFile(pMainFrame->PlayList[i],fname))
				{
					pMainFrame->PlayList[i]=fname;
//					pMainFrame->UpdateTagCache(pMainFrame->PlayList[i],pMainFrame->PlayListAT[i]);
				}

				if(i==pMainFrame->Current)
				{
					pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
					pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
					if(plmode==pmPlaying||plmode==pmPaused)
					{
						pMainFrame->m_Player.InitStream();
						pMainFrame->SetOut();
						pMainFrame->m_Player.Play();
						if(tdi!=0)
							pMainFrame->m_Player.SetPos(100*curpos/tdi);
						if(plmode==pmPaused)
							pMainFrame->m_Player.Pause();
					}
				}
			}
//			if(b) ReadAllTags();
		}
		ShowFileName();
		pMainFrame->UpdMBTR();
	}
}

void CPlaylistDlg::OnTracksFilemanagementDelete() 
{
	if(MessageBox(MyLoadString(IDS_DELETEFILE),"STP", MB_YESNO | MB_ICONEXCLAMATION | MB_DEFBUTTON2)==IDYES)
		Remove(false,true);
}

void CPlaylistDlg::OnTracksFilemanagementCopyto() 
{
	LPMALLOC pMalloc;
	if (SHGetMalloc (&pMalloc)!= NOERROR)
		return;

	BROWSEINFO bi;
	char buf[MAX_PATH];

	CString title;
	title=MyLoadString(IDS_TARGETFOLDER);

	bi.hwndOwner=m_hWnd;
	bi.pszDisplayName=buf;
	bi.pidlRoot=NULL;
	bi.lpszTitle=LPCTSTR(title);
	bi.ulFlags=BIF_RETURNONLYFSDIRS;
	bi.lpfn=BrowseCallbackProc;

	LPITEMIDLIST pidl;
	if((pidl=SHBrowseForFolder(&bi))==NULL)
	{
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	if(SHGetPathFromIDList(pidl,buf)==false)
	{	
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	pMalloc->Free(pidl);
	pMalloc->Release();

	CString theDir=buf;
	if(theDir[theDir.GetLength()-1]!='\\')
		theDir+="\\";

	pMainFrame->InitDir=theDir;

//	bool b=StopReadAll();

	CDialog dlg;
	dlg.Create(IDD_PROGRESS, this);
	CRect rect1,rect2;
	GetWindowRect(&rect1);
	dlg.GetWindowRect(&rect2);
	dlg.SetWindowPos(NULL,rect1.left+(rect1.right-rect1.left-(rect2.right-rect2.left))/2,rect1.top+(rect1.bottom-rect1.top-(rect2.bottom-rect2.top))/2,0,0,SWP_NOSIZE | SWP_NOZORDER);
	dlg.ShowWindow(SW_SHOW);
	dlg.UpdateWindow();

	((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->SetRange(0,m_playlistat.GetSelCount());
	((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->SetStep(1);

	CString srcfile,targetfile;
	int i=-1;
	while((i=m_playlistat.GetFirstSelected(i+1))>-1)
	{
		srcfile=pMainFrame->PlayList[i];
		targetfile=theDir+srcfile.Mid(srcfile.ReverseFind('\\')+1);
		dlg.SetDlgItemText(IDC_FNAME,srcfile.Mid(srcfile.ReverseFind('\\')+1));
		if(FileExists(targetfile))
		{
			if(dlg.MessageBox(MyLoadString(IDS_OVERWRITE)+"\n"+targetfile+"?","STP", MB_YESNO | MB_ICONEXCLAMATION | MB_DEFBUTTON2)==IDYES)
			{
				::SetFileAttributes(targetfile,::GetFileAttributes(targetfile) & !FILE_ATTRIBUTE_READONLY);
				::DeleteFile(targetfile);
				CopyFile(srcfile,targetfile,TRUE);
			}
		} else CopyFile(srcfile,targetfile,TRUE);
		((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->StepIt();
	}
//	if(b) ReadAllTags();

}

void CPlaylistDlg::OnTracksFilemanagementMoveto() 
{
	LPMALLOC pMalloc;
	if (SHGetMalloc (&pMalloc)!= NOERROR)
		return;

	BROWSEINFO bi;
	char buf[MAX_PATH];

	CString title;
	title=MyLoadString(IDS_TARGETFOLDER);

	bi.hwndOwner=m_hWnd;
	bi.pszDisplayName=buf;
	bi.pidlRoot=NULL;
	bi.lpszTitle=LPCTSTR(title);
	bi.ulFlags=BIF_RETURNONLYFSDIRS;
	bi.lpfn=BrowseCallbackProc;

	LPITEMIDLIST pidl;
	if((pidl=SHBrowseForFolder(&bi))==NULL)
	{
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	if(SHGetPathFromIDList(pidl,buf)==false)
	{	
		pMalloc->Free(pidl);
		pMalloc ->Release();
		return;
	}
	pMalloc->Free(pidl);
	pMalloc->Release();

	CString theDir=buf;
	if(theDir[theDir.GetLength()-1]!='\\')
		theDir+="\\";

	pMainFrame->InitDir=theDir;

//	bool b=StopReadAll();

	CDialog dlg;
	dlg.Create(IDD_PROGRESS, this);
	CRect rect1,rect2;
	GetWindowRect(&rect1);
	dlg.GetWindowRect(&rect2);
	dlg.SetWindowPos(NULL,rect1.left+(rect1.right-rect1.left-(rect2.right-rect2.left))/2,rect1.top+(rect1.bottom-rect1.top-(rect2.bottom-rect2.top))/2,0,0,SWP_NOSIZE | SWP_NOZORDER);
	dlg.ShowWindow(SW_SHOW);
	dlg.UpdateWindow();

	((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->SetRange(0,m_playlistat.GetSelCount());
	((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->SetStep(1);

	CString srcfile,targetfile;
	int i=-1, tdi, curpos, plmode;
	while((i=m_playlistat.GetFirstSelected(i+1))>-1)
	{
		srcfile=pMainFrame->PlayList[i];
		targetfile=theDir+srcfile.Mid(srcfile.ReverseFind('\\')+1);
		dlg.SetDlgItemText(IDC_FNAME,srcfile.Mid(srcfile.ReverseFind('\\')+1));
		if(FileExists(targetfile))
		{
			if(dlg.MessageBox(MyLoadString(IDS_OVERWRITE)+"\n"+targetfile+"?","STP", MB_YESNO | MB_ICONEXCLAMATION | MB_DEFBUTTON2)==IDYES)
			{
				::SetFileAttributes(targetfile,::GetFileAttributes(targetfile) & !FILE_ATTRIBUTE_READONLY);
				::DeleteFile(targetfile);
				if(i==pMainFrame->Current)
				{
					CString tmp=pMainFrame->PlayListAT[pMainFrame->Current].Mid(pMainFrame->PlayListAT[pMainFrame->Current].ReverseFind('(')+1);
					tmp=tmp.Left(tmp.GetLength()-1);

					tdi=atoi(tmp.Left(tmp.Find(':')))*60+
						atoi(tmp.Mid(tmp.Find(':')+1));
					
					curpos=pMainFrame->m_Player.GetPos()/1000;

					plmode=pMainFrame->m_Player.PlayerMode();

					pMainFrame->m_Player.Close();
				}
			
				if(MoveFile(srcfile,targetfile))
				{
					pMainFrame->PlayList[i]=targetfile;
//					pMainFrame->UpdateTagCache(pMainFrame->PlayList[i],pMainFrame->PlayListAT[i]);
				}

				if(i==pMainFrame->Current)
				{
					pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
					pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
					if(plmode==pmPlaying||plmode==pmPaused)
					{
						pMainFrame->m_Player.InitStream();
						pMainFrame->SetOut();
						pMainFrame->m_Player.Play();
						if(tdi!=0)
							pMainFrame->m_Player.SetPos(100*curpos/tdi);
						if(plmode==pmPaused)
							pMainFrame->m_Player.Pause();
					}
				}
			}
		} else 
		{
			if(i==pMainFrame->Current)
			{
				CString tmp=pMainFrame->PlayListAT[pMainFrame->Current].Mid(pMainFrame->PlayListAT[pMainFrame->Current].ReverseFind('(')+1);
				tmp=tmp.Left(tmp.GetLength()-1);

				tdi=atoi(tmp.Left(tmp.Find(':')))*60+
					atoi(tmp.Mid(tmp.Find(':')+1));
				
				curpos=pMainFrame->m_Player.GetPos()/1000;

				plmode=pMainFrame->m_Player.PlayerMode();

				pMainFrame->m_Player.Close();
			}
		
			if(MoveFile(srcfile,targetfile))
			{
				pMainFrame->PlayList[i]=targetfile;
//				pMainFrame->UpdateTagCache(pMainFrame->PlayList[i],pMainFrame->PlayListAT[i]);
			}

			if(i==pMainFrame->Current)
			{
				pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
				pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
				if(plmode==pmPlaying||plmode==pmPaused)
				{
					pMainFrame->m_Player.InitStream();
					pMainFrame->SetOut();
					pMainFrame->m_Player.Play();
					if(tdi!=0)
						pMainFrame->m_Player.SetPos(100*curpos/tdi);
					if(plmode==pmPaused)
						pMainFrame->m_Player.Pause();
				}
			}
		}
		((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->StepIt();
	}
//	if(b) ReadAllTags();
	ShowFileName();
}
