// SettingsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "SettingsDialog.h"
#include "MainWnd.h"
#include "SeekDialog.h"
#include "Hotkeys.h"
#include "Unexact.h"
#include "W2File.h"
#include "volume.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CInternetSession* mysession;
extern void InitInetSession();

extern int ADevice, MDevice;
extern CVolume* pVolume;

extern int BuffersType;
extern int InputBuffersType;
extern int ForceMono;
extern int Downsampling;

extern CSysTrayPlayApp theApp;
extern CMainWnd* pMainFrame;
extern CSeekDialog* SeekDialog;
extern CSettingsDialog *SettingsDialog;
//extern CCDBar *CDBar;

static int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	CString dir;
	SettingsDialog->m_c_wav.GetWindowText(dir);
	if(dir.Right(1)=="\\")
		dir=dir.Left(dir.GetLength()-1);

	if (uMsg == BFFM_INITIALIZED)
		::SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)LPCTSTR(dir));
	return 0;
}


BOOL DeleteKeyAndSubKeys
(
    HKEY    hkIn,
    LPSTR   pszSubKey
)
{
    HKEY  hk;
    char  szTmp[MAX_PATH];
    long  l;
    BOOL  f;

    l = RegOpenKeyEx(hkIn, pszSubKey, 0, KEY_ALL_ACCESS, &hk);
    if (l != ERROR_SUCCESS) return FALSE;

    f = TRUE;
    while (f) {
        l = RegEnumKey(hk, 0, szTmp, MAX_PATH);
        if (l != ERROR_SUCCESS) break;
        f = DeleteKeyAndSubKeys(hk, szTmp);
    }

    RegCloseKey(hk);
    l = RegDeleteKey(hkIn, pszSubKey);

    return (l == ERROR_SUCCESS) ? TRUE : FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// CSettingsDialog dialog


CSettingsDialog::CSettingsDialog(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CSettingsDialog)
	m_wav = _T("");
	m_towav = FALSE;
	m_noclicks = FALSE;
	m_email = _T("");
	m_cddb = _T("");
	m_forcemono = FALSE;
	m_ds12 = FALSE;
	m_ds14 = FALSE;
	m_gap = 0;
	m_autocddb = FALSE;
//	m_tpc = 0;
	//}}AFX_DATA_INIT
}


void CSettingsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsDialog)
	DDX_Control(pDX, IDC_MDEVICE, m_mdevice);
	DDX_Control(pDX, IDC_CLICKSR4, m_clicksr4);
	DDX_Control(pDX, IDC_CLICKSR3, m_clicksr3);
	DDX_Control(pDX, IDC_CLICKSR2, m_clicksr2);
	DDX_Control(pDX, IDC_CLICKSR1, m_clicksr1);
	DDX_Control(pDX, IDC_CLICKS4, m_clicks4);
	DDX_Control(pDX, IDC_CLICKS3, m_clicks3);
	DDX_Control(pDX, IDC_CLICKS2, m_clicks2);
	DDX_Control(pDX, IDC_CLICKS1, m_clicks1);
	DDX_Control(pDX, IDC_IBUFFERS, m_ibuffers);
	DDX_Control(pDX, IDC_ADEVICE, m_adevice);
	DDX_Control(pDX, IDC_DS14, m_c_ds14);
	DDX_Control(pDX, IDC_DS12, m_c_ds12);
	DDX_Control(pDX, IDC_BUFFERS, m_buffers);
	DDX_Control(pDX, IDC_PANDH, m_pandh);
	DDX_Control(pDX, IDC_CDDRIVE, m_cddrive);
	DDX_Control(pDX, IDC_NOCLICKS, m_c_noclicks);
	DDX_Control(pDX, IDC_PRIORITY, m_priority);
	DDX_Control(pDX, IDC_TOWAV, m_c_towav);
	DDX_Control(pDX, IDC_EWAV, m_c_wav);
	DDX_Text(pDX, IDC_EWAV, m_wav);
	DDX_Check(pDX, IDC_TOWAV, m_towav);
	DDX_Check(pDX, IDC_NOCLICKS, m_noclicks);
	DDX_Text(pDX, IDC_EMAIL, m_email);
	DDX_Text(pDX, IDC_CDDB, m_cddb);
	DDX_Check(pDX, IDC_MONO, m_forcemono);
	DDX_Check(pDX, IDC_DS12, m_ds12);
	DDX_Check(pDX, IDC_DS14, m_ds14);
	DDX_Text(pDX, IDC_GAP, m_gap);
	DDX_Check(pDX, IDC_AUTOCDDB, m_autocddb);
///	DDX_Text(pDX, IDC_TPC, m_tpc);
	DDX_Control(pDX, IDC_L_OPTIONS, m_l_options);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsDialog, CDialog)
	//{{AFX_MSG_MAP(CSettingsDialog)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_TOWAV, OnTowav)
	ON_BN_CLICKED(IDC_DS12, OnDs12)
	ON_BN_CLICKED(IDC_DS14, OnDs14)
	ON_BN_CLICKED(IDC_HOTKEYS, OnHotkeys)
//	ON_BN_CLICKED(IDC_SKIN, OnSkin)
//	ON_COMMAND(ID_POPUP_LOAD, OnPopupLoad)
//	ON_COMMAND(ID_POPUP_USEDEFAULT, OnPopupUsedefault)
	ON_BN_CLICKED(IDC_FT_WAV, OnFtWav)
	ON_BN_CLICKED(IDC_NOCLICKS, OnNoclicks)
	ON_BN_CLICKED(IDC_W2F, OnW2f)
	ON_BN_CLICKED(IDC_QUERY, OnQuery)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialog message handlers

BOOL CSettingsDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(pMainFrame->StpIcon, TRUE);
	SetIcon(pMainFrame->StpIconSm, FALSE);

	//SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE);

	CString buf;

	m_cddrive.EnableWindow(FALSE);
    for (char c='A';c<='Z';c++)
	{
		buf.Format("%c",c);
		if (GetDriveType(buf+":\\")==DRIVE_CDROM)
		{
			m_cddrive.AddString(buf);
			if(buf==pMainFrame->CDLetter)
				m_cddrive.SetCurSel(m_cddrive.GetCount()-1);
			m_cddrive.EnableWindow(TRUE);
		}
	}

	WAVEOUTCAPS woc;
	m_adevice.AddString("Wave Mapper");
	for (UINT u = 0; u<::waveOutGetNumDevs(); u++)
	{
		::waveOutGetDevCaps(u, &woc,sizeof(WAVEOUTCAPS));
		m_adevice.AddString(woc.szPname);
	}
	m_adevice.SetCurSel(ADevice==WAVE_MAPPER?0:ADevice+1);

	MIXERCAPS mc;
	for (u = 0; u<::mixerGetNumDevs(); u++)
	{
		::mixerGetDevCaps(u, &mc,sizeof(MIXERCAPS));
		m_mdevice.AddString(mc.szPname);
	}
	m_mdevice.SetCurSel(MDevice);

	m_pandh.AddString(MyLoadString(IDS_PANDH1R));
	m_pandh.AddString(MyLoadString(IDS_PANDH2R));
	m_pandh.AddString(MyLoadString(IDS_PANDH3R));

	switch(pMainFrame->PressAndHold)
	{
	case 2:
		m_pandh.SetCurSel(0);
		break;
	case 0:
		m_pandh.SetCurSel(1);
		break;
	case 1:
		m_pandh.SetCurSel(2);
		break;
	}


	m_l_options.AddString("  ");
	m_l_options.AddString("  ");
	m_l_options.AddString("  ");
	m_l_options.AddString(" WAV  . ");
	m_l_options.AddString(" Winamp");
	m_l_options.AddString(" ");


	m_l_options.SetCheck(0,pMainFrame->SMTracks);
	m_l_options.SetCheck(1,pMainFrame->SMAlbum);
	m_l_options.SetCheck(2,pMainFrame->AutoPlay);
	m_l_options.SetCheck(3,pMainFrame->IncludeWAVs);
	m_l_options.SetCheck(4,pMainFrame->WAEmu);
	m_l_options.SetCheck(5,pMainFrame->JeltiySeek);

	m_wav=pMainFrame->OutPath;

	m_towav=(pMainFrame->OutputModule==0);
	
	((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN))->SetRange(0,10000);
//	((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN2))->SetRange(0,100);

	m_gap=pMainFrame->GapBtwTracks;
	
//	m_tpc=pMainFrame->TPC;

	m_autocddb=(pMainFrame->AutoCDDB==1);

	m_forcemono=(ForceMono==1);

	m_ds12=(Downsampling==1);
	m_ds14=(Downsampling==2);

	m_noclicks=(pMainFrame->NoClicks==1);

	m_buffers.SetRange(0,4);
	m_buffers.SetLineSize(1);
	m_buffers.SetPageSize(1);
	m_buffers.SetPos(BuffersType);

	m_ibuffers.SetRange(0,4);
	m_ibuffers.SetLineSize(1);
	m_ibuffers.SetPageSize(1);
	m_ibuffers.SetPos(InputBuffersType);

	m_priority.SetRange(0,4);
	m_priority.SetLineSize(1);
	m_priority.SetPageSize(1);
	m_priority.SetPos(pMainFrame->PlayerPriority-1);

	m_cddb=pMainFrame->CDDBServer;
	m_email=pMainFrame->EMailAddress;

	FillClicksPopup(&m_clicks1, pMainFrame->Clicks1);
	FillClicksPopup(&m_clicks2, pMainFrame->Clicks2);
	FillClicksPopup(&m_clicks3, pMainFrame->Clicks3);
	FillClicksPopup(&m_clicks4, pMainFrame->Clicks4);

	FillClicksPopup(&m_clicksr1, pMainFrame->RClicks1);
	FillClicksPopup(&m_clicksr2, pMainFrame->RClicks2);
	FillClicksPopup(&m_clicksr3, pMainFrame->RClicks3);
	FillClicksPopup(&m_clicksr4, pMainFrame->RClicks4);

	m_clicks1.EnableWindow(!m_noclicks);
	m_clicks2.EnableWindow(!m_noclicks);
	m_clicks3.EnableWindow(!m_noclicks);
	m_clicks4.EnableWindow(!m_noclicks);
	m_clicksr1.EnableWindow(!m_noclicks);
	m_clicksr2.EnableWindow(!m_noclicks);
	m_clicksr3.EnableWindow(!m_noclicks);
	m_clicksr4.EnableWindow(!m_noclicks);
	m_pandh.EnableWindow(!m_noclicks);

	ReadFileTypes();
	ReadContMenus();
	
	UpdateData(false);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDialog::OnOK() 
{
	if(!UpdateData(true)) return;

	if(!CheckClicks())
	{
		MessageBox(MyLoadString(IDS_WRONGCLICKS),"STP",MB_OK | MB_ICONERROR);
		return;
	}

	CString buf;

	switch(m_pandh.GetCurSel())
	{
	case 0:
		pMainFrame->PressAndHold=2;
		break;
	case 1:
		pMainFrame->PressAndHold=0;
		break;
	case 2:
		pMainFrame->PressAndHold=1;
		break;
	}

	m_cddrive.GetLBText(m_cddrive.GetCurSel(),buf);
	if(buf!=pMainFrame->CDLetter&&pMainFrame->CDMode)
	{
		pMainFrame->CDStatus=CDSTOPPED;
		mciSendString("stop stp",NULL,0,NULL);
		mciSendString("close stp",NULL,0,NULL);
		pMainFrame->CDOpenString="open "+buf+": type cdaudio shareable alias stp";
		mciSendString(pMainFrame->CDOpenString,NULL,0,NULL);
		mciSendString("set stp time format tmsf",NULL,0,NULL);
		pMainFrame->nid.hIcon=pMainFrame->StopIcon;
		strcpy(pMainFrame->nid.szTip,"STP CD");

		if(pMainFrame->IconShown)Shell_NotifyIcon(NIM_MODIFY,&pMainFrame->nid);
	}
	pMainFrame->CDLetter=buf;

	
	if(m_adevice.GetCurSel()==0)
		ADevice=WAVE_MAPPER;
	else
		ADevice=m_adevice.GetCurSel()-1;

	int MDeviceold=MDevice;
	MDevice=m_mdevice.GetCurSel();
	if(MDeviceold!=MDevice)
	{
		if(pVolume!=NULL) delete pVolume;
		pVolume = new CVolume(pMainFrame->CDMode?1:0);
	}

	pMainFrame->SMTracks=			m_l_options.GetCheck(0);
	pMainFrame->SMAlbum=			m_l_options.GetCheck(1);
	pMainFrame->AutoPlay=			m_l_options.GetCheck(2);
	pMainFrame->IncludeWAVs=		m_l_options.GetCheck(3);
	pMainFrame->WAEmu=				m_l_options.GetCheck(4);
	pMainFrame->JeltiySeek=			m_l_options.GetCheck(5);



	pMainFrame->AutoCDDB=m_autocddb?1:0;

	pMainFrame->OutputModule=m_towav?0:1;
	pMainFrame->OutPath=m_wav;

	pMainFrame->GapBtwTracks=m_gap;

	pMainFrame->NoClicks=m_noclicks?1:0;

	ForceMono=m_forcemono?1:0;

	Downsampling=m_ds12?1:(m_ds14?2:0);

	BuffersType=m_buffers.GetPos();

	InputBuffersType=m_ibuffers.GetPos();

	pMainFrame->PlayerPriority=m_priority.GetPos()+1;
	switch(pMainFrame->PlayerPriority)
	{
		case 1:
			pMainFrame->m_Player.SetPriority(THREAD_PRIORITY_LOWEST);
			break;
		case 2:
			pMainFrame->m_Player.SetPriority(THREAD_PRIORITY_BELOW_NORMAL);
			break;
		case 3:
			pMainFrame->m_Player.SetPriority(THREAD_PRIORITY_NORMAL);
			break;
		case 4:
			pMainFrame->m_Player.SetPriority(THREAD_PRIORITY_ABOVE_NORMAL);
			break;
		case 5:
			pMainFrame->m_Player.SetPriority(THREAD_PRIORITY_HIGHEST);
			break;
	}

	if(pMainFrame->WAEmu==1)
	{
		pMainFrame->StartWAEmu();
	} else
	{
		pMainFrame->EndWAEmu();
	}

	pMainFrame->CDDBServer=m_cddb;
	pMainFrame->EMailAddress=m_email;

	pMainFrame->Clicks1=GetClicks(&m_clicks1);
	pMainFrame->Clicks2=GetClicks(&m_clicks2);
	pMainFrame->Clicks3=GetClicks(&m_clicks3);
	pMainFrame->Clicks4=GetClicks(&m_clicks4);
	pMainFrame->RClicks1=GetClicks(&m_clicksr1);
	pMainFrame->RClicks2=GetClicks(&m_clicksr2);
	pMainFrame->RClicks3=GetClicks(&m_clicksr3);
	pMainFrame->RClicks4=GetClicks(&m_clicksr4);

	RegFileTypes();
	CreateContMenus();

	DestroyWindow();
	SettingsDialog=NULL;	
}

void CSettingsDialog::OnCancel() 
{
	DestroyWindow();
	SettingsDialog=NULL;	
}

void CSettingsDialog::OnClose() 
{
	DestroyWindow();
	SettingsDialog=NULL;	
}

void CSettingsDialog::OnTowav() 
{
	if(m_c_towav.GetCheck()==1)
	{
		LPMALLOC pMalloc;
		if (SHGetMalloc (&pMalloc)!= NOERROR)
		{
			m_c_towav.SetCheck(0);
			return;
		}

		BROWSEINFO bi;
		char buf[MAX_PATH];

		CString title;
		title=MyLoadString(IDS_OPENFOLDER2);

		bi.hwndOwner=m_hWnd;
		bi.pszDisplayName=buf;
		bi.pidlRoot=NULL;
		bi.lpszTitle=LPCTSTR(title);
		bi.ulFlags=BIF_RETURNONLYFSDIRS;
		bi.lpfn=BrowseCallbackProc;

		LPITEMIDLIST pidl;
		if((pidl=SHBrowseForFolder(&bi))==NULL)
		{
			pMalloc->Free(pidl);
			pMalloc ->Release();
			m_c_towav.SetCheck(0);
			return;
		}
		if(SHGetPathFromIDList(pidl,buf)==false)
		{	
			pMalloc->Free(pidl);
			pMalloc ->Release();
			m_c_towav.SetCheck(0);
			return;
		}
		pMalloc->Free(pidl);
		pMalloc->Release();

		CString theDir=buf;
		if(theDir[theDir.GetLength()-1]!='\\')
			theDir+="\\";
		m_c_wav.SetWindowText(theDir);
	}	
}

void CSettingsDialog::OnDs12() 
{
	m_c_ds14.SetCheck(0);	
}

void CSettingsDialog::OnDs14() 
{
	m_c_ds12.SetCheck(0);
}

void CSettingsDialog::OnHotkeys() 
{
	CHotkeys dlg(IDD_HOTKEYSR);
	dlg.DoModal();
}

void CSettingsDialog::ReadContMenus()
{
	HKEY q;	
	unsigned long z, mp;

	bool PrevPlay=true, PrevAdd=true;

	char fname[MAX_PATH+1];
	GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
	CString mFile = "\"";
	mFile+=fname;
	mFile+="\" \"%1\"";

	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "Directory\\Shell\\Play\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(mFile.CompareNoCase(fname)!=0)
				PrevPlay=false;
		} else PrevPlay=false;
		RegCloseKey(q);
	} else PrevPlay=false;

	GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
	mFile = "\"";
	mFile+=fname;
	mFile+="\" %1";
	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "Drive\\Shell\\Play\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(mFile.CompareNoCase(fname)!=0)
				PrevPlay=false;
		} else PrevPlay=false;
		RegCloseKey(q);
	} else PrevPlay=false;

	GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
	mFile = "\"";
	mFile+=fname;
	mFile+="\" \"%1\"";
	mFile+=" -a";
	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "Directory\\Shell\\Add\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(mFile.CompareNoCase(fname)!=0)
				PrevAdd=false;
		} else PrevAdd=false;
		RegCloseKey(q);
	} else PrevAdd=false;

	GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
	mFile = "\"";
	mFile+=fname;
	mFile+="\" %1";
	mFile+=" -a";
	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "Drive\\Shell\\Add\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(mFile.CompareNoCase(fname)!=0)
				PrevAdd=false;
		} else PrevAdd=false;
		RegCloseKey(q);
	} else PrevAdd=false;

	if(PrevPlay)
		((CButton*)GetDlgItem(IDC_CM_PLAY))->SetCheck(1);
	if(PrevAdd)
		((CButton*)GetDlgItem(IDC_CM_ADD))->SetCheck(1);
}

void CSettingsDialog::CreateContMenus()
{
	DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT,"Directory\\Shell\\Play");
	DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT,"Directory\\Shell\\Add");
	DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT,"Drive\\Shell\\Play");
	DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT,"Drive\\Shell\\Add");

	HKEY q;
	CString buf;

	char fname[MAX_PATH+1];
	GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH);

	if(((CButton*)GetDlgItem(IDC_CM_PLAY))->GetCheck()==1)
	{
		RegCreateKey(HKEY_CLASSES_ROOT, "Directory\\Shell\\Play",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Play with STP",sizeof("Play with STP"));
		RegCloseKey(q);
		RegCreateKey(HKEY_CLASSES_ROOT, "Directory\\Shell\\Play\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" \"%1\"";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "Drive\\Shell\\Play",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Play with STP",sizeof("Play with STP"));
		RegCloseKey(q);
		RegCreateKey(HKEY_CLASSES_ROOT, "Drive\\Shell\\Play\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" %1";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);
	}
	if(((CButton*)GetDlgItem(IDC_CM_ADD))->GetCheck()==1)
	{
		RegCreateKey(HKEY_CLASSES_ROOT, "Directory\\Shell\\Add",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Add to playlist",sizeof("Add to playlist"));
		RegCloseKey(q);
		RegCreateKey(HKEY_CLASSES_ROOT, "Directory\\Shell\\Add\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" \"%1\"";
		buf+=" -a";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "Drive\\Shell\\Add",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Add to playlist",sizeof("Add to playlist"));
		RegCloseKey(q);
		RegCreateKey(HKEY_CLASSES_ROOT, "Drive\\Shell\\Add\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" %1";
		buf+=" -a";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);
	}
}

void CSettingsDialog::RegFileTypes()
{
	char fname[MAX_PATH+1];
	GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH);
	bool enqdef=(((CButton*)GetDlgItem(IDC_ADDBYDEF))->GetCheck()==1);

	unsigned long z=REG_SZ;
	unsigned long mp=MAX_PATH;
	
	HKEY q;
	CString buf;
	
	DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT,"STPMP3");
	DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT,"STPM3U");
	DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT,"STPWAV");


// MP3, M3U, PLS
	if(((CButton*)GetDlgItem(IDC_FT_MP3))->GetCheck()==1)
	{	
		RegCreateKey(HKEY_CLASSES_ROOT, ".mp3", &q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"STPMP3",sizeof("STPMP3"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPMP3",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"MP3 audio",sizeof("MP3 audio"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPMP3\\DefaultIcon",&q);
		buf=fname;
		buf+=",1";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);
		
		RegCreateKey(HKEY_CLASSES_ROOT, "STPMP3\\Shell",&q);
		if(enqdef)
		{
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Add",sizeof("Add"));
		} else
		{
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Open",sizeof("Open"));		
		}
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPMP3\\Shell\\Open",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Open",sizeof("Open"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPMP3\\Shell\\Open\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" \"%1\"";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPMP3\\Shell\\Add",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Add to playlist",sizeof("Add to playlist"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPMP3\\Shell\\Add\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" \"%1\"";
		buf+=" -a";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);
		

		RegCreateKey(HKEY_CLASSES_ROOT, ".m3u", &q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"STPM3U",sizeof("STPM3U"));
		RegCloseKey(q);
		
		RegCreateKey(HKEY_CLASSES_ROOT, ".pls", &q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"STPM3U",sizeof("STPM3U"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"M3U playlist",sizeof("M3U playlist"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\DefaultIcon",&q);
		buf=fname;
		buf+=",2";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell",&q);
		if(enqdef)
		{
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Add",sizeof("Add"));
		} else
		{
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Open",sizeof("Open"));
		}
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Open",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Open",sizeof("Open"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Open\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" \"%1\"";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);
		RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Add",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Add to playlist",sizeof("Add to playlist"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Add\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" \"%1\"";
		buf+=" -a";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);

	} else
	{
		if(PrevMP3)
		{
			RegCreateKey(HKEY_CLASSES_ROOT, ".mp3", &q);
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"",0);
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, ".m3u", &q);
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"",0);
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, ".pls", &q);
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"",0);
			RegCloseKey(q);
		}
	}

// WAV
	if(((CButton*)GetDlgItem(IDC_FT_WAV))->GetCheck()==1)
	{
		RegCreateKey(HKEY_CLASSES_ROOT, ".wav", &q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"STPMP3",sizeof("STPMP3"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Riff WAV MP3 audio",sizeof("Riff WAV MP3 audio"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\DefaultIcon",&q);
		buf=fname;
		buf+=",1";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell",&q);
		if(enqdef)
		{
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Add",sizeof("Add"));
		} else
		{
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Open",sizeof("Open"));
		}
		RegCloseKey(q);
		
		RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell\\Open",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Open",sizeof("Open"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell\\Open\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" \"%1\"";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell\\Add",&q);
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"Add to playlist",sizeof("Add to playlist"));
		RegCloseKey(q);

		RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell\\Add\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" \"%1\"";
		buf+=" -a";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);
	} else
	{
		if(PrevWAV)
		{
			RegCreateKey(HKEY_CLASSES_ROOT, ".wav", &q);
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)"",0);
			RegCloseKey(q);
		}
	}

// CD
	if(((CButton*)GetDlgItem(IDC_FT_CD))->GetCheck()==1)
	{
		RegCreateKey(HKEY_CLASSES_ROOT, "AudioCD\\Shell\\Play\\Command",&q);
		buf=fname;
		buf="\""+buf+"\"";
		buf+=" -c";
		RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
		RegCloseKey(q);
	} else
	{
		if(PrevCD)
		{
			RegCreateKey(HKEY_CLASSES_ROOT, "AudioCD\\Shell\\Play\\Command",&q);
			buf="cdplayer.exe /play %1";
			RegSetValueEx(q,"",0,REG_SZ,(const unsigned char *)LPCTSTR(buf),buf.GetLength()+1);
			RegCloseKey(q);
		}
	}
}

void CSettingsDialog::ReadFileTypes()
{
	char fname[MAX_PATH+1];
	GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
	CString mFile = "\"";
	mFile+=fname;
	mFile+="\" -c";

	HKEY q;
	unsigned long z;
	unsigned long mp; 

	PrevCD=PrevMP3=PrevWAV=false;

	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "AudioCD\\Shell\\Play\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(mFile.CompareNoCase(fname)==0)
			{
				((CButton*)GetDlgItem(IDC_FT_CD))->SetCheck(1);
				PrevCD=true;
			}
		}
		RegCloseKey(q);
	}

	int qq=0;
	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, ".mp3",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(strcmp(fname,"STPMP3")==0)
				qq++;
		}
		RegCloseKey(q);
	}

	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, ".m3u",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(strcmp(fname,"STPM3U")==0)
				qq++;
		}
		RegCloseKey(q);
	}

	if(qq==2)
	{
		PrevMP3=true;
	}

	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, ".wav",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(strcmp(fname,"STPMP3")==0)
			{
				PrevWAV=true;
			}
		}
		RegCloseKey(q);
	}

	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "STPMP3\\Shell",0,KEY_READ,&q)==ERROR_SUCCESS)
	{
		z=REG_SZ;mp=MAX_PATH;
		if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
		{
			if(strcmp(fname,"Add")==0)
				((CButton*)GetDlgItem(IDC_ADDBYDEF))->SetCheck(1);
		}
		RegCloseKey(q);
	}

	GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
	mFile = "\"";
	mFile+=fname;
	mFile+="\" \"%1\"";

	if(PrevMP3||PrevWAV)
	{
		if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "STPMP3\\Shell\\Open\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
		{
			z=REG_SZ;mp=MAX_PATH;
			if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
			{
				if(mFile.CompareNoCase(fname)!=0)
					PrevMP3=PrevWAV=false;
			} else
			{
				PrevMP3=PrevWAV=false;
			}
			RegCloseKey(q);
		} else
		{
			PrevMP3=PrevWAV=false;		
		}

		if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Open\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
		{
			z=REG_SZ;mp=MAX_PATH;
			if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
			{
				if(mFile.CompareNoCase(fname)!=0)
					PrevMP3=PrevWAV=false;
			} else
			{
				PrevMP3=PrevWAV=false;
			}
			RegCloseKey(q);
		} else
		{
			PrevMP3=false;		
		}

		mFile+=" -a";
		if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "STPMP3\\Shell\\Add\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
		{
			z=REG_SZ;mp=MAX_PATH;
			if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
			{
				if(mFile.CompareNoCase(fname)!=0)
					PrevMP3=PrevWAV=false;
			} else
			{
				PrevMP3=PrevWAV=false;
			}
			RegCloseKey(q);
		} else
		{
			PrevMP3=PrevWAV=false;		
		}

		if(RegOpenKeyEx(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Add\\Command",0,KEY_READ,&q)==ERROR_SUCCESS)
		{
			z=REG_SZ;mp=MAX_PATH;
			if(RegQueryValueEx(q,"",NULL,&z,(LPBYTE)fname,&mp)==ERROR_SUCCESS)
			{
				if(mFile.CompareNoCase(fname)!=0)
					PrevMP3=PrevWAV=false;
			} else
			{
				PrevMP3=PrevWAV=false;
			}
			RegCloseKey(q);
		} else
		{
			PrevMP3=false;		
		}
	}

	if(PrevMP3)
	{
		((CButton*)GetDlgItem(IDC_FT_MP3))->SetCheck(1);
	}

	if(PrevWAV)
	{
		((CButton*)GetDlgItem(IDC_FT_WAV))->SetCheck(1);
	}
}





void CSettingsDialog::OnFtWav() 
{
	if(((CButton*)GetDlgItem(IDC_FT_WAV))->GetCheck()==1)
	{
		MessageBox(MyLoadString(IDS_ABOUTWAVS),"STP",MB_OK | MB_ICONWARNING);
	}
}

void CSettingsDialog::OnNoclicks() 
{
	m_clicks1.EnableWindow(!m_c_noclicks.GetCheck());
	m_clicks2.EnableWindow(!m_c_noclicks.GetCheck());
	m_clicks3.EnableWindow(!m_c_noclicks.GetCheck());
	m_clicks4.EnableWindow(!m_c_noclicks.GetCheck());
	m_clicksr1.EnableWindow(!m_c_noclicks.GetCheck());
	m_clicksr2.EnableWindow(!m_c_noclicks.GetCheck());
	m_clicksr3.EnableWindow(!m_c_noclicks.GetCheck());
	m_clicksr4.EnableWindow(!m_c_noclicks.GetCheck());
	m_pandh.EnableWindow(!m_c_noclicks.GetCheck());
}

void CSettingsDialog::FillClicksPopup(CComboBox *cb, int clicks)
{
	int i; CString buf;
	cb->AddString(MyLoadString(IDS_CLICKS0));
	cb->AddString(MyLoadString(IDS_CLICKS1));
	cb->AddString(MyLoadString(IDS_CLICKS2));
	cb->AddString(MyLoadString(IDS_CLICKS3));
	cb->AddString(MyLoadString(IDS_CLICKS4));
	cb->AddString(MyLoadString(IDS_CLICKS5));
	cb->AddString(MyLoadString(IDS_CLICKS11));
	cb->AddString(MyLoadString(IDS_CLICKS6));
	cb->AddString(MyLoadString(IDS_CLICKS7));
	cb->AddString(MyLoadString(IDS_CLICKS8));
	cb->AddString(MyLoadString(IDS_CLICKS9));
	cb->AddString(MyLoadString(IDS_CLICKS10));
	for(i=0;i<cb->GetCount();i++)
	{
		cb->GetLBText(i,buf);
		if(buf==MyLoadString(IDS_CLICKS0+clicks))
		{
			cb->SetCurSel(i);
			break;
		}
	}
}

bool CSettingsDialog::CheckClicks()
{
	CString buf, buf1=MyLoadString(IDS_CLICKS10);

	m_clicks1.GetLBText(m_clicks1.GetCurSel(), buf);
	if(buf==buf1) return true;
	m_clicks2.GetLBText(m_clicks2.GetCurSel(), buf);
	if(buf==buf1) return true;
	m_clicks3.GetLBText(m_clicks3.GetCurSel(), buf);
	if(buf==buf1) return true;
	m_clicks4.GetLBText(m_clicks4.GetCurSel(), buf);
	if(buf==buf1) return true;

	m_clicksr1.GetLBText(m_clicksr1.GetCurSel(), buf);
	if(buf==buf1) return true;
	m_clicksr2.GetLBText(m_clicksr2.GetCurSel(), buf);
	if(buf==buf1) return true;
	m_clicksr3.GetLBText(m_clicksr3.GetCurSel(), buf);
	if(buf==buf1) return true;
	m_clicksr4.GetLBText(m_clicksr4.GetCurSel(), buf);
	if(buf==buf1) return true;

	return false;
}

int CSettingsDialog::GetClicks(CComboBox *cb)
{
	CString buf;
	cb->GetLBText(cb->GetCurSel(), buf);
	for(int i=0;i<cb->GetCount();i++)
	{
		if(buf==MyLoadString(IDS_CLICKS0+i))
		{
			return i;
		}
	}
	return 0;
}

void CSettingsDialog::OnW2f() 
{
	CW2File dlg(IDD_W2FILER);
	dlg.DoModal();	
}

void CSettingsDialog::OnQuery() 
{
	CString url,email;

	email=pMainFrame->EMailAddress;
	email.Replace("@","+");

	CString buf,buf1;

	try
	{
		url="http://freedb.freedb.org/~cddb/cddb.cgi?cmd=sites";
		url+="&hello=";
		url+=email;
		url+="+STP+";
		url+="FINAL";
		url+="&proto=4";

		if(mysession==NULL)
			InitInetSession();

		CStdioFile *remotefile = mysession->OpenURL(url,1,INTERNET_FLAG_TRANSFER_ASCII | INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE);
		if(remotefile==NULL)
		{
			pMainFrame->MessageBox(MyLoadString(IDS_SITESFAILED),"STP",MB_OK | MB_ICONERROR);
			return;
		}
		if(remotefile->ReadString(buf))
		{
			if(buf.Left(3)=="210")
			{
				CUnexact dlg(IDD_CDUNEXACTR);
				for(;;)
				{
					remotefile->ReadString(buf);
					if(buf!=".")
					{
						buf1="http://"+buf.Left(buf.Find(' '));
						buf=buf.Mid(buf.Find(' ')+1);
						if(buf.Left(buf.Find(' '))=="http")
						{
							buf=buf.Mid(buf.Find(' ')+1);
							buf1+=":"+buf.Left(buf.Find(' '));
							buf=buf.Mid(buf.Find(' ')+1);
							buf1+=buf.Left(buf.Find(' '));
							buf=buf.Mid(buf.Find(' ')+1);
							buf=buf.Mid(buf.Find(' ')+1);
							buf=buf.Mid(buf.Find(' ')+1);
							buf1+=" - "+buf;
							dlg.matches.Add(buf1);
						}
					}
					else
						break;
				}
				if(dlg.DoModal()==IDOK)
					SetDlgItemText(IDC_CDDB, dlg.matches[dlg.match].Left(dlg.matches[dlg.match].Find(' ')));
			} else
			{
				pMainFrame->MessageBox(MyLoadString(IDS_SITESFAILED),"STP",MB_OK | MB_ICONERROR);
				return;
			}
		} else
		{
			pMainFrame->MessageBox(MyLoadString(IDS_SITESFAILED),"STP",MB_OK | MB_ICONERROR);
			return;
		}
	}
	catch(...)
	{
		pMainFrame->MessageBox(MyLoadString(IDS_SITESFAILED),"STP",MB_OK | MB_ICONERROR);
		return;
	}
	
}
