// SysTrayPlay.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "EqualizerDlg.h"
#include "mainwnd.h"
#include "SeekDialog.h"
#include "MP3InfoDlg.h"
#include "PlaylistDlg.h"
#include "WAEmuWnd.h"
#include "SearcherDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSeekDialog *SeekDialog;
extern CMP3InfoDlg *MP3InfoDlg;
extern CPlaylistDlg *PlaylistDlg;
extern CWAEmuWnd *WAEmuWnd;

CInternetSession* mysession=NULL;
HINTERNET m_hInternetSession=NULL;

extern bool IfAdd(CString s1, CString s2);
extern bool IfCD(CString s1, CString s2);

void InitInetSession()
{
	mysession=new CInternetSession();
	m_hInternetSession=HINTERNET(*mysession);
}

/////////////////////////////////////////////////////////////////////////////
// CSysTrayPlayApp

BEGIN_MESSAGE_MAP(CSysTrayPlayApp, CWinApp)
	//{{AFX_MSG_MAP(CSysTrayPlayApp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSysTrayPlayApp construction

CSysTrayPlayApp::CSysTrayPlayApp()
{
	hMutex=NULL;

	char profname[MAX_PATH];

	GetModuleFileName(m_hInstance, profname, MAX_PATH);
	for(int i=strlen(profname)-1;i>0;i--)
		if(profname[i]=='.')
		{
			profname[i+1]='i';
			profname[i+2]='n';
			profname[i+3]='i';
			profname[i+4]='\0';
			break;
		}

	free((void*)m_pszProfileName);
	m_pszProfileName=strdup(profname);
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSysTrayPlayApp object

CSysTrayPlayApp theApp;
BOOL bClassRegistered = FALSE;
CMainWnd* pMainFrame;

/////////////////////////////////////////////////////////////////////////////
// CSysTrayPlayApp initialization

BOOL CSysTrayPlayApp::InitInstance()
{
	hMutex = CreateMutex( NULL, FALSE, "STPAppClass");

	if ( GetLastError() == ERROR_ALREADY_EXISTS )
	{
		struct CmdLineStruct {
			CString fname;
			bool AddFlag;
			bool CDFlag;
			bool ExitFlag;
		} CmdLine;
		CmdLine.fname="";
		CmdLine.AddFlag=false;
		CmdLine.CDFlag=false;
		CmdLine.ExitFlag=false;

		for (int i = 1; i < __argc; i++)
		{
			LPCTSTR pszParam = __targv[i];
			BOOL bFlag = FALSE;
			if (pszParam[0] == '-')
			{
				// remove flag specifier
				bFlag = TRUE;
				pszParam++;
			}
			if(bFlag)
			{
				if (lstrcmpA(pszParam, "a") == 0)
					CmdLine.AddFlag=true;
				else if (lstrcmpA(pszParam, "c") == 0)
					CmdLine.CDFlag=true;
				else if (lstrcmpA(pszParam, "x") == 0)
					CmdLine.ExitFlag=true;
			} else
			{
				if(CmdLine.fname=="") CmdLine.fname=pszParam;
			}
		}

		if(CmdLine.fname!=""||CmdLine.CDFlag||CmdLine.ExitFlag)
		{
			HWND hPrevWnd;
			if(CmdLine.ExitFlag)
			{
				if((hPrevWnd=::FindWindow("STPAppClass",NULL))!=NULL)
					::SendMessage ( hPrevWnd, WM_COMMAND, (WPARAM) ID_POPUPMENU_EXIT, (LPARAM) NULL );
			} else
			{
				MsgCmd cmd;
				COPYDATASTRUCT cds;
				cds.dwData = 0;
				cds.cbData = sizeof(cmd);
				cds.lpData = &cmd;
				if(CmdLine.fname!="")
				{
					if(CmdLine.AddFlag) cmd.command=1; else cmd.command=0;
					strcpy(cmd.fname,LPCTSTR(CmdLine.fname));
				} else cmd.command=2;
				for(i=0;i<50;i++)
				{
					if((hPrevWnd=::FindWindow("STPAppClass",NULL))!=NULL)
						if(::SendMessage ( hPrevWnd, WM_COPYDATA, (WPARAM) NULL, (LPARAM) &cds )) break;
					Sleep(100);
				}
			}
		}
		return FALSE;
	}    

	WNDCLASS wndcls;
	memset(&wndcls, 0, sizeof(WNDCLASS));

	wndcls.lpfnWndProc = ::DefWindowProc;
	wndcls.hInstance = AfxGetInstanceHandle();
	wndcls.hIcon = LoadIcon(IDI_STP);
	wndcls.hCursor = LoadCursor( IDC_ARROW );
	wndcls.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wndcls.lpszMenuName = NULL;

	wndcls.lpszClassName = "STPAppClass";

	if(!AfxRegisterClass(&wndcls))
			return FALSE;
	bClassRegistered = TRUE;

	pMainFrame = new CMainWnd;

	pMainFrame->Create("STPAppClass","STP");

	m_pMainWnd = pMainFrame;

	return TRUE;
}

int CSysTrayPlayApp::ExitInstance() 
{
    // Release mutex
	if ( hMutex != NULL ) {
		ReleaseMutex( hMutex );
	}

    // Release the wndclass name
    if(bClassRegistered)
        ::UnregisterClass("STPAppClass",AfxGetInstanceHandle());
	
	if(mysession!=NULL)
		delete mysession;

	return CWinApp::ExitInstance();
}
