// TagEditor.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "TagEditor.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;
extern CStringArray genres;

/////////////////////////////////////////////////////////////////////////////
// CTagEditor dialog


CTagEditor::CTagEditor(UINT id, CWnd* pParent /*=NULL*/)
: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CTagEditor)
	m_genre = -1;
	m_album = _T("");
	m_artist = _T("");
	m_comment = _T("");
	m_filename = _T("");
	m_title = _T("");
	m_year = _T("");
	m_keep1 = FALSE;
	m_keep2 = FALSE;
	m_keep3 = FALSE;
	m_keep4 = FALSE;
	m_keep5 = FALSE;
	m_keep6 = FALSE;
	//}}AFX_DATA_INIT
}


void CTagEditor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTagEditor)
	DDX_Control(pDX, IDC_COMBO_GENRE, m_c_genre);
	DDX_Control(pDX, IDC_EDIT_TITLE, m_c_title);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_c_comment);
	DDX_Control(pDX, IDC_EDIT_ARTIST, m_c_artist);
	DDX_Control(pDX, IDC_EDIT_ALBUM, m_c_album);
	DDX_Control(pDX, IDC_EDIT_YEAR, m_c_year);
	DDX_CBIndex(pDX, IDC_COMBO_GENRE, m_genre);
	DDX_Text(pDX, IDC_EDIT_ALBUM, m_album);
	DDX_Text(pDX, IDC_EDIT_ARTIST, m_artist);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_comment);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_filename);
	DDX_Text(pDX, IDC_EDIT_TITLE, m_title);
	DDX_Text(pDX, IDC_EDIT_YEAR, m_year);
	DDX_Check(pDX, IDC_KEEP1, m_keep1);
	DDX_Check(pDX, IDC_KEEP2, m_keep2);
	DDX_Check(pDX, IDC_KEEP3, m_keep3);
	DDX_Check(pDX, IDC_KEEP4, m_keep4);
	DDX_Check(pDX, IDC_KEEP5, m_keep5);
	DDX_Check(pDX, IDC_KEEP6, m_keep6);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTagEditor, CDialog)
	//{{AFX_MSG_MAP(CTagEditor)
	ON_BN_CLICKED(IDC_REMOVE_TAG, OnRemoveTag)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTagEditor message handlers

void CTagEditor::OnOK() 
{
	UpdateData(true);
	DWORD attrs=::GetFileAttributes(m_filename);
	::SetFileAttributes(m_filename, attrs & !FILE_ATTRIBUTE_READONLY);
	CFile mpfile;
	if(mpfile.Open(m_filename,CFile::modeReadWrite | CFile::shareDenyNone))
	{
		TRY
		{
			
		char buf[31];
		if(mpfile.GetLength()>128)
		{
			mpfile.Seek(-128,CFile::end);

			buf[30]='\0';
			mpfile.Read(buf,3);buf[3]='\0';
			if(strcmp(buf,"TAG")!=0)
			{
				mpfile.SeekToEnd();
				strcpy(buf,"TAG");
				mpfile.Write(buf,3);
			}
		}
		else
		{
			mpfile.SeekToEnd();
			strcpy(buf,"TAG");
			mpfile.Write(buf,3);
		}
		
		m_title+="                                ";
		mpfile.Write(LPCTSTR(m_title),30);

		m_artist+="                                ";
		mpfile.Write(LPCTSTR(m_artist),30);

		m_album+="                                ";
		mpfile.Write(LPCTSTR(m_album),30);

		m_year+="     ";
		mpfile.Write(LPCTSTR(m_year),4);

		m_comment+="                                ";
		mpfile.Write(LPCTSTR(m_comment),30);

		if(m_genre>0)
		{
			m_c_genre.GetLBText(m_genre,buf);
			CString buf2;
			buf2=buf;
			for(int i=0;i<genres.GetSize();i++)
				if(genres[i]==buf2)
				{
					buf[0]=(char)i;
					break;
				}
		} else buf[0]=-1;
		mpfile.Write(buf,1);
		} CATCH( CFileException, e ) {};
		END_CATCH
		mpfile.Close();
	}
	::SetFileAttributes(m_filename, attrs);
	
	CDialog::OnOK();
}

BOOL CTagEditor::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_c_genre.AddString("");
	for(int i=0;i<genres.GetSize();i++)
		m_c_genre.AddString(genres[i]);

	m_c_title.LimitText(30);
	m_c_artist.LimitText(30);
	m_c_album.LimitText(30);
	m_c_year.LimitText(4);
	m_c_comment.LimitText(30);

	ReadTag();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTagEditor::OnRemoveTag() 
{
	CFile mpfile;
	DWORD attrs=::GetFileAttributes(m_filename);
	::SetFileAttributes(m_filename, attrs & !FILE_ATTRIBUTE_READONLY);
	if(mpfile.Open(m_filename,CFile::modeReadWrite | CFile::shareDenyNone))
	{
		TRY
		{
		UpdateData(true);
		
		if(mpfile.GetLength()<129)
		{
			mpfile.Close();
			return;
		}
		mpfile.Seek(-128,CFile::end);

		char buf[31];
		buf[30]='\0';
		mpfile.Read(buf,3);buf[3]='\0';
		if(strcmp(buf,"TAG")==0)
		{
			mpfile.SetLength(mpfile.GetLength()-128);
		}
		} CATCH( CFileException, e ) {};
		END_CATCH
		mpfile.Close();
	}
	::SetFileAttributes(m_filename, attrs);

	CDialog::OnOK();
}

void CTagEditor::ReadTag()
{
	if(!m_keep1)
		m_title="";
	if(!m_keep2)
		m_artist="";
	if(!m_keep3)
		m_album="";
	if(!m_keep4)
		m_year="";
	if(!m_keep5)
		m_comment="";
	if(!m_keep6)
		m_genre=0;

	CString theTitle=m_filename;
	int i;
	i=theTitle.ReverseFind('.');
	if(i==-1)i=theTitle.GetLength()-1;
	theTitle=theTitle.Left(i);

	i=theTitle.ReverseFind('\\');
	theTitle=theTitle.Mid(i+1);

	if(theTitle.GetLength()>30) theTitle=theTitle.Left(30);
	theTitle.Replace('_',' ');

	CFile mpfile;
	if(!mpfile.Open(m_filename,CFile::modeRead | CFile::shareDenyNone))
	{
		if(((CButton*)GetDlgItem(IDC_KEEP1))->GetCheck()==0)
			m_title=theTitle;
		UpdateData(false);
		return;
	}

	if(mpfile.GetLength()<129)
	{
		mpfile.Close();
		if(!m_keep1)
			m_title=theTitle;
		UpdateData(false);
		return;
	}

	mpfile.Seek(-128,CFile::end);

	char buf[31];
	mpfile.Read(buf,3);buf[3]='\0';
	if(strcmp(buf,"TAG"))
	{
		mpfile.Close();
		if(!m_keep1)
			m_title=theTitle;
		UpdateData(false);
		return;
	}

	if(mpfile.Read(buf,30))
	{
		buf[30]='\0';
		if(!m_keep1)
			m_title=buf;
		m_title.TrimRight();
	}
	if(mpfile.Read(buf,30))
	{
		buf[30]='\0';
		if(!m_keep2)
			m_artist=buf;
		m_artist.TrimRight();
	}
	if(mpfile.Read(buf,30))
	{
		buf[30]='\0';
		if(!m_keep3)
			m_album=buf;
		m_album.TrimRight();
	}
	if(mpfile.Read(buf,4))
	{
		buf[4]='\0';
		if(!m_keep4)
			m_year=buf;
		m_year.TrimRight();
	}
	if(mpfile.Read(buf,30))
	{
		buf[30]='\0';
		if(!m_keep5)
			m_comment=buf;
		m_comment.TrimRight();
	}
	
	if(mpfile.Read(buf,1))
	{
		int genre=buf[0];

		if((unsigned char)buf[0]<148)
		{
			int q;
			if((q=m_c_genre.FindStringExact(-1,genres[(unsigned char)buf[0]]))!=CB_ERR)
				if(!m_keep6)
					m_genre=q;
		}
	}

	mpfile.Close();

	UpdateData(FALSE);
}
