// W2File.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "W2File.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;

/////////////////////////////////////////////////////////////////////////////
// CW2File dialog


CW2File::CW2File(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CW2File)
	m_del = FALSE;
	m_exit = _T("");
	m_file = _T("");
	m_oem = FALSE;
	m_pause = _T("");
	m_play = _T("");
	m_stop = _T("");
	m_enabled = FALSE;
	//}}AFX_DATA_INIT
}


void CW2File::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CW2File)
	DDX_Check(pDX, IDC_DELONEXIT, m_del);
	DDX_Text(pDX, IDC_EXIT, m_exit);
	DDX_Text(pDX, IDC_FILE, m_file);
	DDX_Check(pDX, IDC_OEM, m_oem);
	DDX_Text(pDX, IDC_PAUSE, m_pause);
	DDX_Text(pDX, IDC_PLAY, m_play);
	DDX_Text(pDX, IDC_STOP, m_stop);
	DDX_Check(pDX, IDC_ENABLE, m_enabled);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CW2File, CDialog)
	//{{AFX_MSG_MAP(CW2File)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CW2File message handlers

BOOL CW2File::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_file=pMainFrame->W2Ffile;
	m_play=pMainFrame->W2Fplay;
	m_pause=pMainFrame->W2Fpause;
	m_stop=pMainFrame->W2Fstop;
	m_exit=pMainFrame->W2Fexit;
	m_oem=pMainFrame->W2Foem;
	m_del=pMainFrame->W2Fdel;
	m_enabled=pMainFrame->W2Fenabled;

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CW2File::OnOK() 
{
	UpdateData(TRUE);

	pMainFrame->W2Ffile=m_file;
	pMainFrame->W2Fplay=m_play;
	pMainFrame->W2Fpause=m_pause;
	pMainFrame->W2Fstop=m_stop;
	pMainFrame->W2Fexit=m_exit;
	pMainFrame->W2Foem=m_oem?1:0;
	pMainFrame->W2Fdel=m_del?1:0;
	pMainFrame->W2Fenabled=m_enabled?1:0;
	
	CDialog::OnOK();
}

void CW2File::OnBrowse() 
{
	CFileDialog dialog(FALSE, 
						"txt",
						"",
						OFN_HIDEREADONLY |
						OFN_OVERWRITEPROMPT,
						"Text files|*.txt|All files|*.*|");

	if (dialog.DoModal() == IDOK)
	{
		m_file=dialog.GetPathName();
		UpdateData(FALSE);
	}
}
